#ifndef Algorithm__H
#define Algorithm__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description DAE_Else_ELSE__desc;
extern struct record_description DAE_Else_ELSEIF__desc;
extern struct record_description DAE_Else_NOELSE__desc;
extern struct record_description DAE_Statement_STMT__ASSERT__desc;
extern struct record_description DAE_Statement_STMT__ASSIGN__desc;
extern struct record_description DAE_Statement_STMT__ASSIGN__ARR__desc;
extern struct record_description DAE_Statement_STMT__FOR__desc;
extern struct record_description DAE_Statement_STMT__IF__desc;
extern struct record_description DAE_Statement_STMT__PARFOR__desc;
extern struct record_description DAE_Statement_STMT__REINIT__desc;
extern struct record_description DAE_Statement_STMT__TERMINATE__desc;
extern struct record_description DAE_Statement_STMT__TUPLE__ASSIGN__desc;
extern struct record_description DAE_Statement_STMT__WHEN__desc;
extern struct record_description DAE_Statement_STMT__WHILE__desc;
extern struct record_description DAE_Type_T__BOOL__desc;
extern struct record_description DAE_Type_T__REAL__desc;
extern struct record_description DAE_Type_T__UNKNOWN__desc;
extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
typedef struct Algorithm_algorithmEmpty_rettype_s {
  modelica_boolean c1; /* empty */
} Algorithm_algorithmEmpty_rettype;
DLLExport
Algorithm_algorithmEmpty_rettype omc_Algorithm_algorithmEmpty(threadData_t *threadData, modelica_metatype _alg);
typedef struct Algorithm_algorithmEmpty_rettypeboxed_s {
  modelica_metatype c1; /* empty */
} Algorithm_algorithmEmpty_rettypeboxed;
DLLExport
Algorithm_algorithmEmpty_rettypeboxed boxptr_Algorithm_algorithmEmpty(threadData_t *threadData, modelica_metatype _alg);
typedef struct Algorithm_isReinitStatement_rettype_s {
  modelica_boolean c1; /* res */
} Algorithm_isReinitStatement_rettype;
DLLExport
Algorithm_isReinitStatement_rettype omc_Algorithm_isReinitStatement(threadData_t *threadData, modelica_metatype _stmt);
typedef struct Algorithm_isReinitStatement_rettypeboxed_s {
  modelica_metatype c1; /* res */
} Algorithm_isReinitStatement_rettypeboxed;
DLLExport
Algorithm_isReinitStatement_rettypeboxed boxptr_Algorithm_isReinitStatement(threadData_t *threadData, modelica_metatype _stmt);
typedef struct Algorithm_isNotAssertStatement_rettype_s {
  modelica_boolean c1; /* res */
} Algorithm_isNotAssertStatement_rettype;
DLLExport
Algorithm_isNotAssertStatement_rettype omc_Algorithm_isNotAssertStatement(threadData_t *threadData, modelica_metatype _stmt);
typedef struct Algorithm_isNotAssertStatement_rettypeboxed_s {
  modelica_metatype c1; /* res */
} Algorithm_isNotAssertStatement_rettypeboxed;
DLLExport
Algorithm_isNotAssertStatement_rettypeboxed boxptr_Algorithm_isNotAssertStatement(threadData_t *threadData, modelica_metatype _stmt);
typedef struct Algorithm_makeAssignment_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeAssignment_rettype;
DLLExport
Algorithm_makeAssignment_rettype omc_Algorithm_makeAssignment(threadData_t *threadData, modelica_metatype _inExp1, modelica_metatype _inProperties2, modelica_metatype _inExp3, modelica_metatype _inProperties4, modelica_metatype _inAttributes, modelica_metatype _initial_, modelica_metatype _source);
#define boxptr_Algorithm_makeAssignment omc_Algorithm_makeAssignment

typedef struct Algorithm_makeAssignment2_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeAssignment2_rettype;
DLLExport
Algorithm_makeAssignment2_rettype omc_Algorithm_makeAssignment2(threadData_t *threadData, modelica_metatype _lhs, modelica_metatype _lhprop, modelica_metatype _rhs, modelica_metatype _rhprop, modelica_metatype _source);
#define boxptr_Algorithm_makeAssignment2 omc_Algorithm_makeAssignment2

typedef struct Algorithm_makeAssignmentsList_rettype_s {
  modelica_metatype c1; /* assignments */
} Algorithm_makeAssignmentsList_rettype;
DLLExport
Algorithm_makeAssignmentsList_rettype omc_Algorithm_makeAssignmentsList(threadData_t *threadData, modelica_metatype _lhsExps, modelica_metatype _lhsProps, modelica_metatype _rhsExps, modelica_metatype _rhsProps, modelica_metatype _attributes, modelica_metatype _initial_, modelica_metatype _source);
#define boxptr_Algorithm_makeAssignmentsList omc_Algorithm_makeAssignmentsList

typedef struct Algorithm_makeTupleAssignment_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeTupleAssignment_rettype;
DLLExport
Algorithm_makeTupleAssignment_rettype omc_Algorithm_makeTupleAssignment(threadData_t *threadData, modelica_metatype _inExpExpLst, modelica_metatype _inTypesPropertiesLst, modelica_metatype _inExp, modelica_metatype _inProperties, modelica_metatype _initial_, modelica_metatype _source);
#define boxptr_Algorithm_makeTupleAssignment omc_Algorithm_makeTupleAssignment

typedef struct Algorithm_getPropExpType_rettype_s {
  modelica_metatype c1; /* t */
} Algorithm_getPropExpType_rettype;
DLLExport
Algorithm_getPropExpType_rettype omc_Algorithm_getPropExpType(threadData_t *threadData, modelica_metatype _p);
#define boxptr_Algorithm_getPropExpType omc_Algorithm_getPropExpType

typedef struct Algorithm_makeIf_rettype_s {
  modelica_metatype c1; /* outStatements */
} Algorithm_makeIf_rettype;
DLLExport
Algorithm_makeIf_rettype omc_Algorithm_makeIf(threadData_t *threadData, modelica_metatype _inExp1, modelica_metatype _inProperties2, modelica_metatype _inStatementLst3, modelica_metatype _inTplExpExpTypesPropertiesStatementLstLst4, modelica_metatype _inStatementLst5, modelica_metatype _source);
#define boxptr_Algorithm_makeIf omc_Algorithm_makeIf

typedef struct Algorithm_makeIfFromBranches_rettype_s {
  modelica_metatype c1; /* outStatements */
} Algorithm_makeIfFromBranches_rettype;
DLLExport
Algorithm_makeIfFromBranches_rettype omc_Algorithm_makeIfFromBranches(threadData_t *threadData, modelica_metatype _branches, modelica_metatype _source);
#define boxptr_Algorithm_makeIfFromBranches omc_Algorithm_makeIfFromBranches

typedef struct Algorithm_makeElseFromBranches_rettype_s {
  modelica_metatype c1; /* outElse */
} Algorithm_makeElseFromBranches_rettype;
DLLExport
Algorithm_makeElseFromBranches_rettype omc_Algorithm_makeElseFromBranches(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_Algorithm_makeElseFromBranches omc_Algorithm_makeElseFromBranches

typedef struct Algorithm_optimizeIf_rettype_s {
  modelica_metatype c1; /* ostmts */
} Algorithm_optimizeIf_rettype;
DLLExport
Algorithm_optimizeIf_rettype omc_Algorithm_optimizeIf(threadData_t *threadData, modelica_metatype _icond, modelica_metatype _istmts, modelica_metatype _iels, modelica_metatype _isource);
#define boxptr_Algorithm_optimizeIf omc_Algorithm_optimizeIf

typedef struct Algorithm_optimizeElseIf_rettype_s {
  modelica_metatype c1; /* oelse */
} Algorithm_optimizeElseIf_rettype;
DLLExport
Algorithm_optimizeElseIf_rettype omc_Algorithm_optimizeElseIf(threadData_t *threadData, modelica_metatype _cond, modelica_metatype _stmts, modelica_metatype _els);
#define boxptr_Algorithm_optimizeElseIf omc_Algorithm_optimizeElseIf

typedef struct Algorithm_makeElse_rettype_s {
  modelica_metatype c1; /* outElse */
} Algorithm_makeElse_rettype;
DLLExport
Algorithm_makeElse_rettype omc_Algorithm_makeElse(threadData_t *threadData, modelica_metatype _inTuple, modelica_metatype _inStatementLst, modelica_metatype _inSource);
#define boxptr_Algorithm_makeElse omc_Algorithm_makeElse

typedef struct Algorithm_makeFor_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeFor_rettype;
DLLExport
Algorithm_makeFor_rettype omc_Algorithm_makeFor(threadData_t *threadData, modelica_metatype _inIdent, modelica_metatype _inExp, modelica_metatype _inProperties, modelica_metatype _inStatementLst, modelica_metatype _source);
#define boxptr_Algorithm_makeFor omc_Algorithm_makeFor

typedef struct Algorithm_makeParFor_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeParFor_rettype;
DLLExport
Algorithm_makeParFor_rettype omc_Algorithm_makeParFor(threadData_t *threadData, modelica_metatype _inIdent, modelica_metatype _inExp, modelica_metatype _inProperties, modelica_metatype _inStatementLst, modelica_metatype _inLoopPrlVars, modelica_metatype _source);
#define boxptr_Algorithm_makeParFor omc_Algorithm_makeParFor

typedef struct Algorithm_makeWhile_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeWhile_rettype;
DLLExport
Algorithm_makeWhile_rettype omc_Algorithm_makeWhile(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inProperties, modelica_metatype _inStatementLst, modelica_metatype _source);
#define boxptr_Algorithm_makeWhile omc_Algorithm_makeWhile

typedef struct Algorithm_makeWhenA_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeWhenA_rettype;
DLLExport
Algorithm_makeWhenA_rettype omc_Algorithm_makeWhenA(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inProperties, modelica_metatype _inStatementLst, modelica_metatype _elseWhenStmt, modelica_metatype _source);
#define boxptr_Algorithm_makeWhenA omc_Algorithm_makeWhenA

typedef struct Algorithm_makeReinit_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeReinit_rettype;
DLLExport
Algorithm_makeReinit_rettype omc_Algorithm_makeReinit(threadData_t *threadData, modelica_metatype _inExp1, modelica_metatype _inExp2, modelica_metatype _inProperties3, modelica_metatype _inProperties4, modelica_metatype _source);
#define boxptr_Algorithm_makeReinit omc_Algorithm_makeReinit

typedef struct Algorithm_makeAssert_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeAssert_rettype;
DLLExport
Algorithm_makeAssert_rettype omc_Algorithm_makeAssert(threadData_t *threadData, modelica_metatype _cond, modelica_metatype _msg, modelica_metatype _level, modelica_metatype _inProperties3, modelica_metatype _inProperties4, modelica_metatype _inProperties5, modelica_metatype _source);
#define boxptr_Algorithm_makeAssert omc_Algorithm_makeAssert

typedef struct Algorithm_makeTerminate_rettype_s {
  modelica_metatype c1; /* outStatement */
} Algorithm_makeTerminate_rettype;
DLLExport
Algorithm_makeTerminate_rettype omc_Algorithm_makeTerminate(threadData_t *threadData, modelica_metatype _msg, modelica_metatype _props, modelica_metatype _source);
#define boxptr_Algorithm_makeTerminate omc_Algorithm_makeTerminate

typedef struct Algorithm_getCrefFromAlg_rettype_s {
  modelica_metatype c1; /* crs */
} Algorithm_getCrefFromAlg_rettype;
DLLExport
Algorithm_getCrefFromAlg_rettype omc_Algorithm_getCrefFromAlg(threadData_t *threadData, modelica_metatype _alg);
#define boxptr_Algorithm_getCrefFromAlg omc_Algorithm_getCrefFromAlg

typedef struct Algorithm_getAllExps_rettype_s {
  modelica_metatype c1; /* outExpExpLst */
} Algorithm_getAllExps_rettype;
DLLExport
Algorithm_getAllExps_rettype omc_Algorithm_getAllExps(threadData_t *threadData, modelica_metatype _inAlgorithm);
#define boxptr_Algorithm_getAllExps omc_Algorithm_getAllExps

typedef struct Algorithm_getAllExpsStmts_rettype_s {
  modelica_metatype c1; /* exps */
} Algorithm_getAllExpsStmts_rettype;
DLLExport
Algorithm_getAllExpsStmts_rettype omc_Algorithm_getAllExpsStmts(threadData_t *threadData, modelica_metatype _stmts);
#define boxptr_Algorithm_getAllExpsStmts omc_Algorithm_getAllExpsStmts

typedef struct Algorithm_getAllExpsStmtsCollector_rettype_s {
  modelica_metatype c1; /* otpl */
} Algorithm_getAllExpsStmtsCollector_rettype;
DLLExport
Algorithm_getAllExpsStmtsCollector_rettype omc_Algorithm_getAllExpsStmtsCollector(threadData_t *threadData, modelica_metatype _itpl);
#define boxptr_Algorithm_getAllExpsStmtsCollector omc_Algorithm_getAllExpsStmtsCollector

typedef struct Algorithm_getStatementSource_rettype_s {
  modelica_metatype c1; /* source */
} Algorithm_getStatementSource_rettype;
DLLExport
Algorithm_getStatementSource_rettype omc_Algorithm_getStatementSource(threadData_t *threadData, modelica_metatype _stmt);
#define boxptr_Algorithm_getStatementSource omc_Algorithm_getStatementSource

typedef struct Algorithm_getAssertCond_rettype_s {
  modelica_metatype c1; /* cond */
} Algorithm_getAssertCond_rettype;
DLLExport
Algorithm_getAssertCond_rettype omc_Algorithm_getAssertCond(threadData_t *threadData, modelica_metatype _stmt);
#define boxptr_Algorithm_getAssertCond omc_Algorithm_getAssertCond
#ifdef __cplusplus
extern "C" {
#endif
#include "Algorithm.h"
#include "ComponentReference.h"
#include "DAEUtil.h"
#include "Debug.h"
#include "Error.h"
#include "Expression.h"
#include "ExpressionDump.h"
#include "Flags.h"
#include "List.h"
#include "SCodeDump.h"
#include "Types.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

