#ifndef BackendDump__H
#define BackendDump__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Absyn_Info_INFO__desc;
extern struct record_description Absyn_TimeStamp_TIMESTAMP__desc;
extern struct record_description DAE_Algorithm_ALGORITHM__STMTS__desc;
extern struct record_description DAE_Constraint_CONSTRAINT__EXPS__desc;
extern struct record_description DAE_Element_ALGORITHM__desc;
extern struct record_description DAE_Element_CONSTRAINT__desc;
extern struct record_description DAE_ElementSource_SOURCE__desc;
extern struct record_description DAE_Exp_BINARY__desc;
extern struct record_description DAE_Operator_DIV__desc;
extern struct record_description DAE_Operator_DIV__ARRAY__SCALAR__desc;
extern struct record_description DAE_Operator_DIV__SCALAR__ARRAY__desc;
extern struct record_description DumpHTML_Tag_LINE__desc;
extern struct record_description Flags_ConfigFlag_CONFIG__FLAG__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description Flags_FlagData_STRING__FLAG__desc;
extern struct record_description Flags_FlagVisibility_EXTERNAL__desc;
extern struct record_description IOStream_IOStreamType_LIST__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;

DLLExport
void omc_BackendDump_printBackendDAE(threadData_t *threadData, modelica_metatype _inBackendDAE);
#define boxptr_BackendDump_printBackendDAE omc_BackendDump_printBackendDAE


DLLExport
void omc_BackendDump_printEqSystem(threadData_t *threadData, modelica_metatype _inEqSystem);
#define boxptr_BackendDump_printEqSystem omc_BackendDump_printEqSystem


DLLExport
void omc_BackendDump_printEquation(threadData_t *threadData, modelica_metatype _inEquation);
#define boxptr_BackendDump_printEquation omc_BackendDump_printEquation


DLLExport
void omc_BackendDump_printEquationArray(threadData_t *threadData, modelica_metatype _eqns);
#define boxptr_BackendDump_printEquationArray omc_BackendDump_printEquationArray


DLLExport
void omc_BackendDump_printEquationList(threadData_t *threadData, modelica_metatype _eqns);
#define boxptr_BackendDump_printEquationList omc_BackendDump_printEquationList

typedef struct BackendDump_printEquationList2_rettype_s {
  modelica_metatype c1; /* oInteger */
} BackendDump_printEquationList2_rettype;
DLLExport
BackendDump_printEquationList2_rettype omc_BackendDump_printEquationList2(threadData_t *threadData, modelica_metatype _inEquation, modelica_metatype _inInteger);
#define boxptr_BackendDump_printEquationList2 omc_BackendDump_printEquationList2


DLLExport
void omc_BackendDump_printEquations(threadData_t *threadData, modelica_metatype _inIntegerLst, modelica_metatype _syst);
#define boxptr_BackendDump_printEquations omc_BackendDump_printEquations


DLLExport
void omc_BackendDump_printEquationNo(threadData_t *threadData, modelica_integer _inInteger, modelica_metatype _syst);

DLLExport
void boxptr_BackendDump_printEquationNo(threadData_t *threadData, modelica_metatype _inInteger, modelica_metatype _syst);

DLLExport
void omc_BackendDump_printClassAttributes(threadData_t *threadData, modelica_metatype _optimicaFun);
#define boxptr_BackendDump_printClassAttributes omc_BackendDump_printClassAttributes


DLLExport
void omc_BackendDump_printShared(threadData_t *threadData, modelica_metatype _inShared);
#define boxptr_BackendDump_printShared omc_BackendDump_printShared


DLLExport
void omc_BackendDump_printBackendDAEType(threadData_t *threadData, modelica_metatype _btp);
#define boxptr_BackendDump_printBackendDAEType omc_BackendDump_printBackendDAEType


DLLExport
void omc_BackendDump_printStateSets(threadData_t *threadData, modelica_metatype _stateSets);
#define boxptr_BackendDump_printStateSets omc_BackendDump_printStateSets


DLLExport
void omc_BackendDump_printStateSet(threadData_t *threadData, modelica_metatype _statSet);
#define boxptr_BackendDump_printStateSet omc_BackendDump_printStateSet


DLLExport
void omc_BackendDump_printVar(threadData_t *threadData, modelica_metatype _inVar);
#define boxptr_BackendDump_printVar omc_BackendDump_printVar


DLLExport
void omc_BackendDump_printVariables(threadData_t *threadData, modelica_metatype _vars);
#define boxptr_BackendDump_printVariables omc_BackendDump_printVariables


DLLExport
void omc_BackendDump_printVarList(threadData_t *threadData, modelica_metatype _vars);
#define boxptr_BackendDump_printVarList omc_BackendDump_printVarList

typedef struct BackendDump_printVars1_rettype_s {
  modelica_integer c1; /* outVarNo */
} BackendDump_printVars1_rettype;
DLLExport
BackendDump_printVars1_rettype omc_BackendDump_printVars1(threadData_t *threadData, modelica_metatype _inVar, modelica_integer _inVarNo);
typedef struct BackendDump_printVars1_rettypeboxed_s {
  modelica_metatype c1; /* outVarNo */
} BackendDump_printVars1_rettypeboxed;
DLLExport
BackendDump_printVars1_rettypeboxed boxptr_BackendDump_printVars1(threadData_t *threadData, modelica_metatype _inVar, modelica_metatype _inVarNo);

DLLExport
void omc_BackendDump_printExternalObjectClasses(threadData_t *threadData, modelica_metatype _cls);
#define boxptr_BackendDump_printExternalObjectClasses omc_BackendDump_printExternalObjectClasses


DLLExport
void omc_BackendDump_printSparsityPattern(threadData_t *threadData, modelica_metatype _inPattern);
#define boxptr_BackendDump_printSparsityPattern omc_BackendDump_printSparsityPattern


DLLExport
void omc_BackendDump_dumpBackendDAE(threadData_t *threadData, modelica_metatype _inBackendDAE, modelica_metatype _heading);
#define boxptr_BackendDump_dumpBackendDAE omc_BackendDump_dumpBackendDAE


DLLExport
void omc_BackendDump_dumpEqSystem(threadData_t *threadData, modelica_metatype _inEqSystem, modelica_metatype _heading);
#define boxptr_BackendDump_dumpEqSystem omc_BackendDump_dumpEqSystem


DLLExport
void omc_BackendDump_dumpVariables(threadData_t *threadData, modelica_metatype _inVars, modelica_metatype _heading);
#define boxptr_BackendDump_dumpVariables omc_BackendDump_dumpVariables


DLLExport
void omc_BackendDump_dumpVarList(threadData_t *threadData, modelica_metatype _inVars, modelica_metatype _heading);
#define boxptr_BackendDump_dumpVarList omc_BackendDump_dumpVarList


DLLExport
void omc_BackendDump_dumpEquationArray(threadData_t *threadData, modelica_metatype _inEqns, modelica_metatype _heading);
#define boxptr_BackendDump_dumpEquationArray omc_BackendDump_dumpEquationArray


DLLExport
void omc_BackendDump_dumpEquationList(threadData_t *threadData, modelica_metatype _inEqns, modelica_metatype _heading);
#define boxptr_BackendDump_dumpEquationList omc_BackendDump_dumpEquationList


DLLExport
void omc_BackendDump_dumpExternalObjectClasses(threadData_t *threadData, modelica_metatype _inEOC, modelica_metatype _heading);
#define boxptr_BackendDump_dumpExternalObjectClasses omc_BackendDump_dumpExternalObjectClasses


DLLExport
void omc_BackendDump_dumpStateSets(threadData_t *threadData, modelica_metatype _stateSets, modelica_metatype _heading);
#define boxptr_BackendDump_dumpStateSets omc_BackendDump_dumpStateSets


DLLExport
void omc_BackendDump_dumpZeroCrossingList(threadData_t *threadData, modelica_metatype _inZeroCrossingList, modelica_metatype _heading);
#define boxptr_BackendDump_dumpZeroCrossingList omc_BackendDump_dumpZeroCrossingList


DLLExport
void omc_BackendDump_dumpWhenClauseList(threadData_t *threadData, modelica_metatype _inWhenClauseList, modelica_metatype _heading);
#define boxptr_BackendDump_dumpWhenClauseList omc_BackendDump_dumpWhenClauseList


DLLExport
void omc_BackendDump_dumpConstraintArray(threadData_t *threadData, modelica_metatype _inConstraintArray, modelica_metatype _heading);
#define boxptr_BackendDump_dumpConstraintArray omc_BackendDump_dumpConstraintArray


DLLExport
void omc_BackendDump_dumpHashSet(threadData_t *threadData, modelica_metatype _hashSet, modelica_metatype _heading);
#define boxptr_BackendDump_dumpHashSet omc_BackendDump_dumpHashSet


DLLExport
void omc_BackendDump_dumpSparsityPattern(threadData_t *threadData, modelica_metatype _inPattern, modelica_metatype _heading);
#define boxptr_BackendDump_dumpSparsityPattern omc_BackendDump_dumpSparsityPattern


DLLExport
void omc_BackendDump_dumpEquation(threadData_t *threadData, modelica_metatype _inEquation);
#define boxptr_BackendDump_dumpEquation omc_BackendDump_dumpEquation


DLLExport
void omc_BackendDump_dumpTearing(threadData_t *threadData, modelica_metatype _inResEqn, modelica_metatype _inTearVar);
#define boxptr_BackendDump_dumpTearing omc_BackendDump_dumpTearing


DLLExport
void omc_BackendDump_dumpBackendDAEEqnList(threadData_t *threadData, modelica_metatype _inBackendDAEEqnList, modelica_metatype _header, modelica_boolean _printExpTree);

DLLExport
void boxptr_BackendDump_dumpBackendDAEEqnList(threadData_t *threadData, modelica_metatype _inBackendDAEEqnList, modelica_metatype _header, modelica_metatype _printExpTree);

DLLExport
void omc_BackendDump_dumpBackendDAEEqnList2(threadData_t *threadData, modelica_metatype _inBackendDAEEqnList, modelica_boolean _printExpTree);

DLLExport
void boxptr_BackendDump_dumpBackendDAEEqnList2(threadData_t *threadData, modelica_metatype _inBackendDAEEqnList, modelica_metatype _printExpTree);

DLLExport
void omc_BackendDump_dumpBackendDAEVarList(threadData_t *threadData, modelica_metatype _inBackendDAEVarList, modelica_metatype _header);
#define boxptr_BackendDump_dumpBackendDAEVarList omc_BackendDump_dumpBackendDAEVarList


DLLExport
void omc_BackendDump_dumpEqnsSolved(threadData_t *threadData, modelica_metatype _inBackendDAE, modelica_metatype _heading);
#define boxptr_BackendDump_dumpEqnsSolved omc_BackendDump_dumpEqnsSolved


DLLExport
void omc_BackendDump_dumpEqnsSolved1(threadData_t *threadData, modelica_metatype _inEqSystem);
#define boxptr_BackendDump_dumpEqnsSolved1 omc_BackendDump_dumpEqnsSolved1


DLLExport
void omc_BackendDump_dumpEqnsSolved2(threadData_t *threadData, modelica_metatype _inComps, modelica_metatype _eqns, modelica_metatype _vars);
#define boxptr_BackendDump_dumpEqnsSolved2 omc_BackendDump_dumpEqnsSolved2


DLLExport
void omc_BackendDump_dumpComponentsAdvanced(threadData_t *threadData, modelica_metatype _l, modelica_metatype _v2, modelica_metatype _syst);
#define boxptr_BackendDump_dumpComponentsAdvanced omc_BackendDump_dumpComponentsAdvanced


DLLExport
void omc_BackendDump_dumpComponentsAdvanced2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_integer _inInteger, modelica_metatype _v2, modelica_metatype _vars);

DLLExport
void boxptr_BackendDump_dumpComponentsAdvanced2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_metatype _inInteger, modelica_metatype _v2, modelica_metatype _vars);

DLLExport
void omc_BackendDump_dumpComponentsAdvanced3(threadData_t *threadData, modelica_metatype _inIntegerLst, modelica_metatype _v2, modelica_metatype _vars);
#define boxptr_BackendDump_dumpComponentsAdvanced3 omc_BackendDump_dumpComponentsAdvanced3


DLLExport
void omc_BackendDump_dumpComponents(threadData_t *threadData, modelica_metatype _inComps);
#define boxptr_BackendDump_dumpComponents omc_BackendDump_dumpComponents


DLLExport
void omc_BackendDump_dumpComponent(threadData_t *threadData, modelica_metatype _inComp);
#define boxptr_BackendDump_dumpComponent omc_BackendDump_dumpComponent

typedef struct BackendDump_printComponent_rettype_s {
  modelica_metatype c1; /* oString */
} BackendDump_printComponent_rettype;
DLLExport
BackendDump_printComponent_rettype omc_BackendDump_printComponent(threadData_t *threadData, modelica_metatype _inComp);
#define boxptr_BackendDump_printComponent omc_BackendDump_printComponent

typedef struct BackendDump_strongComponentString_rettype_s {
  modelica_metatype c1; /* outS */
} BackendDump_strongComponentString_rettype;
DLLExport
BackendDump_strongComponentString_rettype omc_BackendDump_strongComponentString(threadData_t *threadData, modelica_metatype _inComp);
#define boxptr_BackendDump_strongComponentString omc_BackendDump_strongComponentString

typedef struct BackendDump_whenEquationString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_whenEquationString_rettype;
DLLExport
BackendDump_whenEquationString_rettype omc_BackendDump_whenEquationString(threadData_t *threadData, modelica_metatype _inWhenEqn);
#define boxptr_BackendDump_whenEquationString omc_BackendDump_whenEquationString

typedef struct BackendDump_equationString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_equationString_rettype;
DLLExport
BackendDump_equationString_rettype omc_BackendDump_equationString(threadData_t *threadData, modelica_metatype _inEquation);
#define boxptr_BackendDump_equationString omc_BackendDump_equationString

typedef struct BackendDump_zeroCrossingListString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_zeroCrossingListString_rettype;
DLLExport
BackendDump_zeroCrossingListString_rettype omc_BackendDump_zeroCrossingListString(threadData_t *threadData, modelica_metatype _inZeroCrossingList);
#define boxptr_BackendDump_zeroCrossingListString omc_BackendDump_zeroCrossingListString

typedef struct BackendDump_zeroCrossingString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_zeroCrossingString_rettype;
DLLExport
BackendDump_zeroCrossingString_rettype omc_BackendDump_zeroCrossingString(threadData_t *threadData, modelica_metatype _inZeroCrossing);
#define boxptr_BackendDump_zeroCrossingString omc_BackendDump_zeroCrossingString

typedef struct BackendDump_whenClauseListString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_whenClauseListString_rettype;
DLLExport
BackendDump_whenClauseListString_rettype omc_BackendDump_whenClauseListString(threadData_t *threadData, modelica_metatype _inWhenClauseList);
#define boxptr_BackendDump_whenClauseListString omc_BackendDump_whenClauseListString

typedef struct BackendDump_whenClauseString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_whenClauseString_rettype;
DLLExport
BackendDump_whenClauseString_rettype omc_BackendDump_whenClauseString(threadData_t *threadData, modelica_metatype _inWhenClause);
#define boxptr_BackendDump_whenClauseString omc_BackendDump_whenClauseString

typedef struct BackendDump_componentRef__DIVISION__String_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_componentRef__DIVISION__String_rettype;
DLLExport
BackendDump_componentRef__DIVISION__String_rettype omc_BackendDump_componentRef__DIVISION__String(threadData_t *threadData, modelica_metatype _inCref, modelica_integer _dummy);
typedef struct BackendDump_componentRef__DIVISION__String_rettypeboxed_s {
  modelica_metatype c1; /* outString */
} BackendDump_componentRef__DIVISION__String_rettypeboxed;
DLLExport
BackendDump_componentRef__DIVISION__String_rettypeboxed boxptr_BackendDump_componentRef__DIVISION__String(threadData_t *threadData, modelica_metatype _inCref, modelica_metatype _dummy);

DLLExport
void omc_BackendDump_debugStrCrefLstStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefLstStr omc_BackendDump_debugStrCrefLstStr


DLLExport
void omc_BackendDump_debugCrefStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugCrefStr omc_BackendDump_debugCrefStr


DLLExport
void omc_BackendDump_debugStrIntStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrIntStr omc_BackendDump_debugStrIntStr


DLLExport
void omc_BackendDump_debugStrIntStrIntStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrIntStrIntStr omc_BackendDump_debugStrIntStrIntStr


DLLExport
void omc_BackendDump_debugCrefStrIntStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugCrefStrIntStr omc_BackendDump_debugCrefStrIntStr


DLLExport
void omc_BackendDump_debugStrCrefStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefStr omc_BackendDump_debugStrCrefStr


DLLExport
void omc_BackendDump_debugStrCrefStrIntStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefStrIntStr omc_BackendDump_debugStrCrefStrIntStr


DLLExport
void omc_BackendDump_debugStrCrefStrRealStrRealStrRealStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefStrRealStrRealStrRealStr omc_BackendDump_debugStrCrefStrRealStrRealStrRealStr


DLLExport
void omc_BackendDump_debugStrRealStrRealStrRealStrRealStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrRealStrRealStrRealStrRealStr omc_BackendDump_debugStrRealStrRealStrRealStrRealStr


DLLExport
void omc_BackendDump_debugStrCrefStrExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefStrExpStr omc_BackendDump_debugStrCrefStrExpStr


DLLExport
void omc_BackendDump_debugStrCrefStrCrefStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrCrefStrCrefStr omc_BackendDump_debugStrCrefStrCrefStr


DLLExport
void omc_BackendDump_debugExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugExpStr omc_BackendDump_debugExpStr


DLLExport
void omc_BackendDump_debugStrExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrExpStr omc_BackendDump_debugStrExpStr


DLLExport
void omc_BackendDump_debugStrExpLstStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrExpLstStr omc_BackendDump_debugStrExpLstStr


DLLExport
void omc_BackendDump_debugStrExpStrCrefStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrExpStrCrefStr omc_BackendDump_debugStrExpStrCrefStr


DLLExport
void omc_BackendDump_debugStrExpStrExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrExpStrExpStr omc_BackendDump_debugStrExpStrExpStr


DLLExport
void omc_BackendDump_debugExpStrExpStrExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugExpStrExpStrExpStr omc_BackendDump_debugExpStrExpStrExpStr


DLLExport
void omc_BackendDump_debugStrExpStrExpStrExpStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrExpStrExpStrExpStr omc_BackendDump_debugStrExpStrExpStrExpStr


DLLExport
void omc_BackendDump_debugStrEqnStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrEqnStr omc_BackendDump_debugStrEqnStr


DLLExport
void omc_BackendDump_debugStrEqnStrEqnStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debugStrEqnStrEqnStr omc_BackendDump_debugStrEqnStrEqnStr


DLLExport
void omc_BackendDump_debuglst(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_debuglst omc_BackendDump_debuglst

typedef struct BackendDump_printCallFunction2StrDIVISION_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_printCallFunction2StrDIVISION_rettype;
DLLExport
BackendDump_printCallFunction2StrDIVISION_rettype omc_BackendDump_printCallFunction2StrDIVISION(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _stringDelimiter, modelica_metatype _opcreffunc);
#define boxptr_BackendDump_printCallFunction2StrDIVISION omc_BackendDump_printCallFunction2StrDIVISION

typedef struct BackendDump_dumpTypeStr_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_dumpTypeStr_rettype;
DLLExport
BackendDump_dumpTypeStr_rettype omc_BackendDump_dumpTypeStr(threadData_t *threadData, modelica_metatype _inType);
#define boxptr_BackendDump_dumpTypeStr omc_BackendDump_dumpTypeStr

typedef struct BackendDump_dumpWhenOperatorStr_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_dumpWhenOperatorStr_rettype;
DLLExport
BackendDump_dumpWhenOperatorStr_rettype omc_BackendDump_dumpWhenOperatorStr(threadData_t *threadData, modelica_metatype _inWhenOperator);
#define boxptr_BackendDump_dumpWhenOperatorStr omc_BackendDump_dumpWhenOperatorStr


DLLExport
void omc_BackendDump_dumpOption(threadData_t *threadData, modelica_metatype _inType, modelica_fnptr infunc);
#define boxptr_BackendDump_dumpOption omc_BackendDump_dumpOption

typedef struct BackendDump_dumpEqSystemHTML_rettype_s {
  modelica_metatype c1; /* outTpl */
} BackendDump_dumpEqSystemHTML_rettype;
DLLExport
BackendDump_dumpEqSystemHTML_rettype omc_BackendDump_dumpEqSystemHTML(threadData_t *threadData, modelica_metatype _inEqSystem, modelica_metatype _inPrefixIdstr, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpEqSystemHTML omc_BackendDump_dumpEqSystemHTML

typedef struct BackendDump_printVarListHTML_rettype_s {
  modelica_metatype c1; /* outTags */
} BackendDump_printVarListHTML_rettype;
DLLExport
BackendDump_printVarListHTML_rettype omc_BackendDump_printVarListHTML(threadData_t *threadData, modelica_metatype _vars, modelica_metatype _prefixId, modelica_metatype _inTags);
#define boxptr_BackendDump_printVarListHTML omc_BackendDump_printVarListHTML

typedef struct BackendDump_dumpVarHTML_rettype_s {
  modelica_metatype c1; /* oTpl */
} BackendDump_dumpVarHTML_rettype;
DLLExport
BackendDump_dumpVarHTML_rettype omc_BackendDump_dumpVarHTML(threadData_t *threadData, modelica_metatype _inVar, modelica_metatype _prefixId, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpVarHTML omc_BackendDump_dumpVarHTML

typedef struct BackendDump_dumpEqnsHTML_rettype_s {
  modelica_metatype c1; /* outTags */
} BackendDump_dumpEqnsHTML_rettype;
DLLExport
BackendDump_dumpEqnsHTML_rettype omc_BackendDump_dumpEqnsHTML(threadData_t *threadData, modelica_metatype _eqns, modelica_metatype _prefixId, modelica_metatype _inTags);
#define boxptr_BackendDump_dumpEqnsHTML omc_BackendDump_dumpEqnsHTML

typedef struct BackendDump_dumpEqnHTML_rettype_s {
  modelica_metatype c1; /* oTpl */
} BackendDump_dumpEqnHTML_rettype;
DLLExport
BackendDump_dumpEqnHTML_rettype omc_BackendDump_dumpEqnHTML(threadData_t *threadData, modelica_metatype _inEquation, modelica_metatype _prefixId, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpEqnHTML omc_BackendDump_dumpEqnHTML

typedef struct BackendDump_dumpFullMatchingHTML_rettype_s {
  modelica_metatype c1; /* outTags */
} BackendDump_dumpFullMatchingHTML_rettype;
DLLExport
BackendDump_dumpFullMatchingHTML_rettype omc_BackendDump_dumpFullMatchingHTML(threadData_t *threadData, modelica_metatype _inMatch, modelica_metatype _prefixId, modelica_metatype _inTags);
#define boxptr_BackendDump_dumpFullMatchingHTML omc_BackendDump_dumpFullMatchingHTML

typedef struct BackendDump_dumpMatchingHTML_rettype_s {
  modelica_metatype c1; /* outTags */
} BackendDump_dumpMatchingHTML_rettype;
DLLExport
BackendDump_dumpMatchingHTML_rettype omc_BackendDump_dumpMatchingHTML(threadData_t *threadData, modelica_metatype _v, modelica_metatype _prefixId, modelica_metatype _inTags);
#define boxptr_BackendDump_dumpMatchingHTML omc_BackendDump_dumpMatchingHTML

typedef struct BackendDump_dumpMatchingHTML2_rettype_s {
  modelica_metatype c1; /* outTags */
} BackendDump_dumpMatchingHTML2_rettype;
DLLExport
BackendDump_dumpMatchingHTML2_rettype omc_BackendDump_dumpMatchingHTML2(threadData_t *threadData, modelica_metatype _v, modelica_integer _i, modelica_integer _len, modelica_metatype _prefixId, modelica_metatype _inTags);
typedef struct BackendDump_dumpMatchingHTML2_rettypeboxed_s {
  modelica_metatype c1; /* outTags */
} BackendDump_dumpMatchingHTML2_rettypeboxed;
DLLExport
BackendDump_dumpMatchingHTML2_rettypeboxed boxptr_BackendDump_dumpMatchingHTML2(threadData_t *threadData, modelica_metatype _v, modelica_metatype _i, modelica_metatype _len, modelica_metatype _prefixId, modelica_metatype _inTags);
typedef struct BackendDump_dumpSharedHTML_rettype_s {
  modelica_metatype c1; /* outDoc */
} BackendDump_dumpSharedHTML_rettype;
DLLExport
BackendDump_dumpSharedHTML_rettype omc_BackendDump_dumpSharedHTML(threadData_t *threadData, modelica_metatype _inShared, modelica_metatype _inDoc);
#define boxptr_BackendDump_dumpSharedHTML omc_BackendDump_dumpSharedHTML


DLLExport
void omc_BackendDump_dumpAlgorithms(threadData_t *threadData, modelica_metatype _ialgs, modelica_integer _indx);

DLLExport
void boxptr_BackendDump_dumpAlgorithms(threadData_t *threadData, modelica_metatype _ialgs, modelica_metatype _indx);

DLLExport
void omc_BackendDump_dumpConstraints(threadData_t *threadData, modelica_metatype _ionstrs, modelica_integer _indx);

DLLExport
void boxptr_BackendDump_dumpConstraints(threadData_t *threadData, modelica_metatype _ionstrs, modelica_metatype _indx);

DLLExport
void omc_BackendDump_dumpSparsePatternArray(threadData_t *threadData, modelica_metatype _inSparsePatter);
#define boxptr_BackendDump_dumpSparsePatternArray omc_BackendDump_dumpSparsePatternArray


DLLExport
void omc_BackendDump_dumpSparsePattern(threadData_t *threadData, modelica_metatype _inSparsePatter);
#define boxptr_BackendDump_dumpSparsePattern omc_BackendDump_dumpSparsePattern


DLLExport
void omc_BackendDump_dumpSparsePattern2(threadData_t *threadData, modelica_metatype _inSparsePatter, modelica_integer _inInteger);

DLLExport
void boxptr_BackendDump_dumpSparsePattern2(threadData_t *threadData, modelica_metatype _inSparsePatter, modelica_metatype _inInteger);
typedef struct BackendDump_dumpJacobianStr_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_dumpJacobianStr_rettype;
DLLExport
BackendDump_dumpJacobianStr_rettype omc_BackendDump_dumpJacobianStr(threadData_t *threadData, modelica_metatype _inTplIntegerIntegerEquationLstOption);
#define boxptr_BackendDump_dumpJacobianStr omc_BackendDump_dumpJacobianStr

typedef struct BackendDump_dumpJacobianStr2_rettype_s {
  modelica_metatype c1; /* outStringLst */
} BackendDump_dumpJacobianStr2_rettype;
DLLExport
BackendDump_dumpJacobianStr2_rettype omc_BackendDump_dumpJacobianStr2(threadData_t *threadData, modelica_metatype _inTplIntegerIntegerEquationLst);
#define boxptr_BackendDump_dumpJacobianStr2 omc_BackendDump_dumpJacobianStr2

typedef struct BackendDump_jacobianTypeStr_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_jacobianTypeStr_rettype;
DLLExport
BackendDump_jacobianTypeStr_rettype omc_BackendDump_jacobianTypeStr(threadData_t *threadData, modelica_metatype _inJacobianType);
#define boxptr_BackendDump_jacobianTypeStr omc_BackendDump_jacobianTypeStr

typedef struct BackendDump_dumpEqnsStr_rettype_s {
  modelica_metatype c1; /* str */
} BackendDump_dumpEqnsStr_rettype;
DLLExport
BackendDump_dumpEqnsStr_rettype omc_BackendDump_dumpEqnsStr(threadData_t *threadData, modelica_metatype _eqns);
#define boxptr_BackendDump_dumpEqnsStr omc_BackendDump_dumpEqnsStr

typedef struct BackendDump_dumpEqnsStr2_rettype_s {
  modelica_metatype c1; /* strs */
} BackendDump_dumpEqnsStr2_rettype;
DLLExport
BackendDump_dumpEqnsStr2_rettype omc_BackendDump_dumpEqnsStr2(threadData_t *threadData, modelica_metatype _inEquationLst, modelica_integer _inInteger, modelica_metatype _inAcc);
typedef struct BackendDump_dumpEqnsStr2_rettypeboxed_s {
  modelica_metatype c1; /* strs */
} BackendDump_dumpEqnsStr2_rettypeboxed;
DLLExport
BackendDump_dumpEqnsStr2_rettypeboxed boxptr_BackendDump_dumpEqnsStr2(threadData_t *threadData, modelica_metatype _inEquationLst, modelica_metatype _inInteger, modelica_metatype _inAcc);
typedef struct BackendDump_ifequationString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_ifequationString_rettype;
DLLExport
BackendDump_ifequationString_rettype omc_BackendDump_ifequationString(threadData_t *threadData, modelica_metatype _conditions, modelica_metatype _eqnstrue, modelica_metatype _eqnsfalse, modelica_metatype _iString);
#define boxptr_BackendDump_ifequationString omc_BackendDump_ifequationString

typedef struct BackendDump_varString_rettype_s {
  modelica_metatype c1; /* outStr */
} BackendDump_varString_rettype;
DLLExport
BackendDump_varString_rettype omc_BackendDump_varString(threadData_t *threadData, modelica_metatype _inVar);
#define boxptr_BackendDump_varString omc_BackendDump_varString


DLLExport
void omc_BackendDump_dumpKind(threadData_t *threadData, modelica_metatype _inVarKind);
#define boxptr_BackendDump_dumpKind omc_BackendDump_dumpKind

typedef struct BackendDump_kindString_rettype_s {
  modelica_metatype c1; /* kindStr */
} BackendDump_kindString_rettype;
DLLExport
BackendDump_kindString_rettype omc_BackendDump_kindString(threadData_t *threadData, modelica_metatype _inVarKind);
#define boxptr_BackendDump_kindString omc_BackendDump_kindString


DLLExport
void omc_BackendDump_dumpConnectorType(threadData_t *threadData, modelica_metatype _inConnectorType);
#define boxptr_BackendDump_dumpConnectorType omc_BackendDump_dumpConnectorType

typedef struct BackendDump_connectorTypeString_rettype_s {
  modelica_metatype c1; /* connectorTypeStr */
} BackendDump_connectorTypeString_rettype;
DLLExport
BackendDump_connectorTypeString_rettype omc_BackendDump_connectorTypeString(threadData_t *threadData, modelica_metatype _inConnectorType);
#define boxptr_BackendDump_connectorTypeString omc_BackendDump_connectorTypeString


DLLExport
void omc_BackendDump_dumpAttributes(threadData_t *threadData, modelica_metatype _inAttr);
#define boxptr_BackendDump_dumpAttributes omc_BackendDump_dumpAttributes


DLLExport
void omc_BackendDump_dumpOptDistribution(threadData_t *threadData, modelica_metatype _dist);
#define boxptr_BackendDump_dumpOptDistribution omc_BackendDump_dumpOptDistribution


DLLExport
void omc_BackendDump_dumpOptStateSelection(threadData_t *threadData, modelica_metatype _ss);
#define boxptr_BackendDump_dumpOptStateSelection omc_BackendDump_dumpOptStateSelection


DLLExport
void omc_BackendDump_dumpOptExpression(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inString);
#define boxptr_BackendDump_dumpOptExpression omc_BackendDump_dumpOptExpression


DLLExport
void omc_BackendDump_dumpOptBoolean(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inString);
#define boxptr_BackendDump_dumpOptBoolean omc_BackendDump_dumpOptBoolean

typedef struct BackendDump_attributesString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_attributesString_rettype;
DLLExport
BackendDump_attributesString_rettype omc_BackendDump_attributesString(threadData_t *threadData, modelica_metatype _inAttr);
#define boxptr_BackendDump_attributesString omc_BackendDump_attributesString

typedef struct BackendDump_optDistributionString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_optDistributionString_rettype;
DLLExport
BackendDump_optDistributionString_rettype omc_BackendDump_optDistributionString(threadData_t *threadData, modelica_metatype _dist);
#define boxptr_BackendDump_optDistributionString omc_BackendDump_optDistributionString

typedef struct BackendDump_optUncertainty_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_optUncertainty_rettype;
DLLExport
BackendDump_optUncertainty_rettype omc_BackendDump_optUncertainty(threadData_t *threadData, modelica_metatype _uncertainty);
#define boxptr_BackendDump_optUncertainty omc_BackendDump_optUncertainty

typedef struct BackendDump_optStateSelectionString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_optStateSelectionString_rettype;
DLLExport
BackendDump_optStateSelectionString_rettype omc_BackendDump_optStateSelectionString(threadData_t *threadData, modelica_metatype _ss);
#define boxptr_BackendDump_optStateSelectionString omc_BackendDump_optStateSelectionString

typedef struct BackendDump_optExpressionString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_optExpressionString_rettype;
DLLExport
BackendDump_optExpressionString_rettype omc_BackendDump_optExpressionString(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inString);
#define boxptr_BackendDump_optExpressionString omc_BackendDump_optExpressionString

typedef struct BackendDump_optBooleanString_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_optBooleanString_rettype;
DLLExport
BackendDump_optBooleanString_rettype omc_BackendDump_optBooleanString(threadData_t *threadData, modelica_metatype _inExp, modelica_metatype _inString);
#define boxptr_BackendDump_optBooleanString omc_BackendDump_optBooleanString


DLLExport
void omc_BackendDump_dumpIncidenceMatrix(threadData_t *threadData, modelica_metatype _m);
#define boxptr_BackendDump_dumpIncidenceMatrix omc_BackendDump_dumpIncidenceMatrix


DLLExport
void omc_BackendDump_dumpIncidenceMatrixT(threadData_t *threadData, modelica_metatype _m);
#define boxptr_BackendDump_dumpIncidenceMatrixT omc_BackendDump_dumpIncidenceMatrixT


DLLExport
void omc_BackendDump_dumpIncidenceMatrix2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_integer _rowIndex);

DLLExport
void boxptr_BackendDump_dumpIncidenceMatrix2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_metatype _rowIndex);

DLLExport
void omc_BackendDump_dumpIncidenceRow(threadData_t *threadData, modelica_metatype _inIntegerLst);
#define boxptr_BackendDump_dumpIncidenceRow omc_BackendDump_dumpIncidenceRow


DLLExport
void omc_BackendDump_dumpAdjacencyMatrixEnhanced(threadData_t *threadData, modelica_metatype _m);
#define boxptr_BackendDump_dumpAdjacencyMatrixEnhanced omc_BackendDump_dumpAdjacencyMatrixEnhanced


DLLExport
void omc_BackendDump_dumpAdjacencyMatrixTEnhanced(threadData_t *threadData, modelica_metatype _m);
#define boxptr_BackendDump_dumpAdjacencyMatrixTEnhanced omc_BackendDump_dumpAdjacencyMatrixTEnhanced


DLLExport
void omc_BackendDump_dumpAdjacencyMatrixEnhanced2(threadData_t *threadData, modelica_metatype _inRows, modelica_integer _rowIndex);

DLLExport
void boxptr_BackendDump_dumpAdjacencyMatrixEnhanced2(threadData_t *threadData, modelica_metatype _inRows, modelica_metatype _rowIndex);

DLLExport
void omc_BackendDump_dumpAdjacencyRowEnhanced(threadData_t *threadData, modelica_metatype _inRow);
#define boxptr_BackendDump_dumpAdjacencyRowEnhanced omc_BackendDump_dumpAdjacencyRowEnhanced

typedef struct BackendDump_dumpSolvability_rettype_s {
  modelica_metatype c1; /* s */
} BackendDump_dumpSolvability_rettype;
DLLExport
BackendDump_dumpSolvability_rettype omc_BackendDump_dumpSolvability(threadData_t *threadData, modelica_metatype _solva);
#define boxptr_BackendDump_dumpSolvability omc_BackendDump_dumpSolvability


DLLExport
void omc_BackendDump_dumpFullMatching(threadData_t *threadData, modelica_metatype _inMatch);
#define boxptr_BackendDump_dumpFullMatching omc_BackendDump_dumpFullMatching


DLLExport
void omc_BackendDump_dumpMatching(threadData_t *threadData, modelica_metatype _v);
#define boxptr_BackendDump_dumpMatching omc_BackendDump_dumpMatching


DLLExport
void omc_BackendDump_dumpMatching2(threadData_t *threadData, modelica_metatype _v, modelica_integer _i, modelica_integer _len);

DLLExport
void boxptr_BackendDump_dumpMatching2(threadData_t *threadData, modelica_metatype _v, modelica_metatype _i, modelica_metatype _len);
typedef struct BackendDump_dumpMarkedEqns_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_dumpMarkedEqns_rettype;
DLLExport
BackendDump_dumpMarkedEqns_rettype omc_BackendDump_dumpMarkedEqns(threadData_t *threadData, modelica_metatype _syst, modelica_metatype _inIntegerLst);
#define boxptr_BackendDump_dumpMarkedEqns omc_BackendDump_dumpMarkedEqns

typedef struct BackendDump_dumpMarkedEqns1_rettype_s {
  modelica_metatype c1; /* outS */
} BackendDump_dumpMarkedEqns1_rettype;
DLLExport
BackendDump_dumpMarkedEqns1_rettype omc_BackendDump_dumpMarkedEqns1(threadData_t *threadData, modelica_integer _e, modelica_metatype _eqns, modelica_metatype _inS);
typedef struct BackendDump_dumpMarkedEqns1_rettypeboxed_s {
  modelica_metatype c1; /* outS */
} BackendDump_dumpMarkedEqns1_rettypeboxed;
DLLExport
BackendDump_dumpMarkedEqns1_rettypeboxed boxptr_BackendDump_dumpMarkedEqns1(threadData_t *threadData, modelica_metatype _e, modelica_metatype _eqns, modelica_metatype _inS);
typedef struct BackendDump_dumpMarkedVars_rettype_s {
  modelica_metatype c1; /* outString */
} BackendDump_dumpMarkedVars_rettype;
DLLExport
BackendDump_dumpMarkedVars_rettype omc_BackendDump_dumpMarkedVars(threadData_t *threadData, modelica_metatype _syst, modelica_metatype _inIntegerLst);
#define boxptr_BackendDump_dumpMarkedVars omc_BackendDump_dumpMarkedVars

typedef struct BackendDump_dumpMarkedVars1_rettype_s {
  modelica_metatype c1; /* outS */
} BackendDump_dumpMarkedVars1_rettype;
DLLExport
BackendDump_dumpMarkedVars1_rettype omc_BackendDump_dumpMarkedVars1(threadData_t *threadData, modelica_integer _v, modelica_metatype _vars);
typedef struct BackendDump_dumpMarkedVars1_rettypeboxed_s {
  modelica_metatype c1; /* outS */
} BackendDump_dumpMarkedVars1_rettypeboxed;
DLLExport
BackendDump_dumpMarkedVars1_rettypeboxed boxptr_BackendDump_dumpMarkedVars1(threadData_t *threadData, modelica_metatype _v, modelica_metatype _vars);
typedef struct BackendDump_dumpComponentsGraphStr_rettype_s {
  modelica_metatype c1; /* outDAE */
} BackendDump_dumpComponentsGraphStr_rettype;
DLLExport
BackendDump_dumpComponentsGraphStr_rettype omc_BackendDump_dumpComponentsGraphStr(threadData_t *threadData, modelica_metatype _inDAE);
#define boxptr_BackendDump_dumpComponentsGraphStr omc_BackendDump_dumpComponentsGraphStr

typedef struct BackendDump_dumpComponentsGraphStr2_rettype_s {
  modelica_metatype c1; /* lst */
} BackendDump_dumpComponentsGraphStr2_rettype;
DLLExport
BackendDump_dumpComponentsGraphStr2_rettype omc_BackendDump_dumpComponentsGraphStr2(threadData_t *threadData, modelica_integer _i, modelica_integer _n, modelica_metatype _m, modelica_metatype _mT, modelica_metatype _ass1, modelica_metatype _ass2);
typedef struct BackendDump_dumpComponentsGraphStr2_rettypeboxed_s {
  modelica_metatype c1; /* lst */
} BackendDump_dumpComponentsGraphStr2_rettypeboxed;
DLLExport
BackendDump_dumpComponentsGraphStr2_rettypeboxed boxptr_BackendDump_dumpComponentsGraphStr2(threadData_t *threadData, modelica_metatype _i, modelica_metatype _n, modelica_metatype _m, modelica_metatype _mT, modelica_metatype _ass1, modelica_metatype _ass2);

DLLExport
void omc_BackendDump_dumpList(threadData_t *threadData, modelica_metatype _l, modelica_metatype _str);
#define boxptr_BackendDump_dumpList omc_BackendDump_dumpList


DLLExport
void omc_BackendDump_dumpComponentsOLD(threadData_t *threadData, modelica_metatype _l);
#define boxptr_BackendDump_dumpComponentsOLD omc_BackendDump_dumpComponentsOLD


DLLExport
void omc_BackendDump_dumpComponents2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_integer _inInteger);

DLLExport
void boxptr_BackendDump_dumpComponents2(threadData_t *threadData, modelica_metatype _inIntegerLstLst, modelica_metatype _inInteger);
typedef struct BackendDump_intListStr_rettype_s {
  modelica_metatype c1; /* res */
} BackendDump_intListStr_rettype;
DLLExport
BackendDump_intListStr_rettype omc_BackendDump_intListStr(threadData_t *threadData, modelica_metatype _lst);
#define boxptr_BackendDump_intListStr omc_BackendDump_intListStr


DLLExport
void omc_BackendDump_dumpStateVariables(threadData_t *threadData, modelica_metatype _inVars);
#define boxptr_BackendDump_dumpStateVariables omc_BackendDump_dumpStateVariables

typedef struct BackendDump_dumpStateVariable_rettype_s {
  modelica_metatype c1; /* outTpl */
} BackendDump_dumpStateVariable_rettype;
DLLExport
BackendDump_dumpStateVariable_rettype omc_BackendDump_dumpStateVariable(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpStateVariable omc_BackendDump_dumpStateVariable


DLLExport
void omc_BackendDump_bltdump(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_bltdump omc_BackendDump_bltdump

typedef struct BackendDump_tupleString_rettype_s {
  modelica_metatype c1; /* s */
} BackendDump_tupleString_rettype;
DLLExport
BackendDump_tupleString_rettype omc_BackendDump_tupleString(threadData_t *threadData, modelica_metatype _iTpl);
#define boxptr_BackendDump_tupleString omc_BackendDump_tupleString


DLLExport
void omc_BackendDump_dumpCompShort(threadData_t *threadData, modelica_metatype _inDAE);
#define boxptr_BackendDump_dumpCompShort omc_BackendDump_dumpCompShort

typedef struct BackendDump_intTplString_rettype_s {
  modelica_metatype c1; /* outStr */
} BackendDump_intTplString_rettype;
DLLExport
BackendDump_intTplString_rettype omc_BackendDump_intTplString(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_intTplString omc_BackendDump_intTplString

typedef struct BackendDump_dumpCompShort1_rettype_s {
  modelica_metatype c1; /* outTpl */
} BackendDump_dumpCompShort1_rettype;
DLLExport
BackendDump_dumpCompShort1_rettype omc_BackendDump_dumpCompShort1(threadData_t *threadData, modelica_metatype _inSyst, modelica_metatype _inShared, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpCompShort1 omc_BackendDump_dumpCompShort1

typedef struct BackendDump_traversingisStateTopInputVarFinder_rettype_s {
  modelica_metatype c1; /* outTpl */
} BackendDump_traversingisStateTopInputVarFinder_rettype;
DLLExport
BackendDump_traversingisStateTopInputVarFinder_rettype omc_BackendDump_traversingisStateTopInputVarFinder(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_BackendDump_traversingisStateTopInputVarFinder omc_BackendDump_traversingisStateTopInputVarFinder

typedef struct BackendDump_dumpCompShort2_rettype_s {
  modelica_metatype c1; /* outTpl */
} BackendDump_dumpCompShort2_rettype;
DLLExport
BackendDump_dumpCompShort2_rettype omc_BackendDump_dumpCompShort2(threadData_t *threadData, modelica_metatype _inComp, modelica_metatype _inTpl);
#define boxptr_BackendDump_dumpCompShort2 omc_BackendDump_dumpCompShort2


DLLExport
void omc_BackendDump_dumpNrOfEquations(threadData_t *threadData, modelica_metatype _inDAE, modelica_metatype _preStr);
#define boxptr_BackendDump_dumpNrOfEquations omc_BackendDump_dumpNrOfEquations
#ifdef __cplusplus
extern "C" {
#endif
#include "Absyn.h"
#include "BackendDAETransform.h"
#include "BackendDAEUtil.h"
#include "BackendDump.h"
#include "BackendEquation.h"
#include "BackendVariable.h"
#include "BaseHashSet.h"
#include "ComponentReference.h"
#include "DAEDump.h"
#include "DAEUtil.h"
#include "Debug.h"
#include "DumpHTML.h"
#include "ExpressionDump.h"
#include "Flags.h"
#include "IOStream.h"
#include "List.h"
#include "System.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

