#ifndef BaseHashTable__H
#define BaseHashTable__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct BaseHashTable_bucketToValuesSize_rettype_s {
  modelica_integer c1; /* szArr */
} BaseHashTable_bucketToValuesSize_rettype;
DLLExport
BaseHashTable_bucketToValuesSize_rettype omc_BaseHashTable_bucketToValuesSize(threadData_t *threadData, modelica_integer _szBucket);
typedef struct BaseHashTable_bucketToValuesSize_rettypeboxed_s {
  modelica_metatype c1; /* szArr */
} BaseHashTable_bucketToValuesSize_rettypeboxed;
DLLExport
BaseHashTable_bucketToValuesSize_rettypeboxed boxptr_BaseHashTable_bucketToValuesSize(threadData_t *threadData, modelica_metatype _szBucket);
typedef struct BaseHashTable_emptyHashTableWork_rettype_s {
  modelica_metatype c1; /* hashTable */
} BaseHashTable_emptyHashTableWork_rettype;
DLLExport
BaseHashTable_emptyHashTableWork_rettype omc_BaseHashTable_emptyHashTableWork(threadData_t *threadData, modelica_integer _szBucket, modelica_metatype _fntpl);
typedef struct BaseHashTable_emptyHashTableWork_rettypeboxed_s {
  modelica_metatype c1; /* hashTable */
} BaseHashTable_emptyHashTableWork_rettypeboxed;
DLLExport
BaseHashTable_emptyHashTableWork_rettypeboxed boxptr_BaseHashTable_emptyHashTableWork(threadData_t *threadData, modelica_metatype _szBucket, modelica_metatype _fntpl);
typedef struct BaseHashTable_add_rettype_s {
  modelica_metatype c1; /* outHashTable */
} BaseHashTable_add_rettype;
DLLExport
BaseHashTable_add_rettype omc_BaseHashTable_add(threadData_t *threadData, modelica_metatype _entry, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_add omc_BaseHashTable_add


DLLExport
void omc_BaseHashTable_dumpHashTableStatistics(threadData_t *threadData, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_dumpHashTableStatistics omc_BaseHashTable_dumpHashTableStatistics

typedef struct BaseHashTable_addNoUpdCheck_rettype_s {
  modelica_metatype c1; /* outHashTable */
} BaseHashTable_addNoUpdCheck_rettype;
DLLExport
BaseHashTable_addNoUpdCheck_rettype omc_BaseHashTable_addNoUpdCheck(threadData_t *threadData, modelica_metatype _entry, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_addNoUpdCheck omc_BaseHashTable_addNoUpdCheck

typedef struct BaseHashTable_addUnique_rettype_s {
  modelica_metatype c1; /* outHashTable */
} BaseHashTable_addUnique_rettype;
DLLExport
BaseHashTable_addUnique_rettype omc_BaseHashTable_addUnique(threadData_t *threadData, modelica_metatype _entry, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_addUnique omc_BaseHashTable_addUnique

typedef struct BaseHashTable_update_rettype_s {
  modelica_metatype c1; /* outHashTable */
} BaseHashTable_update_rettype;
DLLExport
BaseHashTable_update_rettype omc_BaseHashTable_update(threadData_t *threadData, modelica_metatype _inEntry, modelica_metatype _inHashTable);
#define boxptr_BaseHashTable_update omc_BaseHashTable_update

typedef struct BaseHashTable_delete_rettype_s {
  modelica_metatype c1; /* outHashTable */
} BaseHashTable_delete_rettype;
DLLExport
BaseHashTable_delete_rettype omc_BaseHashTable_delete(threadData_t *threadData, modelica_metatype _key, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_delete omc_BaseHashTable_delete

typedef struct BaseHashTable_get_rettype_s {
  modelica_metatype c1; /* value */
} BaseHashTable_get_rettype;
DLLExport
BaseHashTable_get_rettype omc_BaseHashTable_get(threadData_t *threadData, modelica_metatype _key, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_get omc_BaseHashTable_get

typedef struct BaseHashTable_get1_rettype_s {
  modelica_metatype c1; /* value */
  modelica_integer c2; /* indx */
} BaseHashTable_get1_rettype;
DLLExport
BaseHashTable_get1_rettype omc_BaseHashTable_get1(threadData_t *threadData, modelica_metatype _key, modelica_metatype _hashTable);
typedef struct BaseHashTable_get1_rettypeboxed_s {
  modelica_metatype c1; /* value */
  modelica_metatype c2; /* indx */
} BaseHashTable_get1_rettypeboxed;
DLLExport
BaseHashTable_get1_rettypeboxed boxptr_BaseHashTable_get1(threadData_t *threadData, modelica_metatype _key, modelica_metatype _hashTable);
typedef struct BaseHashTable_get2_rettype_s {
  modelica_integer c1; /* index */
} BaseHashTable_get2_rettype;
DLLExport
BaseHashTable_get2_rettype omc_BaseHashTable_get2(threadData_t *threadData, modelica_boolean _b, modelica_integer _indexIfTrue, modelica_metatype _key, modelica_metatype _keyIndices, modelica_fnptr keyEqual);
typedef struct BaseHashTable_get2_rettypeboxed_s {
  modelica_metatype c1; /* index */
} BaseHashTable_get2_rettypeboxed;
DLLExport
BaseHashTable_get2_rettypeboxed boxptr_BaseHashTable_get2(threadData_t *threadData, modelica_metatype _b, modelica_metatype _indexIfTrue, modelica_metatype _key, modelica_metatype _keyIndices, modelica_fnptr keyEqual);

DLLExport
void omc_BaseHashTable_dumpHashTable(threadData_t *threadData, modelica_metatype _t);
#define boxptr_BaseHashTable_dumpHashTable omc_BaseHashTable_dumpHashTable

typedef struct BaseHashTable_dumpTuple_rettype_s {
  modelica_metatype c1; /* str */
} BaseHashTable_dumpTuple_rettype;
DLLExport
BaseHashTable_dumpTuple_rettype omc_BaseHashTable_dumpTuple(threadData_t *threadData, modelica_metatype _tpl, modelica_fnptr printKey, modelica_fnptr printValue);
#define boxptr_BaseHashTable_dumpTuple omc_BaseHashTable_dumpTuple

typedef struct BaseHashTable_hashTableValueList_rettype_s {
  modelica_metatype c1; /* valLst */
} BaseHashTable_hashTableValueList_rettype;
DLLExport
BaseHashTable_hashTableValueList_rettype omc_BaseHashTable_hashTableValueList(threadData_t *threadData, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_hashTableValueList omc_BaseHashTable_hashTableValueList

typedef struct BaseHashTable_hashTableKeyList_rettype_s {
  modelica_metatype c1; /* valLst */
} BaseHashTable_hashTableKeyList_rettype;
DLLExport
BaseHashTable_hashTableKeyList_rettype omc_BaseHashTable_hashTableKeyList(threadData_t *threadData, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_hashTableKeyList omc_BaseHashTable_hashTableKeyList

typedef struct BaseHashTable_hashTableList_rettype_s {
  modelica_metatype c1; /* outEntries */
} BaseHashTable_hashTableList_rettype;
DLLExport
BaseHashTable_hashTableList_rettype omc_BaseHashTable_hashTableList(threadData_t *threadData, modelica_metatype _hashTable);
#define boxptr_BaseHashTable_hashTableList omc_BaseHashTable_hashTableList

typedef struct BaseHashTable_valueArrayList_rettype_s {
  modelica_metatype c1; /* outEntries */
} BaseHashTable_valueArrayList_rettype;
DLLExport
BaseHashTable_valueArrayList_rettype omc_BaseHashTable_valueArrayList(threadData_t *threadData, modelica_metatype _valueArray);
#define boxptr_BaseHashTable_valueArrayList omc_BaseHashTable_valueArrayList

typedef struct BaseHashTable_hashTableCurrentSize_rettype_s {
  modelica_integer c1; /* sz */
} BaseHashTable_hashTableCurrentSize_rettype;
DLLExport
BaseHashTable_hashTableCurrentSize_rettype omc_BaseHashTable_hashTableCurrentSize(threadData_t *threadData, modelica_metatype _hashTable);
typedef struct BaseHashTable_hashTableCurrentSize_rettypeboxed_s {
  modelica_metatype c1; /* sz */
} BaseHashTable_hashTableCurrentSize_rettypeboxed;
DLLExport
BaseHashTable_hashTableCurrentSize_rettypeboxed boxptr_BaseHashTable_hashTableCurrentSize(threadData_t *threadData, modelica_metatype _hashTable);
typedef struct BaseHashTable_valueArrayLength_rettype_s {
  modelica_integer c1; /* sz */
} BaseHashTable_valueArrayLength_rettype;
DLLExport
BaseHashTable_valueArrayLength_rettype omc_BaseHashTable_valueArrayLength(threadData_t *threadData, modelica_metatype _valueArray);
typedef struct BaseHashTable_valueArrayLength_rettypeboxed_s {
  modelica_metatype c1; /* sz */
} BaseHashTable_valueArrayLength_rettypeboxed;
DLLExport
BaseHashTable_valueArrayLength_rettypeboxed boxptr_BaseHashTable_valueArrayLength(threadData_t *threadData, modelica_metatype _valueArray);
typedef struct BaseHashTable_valueArrayAdd_rettype_s {
  modelica_metatype c1; /* outValueArray */
} BaseHashTable_valueArrayAdd_rettype;
DLLExport
BaseHashTable_valueArrayAdd_rettype omc_BaseHashTable_valueArrayAdd(threadData_t *threadData, modelica_metatype _valueArray, modelica_metatype _entry);
#define boxptr_BaseHashTable_valueArrayAdd omc_BaseHashTable_valueArrayAdd

typedef struct BaseHashTable_valueArraySetnth_rettype_s {
  modelica_metatype c1; /* outValueArray */
} BaseHashTable_valueArraySetnth_rettype;
DLLExport
BaseHashTable_valueArraySetnth_rettype omc_BaseHashTable_valueArraySetnth(threadData_t *threadData, modelica_metatype _valueArray, modelica_integer _pos, modelica_metatype _entry);
typedef struct BaseHashTable_valueArraySetnth_rettypeboxed_s {
  modelica_metatype c1; /* outValueArray */
} BaseHashTable_valueArraySetnth_rettypeboxed;
DLLExport
BaseHashTable_valueArraySetnth_rettypeboxed boxptr_BaseHashTable_valueArraySetnth(threadData_t *threadData, modelica_metatype _valueArray, modelica_metatype _pos, modelica_metatype _entry);
typedef struct BaseHashTable_valueArrayClearnth_rettype_s {
  modelica_metatype c1; /* outValueArray */
} BaseHashTable_valueArrayClearnth_rettype;
DLLExport
BaseHashTable_valueArrayClearnth_rettype omc_BaseHashTable_valueArrayClearnth(threadData_t *threadData, modelica_metatype _valueArray, modelica_integer _pos);
typedef struct BaseHashTable_valueArrayClearnth_rettypeboxed_s {
  modelica_metatype c1; /* outValueArray */
} BaseHashTable_valueArrayClearnth_rettypeboxed;
DLLExport
BaseHashTable_valueArrayClearnth_rettypeboxed boxptr_BaseHashTable_valueArrayClearnth(threadData_t *threadData, modelica_metatype _valueArray, modelica_metatype _pos);
typedef struct BaseHashTable_valueArrayNth_rettype_s {
  modelica_metatype c1; /* key */
  modelica_metatype c2; /* value */
} BaseHashTable_valueArrayNth_rettype;
DLLExport
BaseHashTable_valueArrayNth_rettype omc_BaseHashTable_valueArrayNth(threadData_t *threadData, modelica_metatype _valueArray, modelica_integer _pos);
typedef struct BaseHashTable_valueArrayNth_rettypeboxed_s {
  modelica_metatype c1; /* key */
  modelica_metatype c2; /* value */
} BaseHashTable_valueArrayNth_rettypeboxed;
DLLExport
BaseHashTable_valueArrayNth_rettypeboxed boxptr_BaseHashTable_valueArrayNth(threadData_t *threadData, modelica_metatype _valueArray, modelica_metatype _pos);
#ifdef __cplusplus
extern "C" {
#endif
#include "BaseHashTable.h"
#include "List.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

