#ifndef ClassLoader__H
#define ClassLoader__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Absyn_Class_CLASS__desc;
extern struct record_description Absyn_ClassDef_PARTS__desc;
extern struct record_description Absyn_ClassPart_PROTECTED__desc;
extern struct record_description Absyn_ClassPart_PUBLIC__desc;
extern struct record_description Absyn_Info_INFO__desc;
extern struct record_description Absyn_Path_IDENT__desc;
extern struct record_description Absyn_Program_PROGRAM__desc;
extern struct record_description Absyn_TimeStamp_TIMESTAMP__desc;
extern struct record_description Absyn_Within_TOP__desc;
extern struct record_description Absyn_Within_WITHIN__desc;
extern struct record_description ClassLoader_PackageOrder_CLASSLOAD__desc;
extern struct record_description ClassLoader_PackageOrder_CLASSPART__desc;
extern struct record_description ClassLoader_PackageOrder_ELEMENT__desc;
extern struct record_description Config_LanguageStandard_MODELICA__2__X__desc;
extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_GRAMMAR__desc;
extern struct record_description Error_MessageType_SCRIPTING__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Error_Severity_NOTIFICATION__desc;
extern struct record_description Error_Severity_WARNING__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
extern struct record_description Util_TranslatableContent_notrans__desc;
typedef struct ClassLoader_loadClass_rettype_s {
  modelica_metatype c1; /* outProgram */
} ClassLoader_loadClass_rettype;
DLLExport
ClassLoader_loadClass_rettype omc_ClassLoader_loadClass(threadData_t *threadData, modelica_metatype _inPath, modelica_metatype _priorityList, modelica_metatype _modelicaPath, modelica_metatype _encoding);
#define boxptr_ClassLoader_loadClass omc_ClassLoader_loadClass


DLLExport
void omc_ClassLoader_existRegularFile(threadData_t *threadData, modelica_metatype _filename);
#define boxptr_ClassLoader_existRegularFile omc_ClassLoader_existRegularFile


DLLExport
void omc_ClassLoader_existDirectoryFile(threadData_t *threadData, modelica_metatype _filename);
#define boxptr_ClassLoader_existDirectoryFile omc_ClassLoader_existDirectoryFile

typedef struct ClassLoader_loadClassFromMps_rettype_s {
  modelica_metatype c1; /* outProgram */
} ClassLoader_loadClassFromMps_rettype;
DLLExport
ClassLoader_loadClassFromMps_rettype omc_ClassLoader_loadClassFromMps(threadData_t *threadData, modelica_metatype _id, modelica_metatype _prios, modelica_metatype _mps, modelica_metatype _encoding);
#define boxptr_ClassLoader_loadClassFromMps omc_ClassLoader_loadClassFromMps

typedef struct ClassLoader_loadClassFromMp_rettype_s {
  modelica_metatype c1; /* outClass */
} ClassLoader_loadClassFromMp_rettype;
DLLExport
ClassLoader_loadClassFromMp_rettype omc_ClassLoader_loadClassFromMp(threadData_t *threadData, modelica_metatype _id, modelica_metatype _path, modelica_metatype _name, modelica_boolean _isDir, modelica_metatype _optEncoding);
typedef struct ClassLoader_loadClassFromMp_rettypeboxed_s {
  modelica_metatype c1; /* outClass */
} ClassLoader_loadClassFromMp_rettypeboxed;
DLLExport
ClassLoader_loadClassFromMp_rettypeboxed boxptr_ClassLoader_loadClassFromMp(threadData_t *threadData, modelica_metatype _id, modelica_metatype _path, modelica_metatype _name, modelica_metatype _isDir, modelica_metatype _optEncoding);
typedef struct ClassLoader_loadCompletePackageFromMp_rettype_s {
  modelica_metatype c1; /* cl */
} ClassLoader_loadCompletePackageFromMp_rettype;
DLLExport
ClassLoader_loadCompletePackageFromMp_rettype omc_ClassLoader_loadCompletePackageFromMp(threadData_t *threadData, modelica_metatype _id, modelica_metatype _inIdent, modelica_metatype _inString, modelica_metatype _encoding, modelica_metatype _inWithin, modelica_integer _numError);
typedef struct ClassLoader_loadCompletePackageFromMp_rettypeboxed_s {
  modelica_metatype c1; /* cl */
} ClassLoader_loadCompletePackageFromMp_rettypeboxed;
DLLExport
ClassLoader_loadCompletePackageFromMp_rettypeboxed boxptr_ClassLoader_loadCompletePackageFromMp(threadData_t *threadData, modelica_metatype _id, modelica_metatype _inIdent, modelica_metatype _inString, modelica_metatype _encoding, modelica_metatype _inWithin, modelica_metatype _numError);
typedef struct ClassLoader_mergeBefore_rettype_s {
  modelica_metatype c1; /* ocp */
} ClassLoader_mergeBefore_rettype;
DLLExport
ClassLoader_mergeBefore_rettype omc_ClassLoader_mergeBefore(threadData_t *threadData, modelica_metatype _cp, modelica_metatype _cps);
#define boxptr_ClassLoader_mergeBefore omc_ClassLoader_mergeBefore

typedef struct ClassLoader_loadCompletePackageFromMp2_rettype_s {
  modelica_metatype c1; /* cps */
} ClassLoader_loadCompletePackageFromMp2_rettype;
DLLExport
ClassLoader_loadCompletePackageFromMp2_rettype omc_ClassLoader_loadCompletePackageFromMp2(threadData_t *threadData, modelica_metatype _po, modelica_metatype _mp, modelica_metatype _encoding, modelica_metatype _w1, modelica_metatype _acc);
#define boxptr_ClassLoader_loadCompletePackageFromMp2 omc_ClassLoader_loadCompletePackageFromMp2

typedef struct ClassLoader_loadFile_rettype_s {
  modelica_metatype c1; /* outProgram */
} ClassLoader_loadFile_rettype;
DLLExport
ClassLoader_loadFile_rettype omc_ClassLoader_loadFile(threadData_t *threadData, modelica_metatype _name, modelica_metatype _encoding);
#define boxptr_ClassLoader_loadFile omc_ClassLoader_loadFile

typedef struct ClassLoader_parsePackageFile_rettype_s {
  modelica_metatype c1; /* outClass */
} ClassLoader_parsePackageFile_rettype;
DLLExport
ClassLoader_parsePackageFile_rettype omc_ClassLoader_parsePackageFile(threadData_t *threadData, modelica_metatype _name, modelica_metatype _encoding, modelica_boolean _expectPackage, modelica_metatype _w1, modelica_metatype _pack);
typedef struct ClassLoader_parsePackageFile_rettypeboxed_s {
  modelica_metatype c1; /* outClass */
} ClassLoader_parsePackageFile_rettypeboxed;
DLLExport
ClassLoader_parsePackageFile_rettypeboxed boxptr_ClassLoader_parsePackageFile(threadData_t *threadData, modelica_metatype _name, modelica_metatype _encoding, modelica_metatype _expectPackage, modelica_metatype _w1, modelica_metatype _pack);
typedef struct ClassLoader_getPackageContentNames_rettype_s {
  modelica_metatype c1; /* po */
} ClassLoader_getPackageContentNames_rettype;
DLLExport
ClassLoader_getPackageContentNames_rettype omc_ClassLoader_getPackageContentNames(threadData_t *threadData, modelica_metatype _cl, modelica_metatype _filename, modelica_metatype _mp, modelica_integer _numError);
typedef struct ClassLoader_getPackageContentNames_rettypeboxed_s {
  modelica_metatype c1; /* po */
} ClassLoader_getPackageContentNames_rettypeboxed;
DLLExport
ClassLoader_getPackageContentNames_rettypeboxed boxptr_ClassLoader_getPackageContentNames(threadData_t *threadData, modelica_metatype _cl, modelica_metatype _filename, modelica_metatype _mp, modelica_metatype _numError);
typedef struct ClassLoader_makeClassPart_rettype_s {
  modelica_metatype c1; /* po */
} ClassLoader_makeClassPart_rettype;
DLLExport
ClassLoader_makeClassPart_rettype omc_ClassLoader_makeClassPart(threadData_t *threadData, modelica_metatype _part);
#define boxptr_ClassLoader_makeClassPart omc_ClassLoader_makeClassPart

typedef struct ClassLoader_makeElement_rettype_s {
  modelica_metatype c1; /* po */
} ClassLoader_makeElement_rettype;
DLLExport
ClassLoader_makeElement_rettype omc_ClassLoader_makeElement(threadData_t *threadData, modelica_metatype _el, modelica_boolean _pub);
typedef struct ClassLoader_makeElement_rettypeboxed_s {
  modelica_metatype c1; /* po */
} ClassLoader_makeElement_rettypeboxed;
DLLExport
ClassLoader_makeElement_rettypeboxed boxptr_ClassLoader_makeElement(threadData_t *threadData, modelica_metatype _el, modelica_metatype _pub);
typedef struct ClassLoader_makeClassLoad_rettype_s {
  modelica_metatype c1; /* po */
} ClassLoader_makeClassLoad_rettype;
DLLExport
ClassLoader_makeClassLoad_rettype omc_ClassLoader_makeClassLoad(threadData_t *threadData, modelica_metatype _str);
#define boxptr_ClassLoader_makeClassLoad omc_ClassLoader_makeClassLoad


DLLExport
void omc_ClassLoader_checkPackageOrderFilesExist(threadData_t *threadData, modelica_metatype _po, modelica_metatype _mp, modelica_metatype _info);
#define boxptr_ClassLoader_checkPackageOrderFilesExist omc_ClassLoader_checkPackageOrderFilesExist

typedef struct ClassLoader_existPackage_rettype_s {
  modelica_boolean c1; /* b */
} ClassLoader_existPackage_rettype;
DLLExport
ClassLoader_existPackage_rettype omc_ClassLoader_existPackage(threadData_t *threadData, modelica_metatype _name, modelica_metatype _mp);
typedef struct ClassLoader_existPackage_rettypeboxed_s {
  modelica_metatype c1; /* b */
} ClassLoader_existPackage_rettypeboxed;
DLLExport
ClassLoader_existPackage_rettypeboxed boxptr_ClassLoader_existPackage(threadData_t *threadData, modelica_metatype _name, modelica_metatype _mp);
typedef struct ClassLoader_getPackageContentNamesinParts_rettype_s {
  modelica_metatype c1; /* outOrder */
} ClassLoader_getPackageContentNamesinParts_rettype;
DLLExport
ClassLoader_getPackageContentNamesinParts_rettype omc_ClassLoader_getPackageContentNamesinParts(threadData_t *threadData, modelica_metatype _inNamesToSort, modelica_metatype _cps, modelica_metatype _acc);
#define boxptr_ClassLoader_getPackageContentNamesinParts omc_ClassLoader_getPackageContentNamesinParts

typedef struct ClassLoader_getPackageContentNamesinElts_rettype_s {
  modelica_metatype c1; /* outOrder */
  modelica_metatype c2; /* outNames */
} ClassLoader_getPackageContentNamesinElts_rettype;
DLLExport
ClassLoader_getPackageContentNamesinElts_rettype omc_ClassLoader_getPackageContentNamesinElts(threadData_t *threadData, modelica_metatype _inNamesToSort, modelica_metatype _inElts, modelica_metatype _po, modelica_boolean _pub);
typedef struct ClassLoader_getPackageContentNamesinElts_rettypeboxed_s {
  modelica_metatype c1; /* outOrder */
  modelica_metatype c2; /* outNames */
} ClassLoader_getPackageContentNamesinElts_rettypeboxed;
DLLExport
ClassLoader_getPackageContentNamesinElts_rettypeboxed boxptr_ClassLoader_getPackageContentNamesinElts(threadData_t *threadData, modelica_metatype _inNamesToSort, modelica_metatype _inElts, modelica_metatype _po, modelica_metatype _pub);
typedef struct ClassLoader_matchCompNames_rettype_s {
  modelica_metatype c1; /* outNames */
  modelica_boolean c2; /* matchedNames */
} ClassLoader_matchCompNames_rettype;
DLLExport
ClassLoader_matchCompNames_rettype omc_ClassLoader_matchCompNames(threadData_t *threadData, modelica_metatype _names, modelica_metatype _comps, modelica_metatype _info);
typedef struct ClassLoader_matchCompNames_rettypeboxed_s {
  modelica_metatype c1; /* outNames */
  modelica_metatype c2; /* matchedNames */
} ClassLoader_matchCompNames_rettypeboxed;
DLLExport
ClassLoader_matchCompNames_rettypeboxed boxptr_ClassLoader_matchCompNames(threadData_t *threadData, modelica_metatype _names, modelica_metatype _comps, modelica_metatype _info);
typedef struct ClassLoader_packageOrderName_rettype_s {
  modelica_metatype c1; /* name */
} ClassLoader_packageOrderName_rettype;
DLLExport
ClassLoader_packageOrderName_rettype omc_ClassLoader_packageOrderName(threadData_t *threadData, modelica_metatype _ord);
#define boxptr_ClassLoader_packageOrderName omc_ClassLoader_packageOrderName


DLLExport
void omc_ClassLoader_checkOnLoadMessage(threadData_t *threadData, modelica_metatype _p1);
#define boxptr_ClassLoader_checkOnLoadMessage omc_ClassLoader_checkOnLoadMessage

typedef struct ClassLoader_checkOnLoadMessageWork_rettype_s {
  modelica_integer c1; /* dummy */
} ClassLoader_checkOnLoadMessageWork_rettype;
DLLExport
ClassLoader_checkOnLoadMessageWork_rettype omc_ClassLoader_checkOnLoadMessageWork(threadData_t *threadData, modelica_metatype _mod);
typedef struct ClassLoader_checkOnLoadMessageWork_rettypeboxed_s {
  modelica_metatype c1; /* dummy */
} ClassLoader_checkOnLoadMessageWork_rettypeboxed;
DLLExport
ClassLoader_checkOnLoadMessageWork_rettypeboxed boxptr_ClassLoader_checkOnLoadMessageWork(threadData_t *threadData, modelica_metatype _mod);
#ifdef __cplusplus
extern "C" {
#endif
#include "Absyn.h"
#include "ClassLoader.h"
#include "Config.h"
#include "Debug.h"
#include "Error.h"
#include "List.h"
#include "Parser.h"
#include "System.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

