#ifndef ConnectionGraph__H
#define ConnectionGraph__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description ConnectionGraph_ConnectionGraph_GRAPH__desc;
extern struct record_description DAE_DAElist_DAE__desc;
extern struct record_description DAE_Exp_BCONST__desc;
extern struct record_description DAE_Type_T__INTEGER__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description IOStream_IOStreamType_LIST__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
typedef struct ConnectionGraph_handleOverconstrainedConnections_rettype_s {
  modelica_metatype c1; /* outDAE */
  modelica_metatype c2; /* outConnected */
  modelica_metatype c3; /* outBroken */
} ConnectionGraph_handleOverconstrainedConnections_rettype;
DLLExport
ConnectionGraph_handleOverconstrainedConnections_rettype omc_ConnectionGraph_handleOverconstrainedConnections(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _modelNameQualified, modelica_metatype _inDAE);
#define boxptr_ConnectionGraph_handleOverconstrainedConnections omc_ConnectionGraph_handleOverconstrainedConnections

typedef struct ConnectionGraph_addDefiniteRoot_rettype_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_addDefiniteRoot_rettype;
DLLExport
ConnectionGraph_addDefiniteRoot_rettype omc_ConnectionGraph_addDefiniteRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot);
#define boxptr_ConnectionGraph_addDefiniteRoot omc_ConnectionGraph_addDefiniteRoot

typedef struct ConnectionGraph_addPotentialRoot_rettype_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_addPotentialRoot_rettype;
DLLExport
ConnectionGraph_addPotentialRoot_rettype omc_ConnectionGraph_addPotentialRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot, modelica_real _inPriority);
typedef struct ConnectionGraph_addPotentialRoot_rettypeboxed_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_addPotentialRoot_rettypeboxed;
DLLExport
ConnectionGraph_addPotentialRoot_rettypeboxed boxptr_ConnectionGraph_addPotentialRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot, modelica_metatype _inPriority);
typedef struct ConnectionGraph_addBranch_rettype_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_addBranch_rettype;
DLLExport
ConnectionGraph_addBranch_rettype omc_ConnectionGraph_addBranch(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRef1, modelica_metatype _inRef2);
#define boxptr_ConnectionGraph_addBranch omc_ConnectionGraph_addBranch

typedef struct ConnectionGraph_addConnection_rettype_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_addConnection_rettype;
DLLExport
ConnectionGraph_addConnection_rettype omc_ConnectionGraph_addConnection(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRef1, modelica_metatype _inRef2, modelica_metatype _inDae);
#define boxptr_ConnectionGraph_addConnection omc_ConnectionGraph_addConnection

typedef struct ConnectionGraph_canonical_rettype_s {
  modelica_metatype c1; /* outCanonical */
} ConnectionGraph_canonical_rettype;
DLLExport
ConnectionGraph_canonical_rettype omc_ConnectionGraph_canonical(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef);
#define boxptr_ConnectionGraph_canonical omc_ConnectionGraph_canonical

typedef struct ConnectionGraph_areInSameComponent_rettype_s {
  modelica_boolean c1; /* outResult */
} ConnectionGraph_areInSameComponent_rettype;
DLLExport
ConnectionGraph_areInSameComponent_rettype omc_ConnectionGraph_areInSameComponent(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef1, modelica_metatype _inRef2);
typedef struct ConnectionGraph_areInSameComponent_rettypeboxed_s {
  modelica_metatype c1; /* outResult */
} ConnectionGraph_areInSameComponent_rettypeboxed;
DLLExport
ConnectionGraph_areInSameComponent_rettypeboxed boxptr_ConnectionGraph_areInSameComponent(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef1, modelica_metatype _inRef2);
typedef struct ConnectionGraph_connectBranchComponents_rettype_s {
  modelica_metatype c1; /* outPartition */
} ConnectionGraph_connectBranchComponents_rettype;
DLLExport
ConnectionGraph_connectBranchComponents_rettype omc_ConnectionGraph_connectBranchComponents(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef1, modelica_metatype _inRef2);
#define boxptr_ConnectionGraph_connectBranchComponents omc_ConnectionGraph_connectBranchComponents

typedef struct ConnectionGraph_connectComponents_rettype_s {
  modelica_metatype c1; /* outPartition */
  modelica_metatype c2; /* outConnectedConnections */
  modelica_metatype c3; /* outBrokenConnections */
} ConnectionGraph_connectComponents_rettype;
DLLExport
ConnectionGraph_connectComponents_rettype omc_ConnectionGraph_connectComponents(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inDaeEdge);
#define boxptr_ConnectionGraph_connectComponents omc_ConnectionGraph_connectComponents

typedef struct ConnectionGraph_connectCanonicalComponents_rettype_s {
  modelica_metatype c1; /* outPartition */
  modelica_boolean c2; /* outReallyConnected */
} ConnectionGraph_connectCanonicalComponents_rettype;
DLLExport
ConnectionGraph_connectCanonicalComponents_rettype omc_ConnectionGraph_connectCanonicalComponents(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef1, modelica_metatype _inRef2);
typedef struct ConnectionGraph_connectCanonicalComponents_rettypeboxed_s {
  modelica_metatype c1; /* outPartition */
  modelica_metatype c2; /* outReallyConnected */
} ConnectionGraph_connectCanonicalComponents_rettypeboxed;
DLLExport
ConnectionGraph_connectCanonicalComponents_rettypeboxed boxptr_ConnectionGraph_connectCanonicalComponents(threadData_t *threadData, modelica_metatype _inPartition, modelica_metatype _inRef1, modelica_metatype _inRef2);
typedef struct ConnectionGraph_addRootsToTable_rettype_s {
  modelica_metatype c1; /* outTable */
} ConnectionGraph_addRootsToTable_rettype;
DLLExport
ConnectionGraph_addRootsToTable_rettype omc_ConnectionGraph_addRootsToTable(threadData_t *threadData, modelica_metatype _inTable, modelica_metatype _inRoots, modelica_metatype _inFirstRoot);
#define boxptr_ConnectionGraph_addRootsToTable omc_ConnectionGraph_addRootsToTable

typedef struct ConnectionGraph_resultGraphWithRoots_rettype_s {
  modelica_metatype c1; /* outTable */
} ConnectionGraph_resultGraphWithRoots_rettype;
DLLExport
ConnectionGraph_resultGraphWithRoots_rettype omc_ConnectionGraph_resultGraphWithRoots(threadData_t *threadData, modelica_metatype _roots);
#define boxptr_ConnectionGraph_resultGraphWithRoots omc_ConnectionGraph_resultGraphWithRoots

typedef struct ConnectionGraph_addBranchesToTable_rettype_s {
  modelica_metatype c1; /* outTable */
} ConnectionGraph_addBranchesToTable_rettype;
DLLExport
ConnectionGraph_addBranchesToTable_rettype omc_ConnectionGraph_addBranchesToTable(threadData_t *threadData, modelica_metatype _inTable, modelica_metatype _inBranches);
#define boxptr_ConnectionGraph_addBranchesToTable omc_ConnectionGraph_addBranchesToTable

typedef struct ConnectionGraph_ord_rettype_s {
  modelica_boolean c1; /* outBoolean */
} ConnectionGraph_ord_rettype;
DLLExport
ConnectionGraph_ord_rettype omc_ConnectionGraph_ord(threadData_t *threadData, modelica_metatype _inEl1, modelica_metatype _inEl2);
typedef struct ConnectionGraph_ord_rettypeboxed_s {
  modelica_metatype c1; /* outBoolean */
} ConnectionGraph_ord_rettypeboxed;
DLLExport
ConnectionGraph_ord_rettypeboxed boxptr_ConnectionGraph_ord(threadData_t *threadData, modelica_metatype _inEl1, modelica_metatype _inEl2);
typedef struct ConnectionGraph_addPotentialRootsToTable_rettype_s {
  modelica_metatype c1; /* outTable */
  modelica_metatype c2; /* outRoots */
} ConnectionGraph_addPotentialRootsToTable_rettype;
DLLExport
ConnectionGraph_addPotentialRootsToTable_rettype omc_ConnectionGraph_addPotentialRootsToTable(threadData_t *threadData, modelica_metatype _inTable, modelica_metatype _inPotentialRoots, modelica_metatype _inRoots, modelica_metatype _inFirstRoot);
#define boxptr_ConnectionGraph_addPotentialRootsToTable omc_ConnectionGraph_addPotentialRootsToTable

typedef struct ConnectionGraph_addConnections_rettype_s {
  modelica_metatype c1; /* outTable */
  modelica_metatype c2; /* outConnectedConnections */
  modelica_metatype c3; /* outBrokenConnections */
} ConnectionGraph_addConnections_rettype;
DLLExport
ConnectionGraph_addConnections_rettype omc_ConnectionGraph_addConnections(threadData_t *threadData, modelica_metatype _inTable, modelica_metatype _inConnections);
#define boxptr_ConnectionGraph_addConnections omc_ConnectionGraph_addConnections

typedef struct ConnectionGraph_findResultGraph_rettype_s {
  modelica_metatype c1; /* outRoots */
  modelica_metatype c2; /* outConnectedConnections */
  modelica_metatype c3; /* outBrokenConnections */
} ConnectionGraph_findResultGraph_rettype;
DLLExport
ConnectionGraph_findResultGraph_rettype omc_ConnectionGraph_findResultGraph(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _modelNameQualified);
#define boxptr_ConnectionGraph_findResultGraph omc_ConnectionGraph_findResultGraph

typedef struct ConnectionGraph_orderConnectsGuidedByUser_rettype_s {
  modelica_metatype c1; /* outOrderedConnections */
} ConnectionGraph_orderConnectsGuidedByUser_rettype;
DLLExport
ConnectionGraph_orderConnectsGuidedByUser_rettype omc_ConnectionGraph_orderConnectsGuidedByUser(threadData_t *threadData, modelica_metatype _inConnections, modelica_metatype _inUserSelectedBreaking);
#define boxptr_ConnectionGraph_orderConnectsGuidedByUser omc_ConnectionGraph_orderConnectsGuidedByUser

typedef struct ConnectionGraph_printTupleStr_rettype_s {
  modelica_metatype c1; /* out */
} ConnectionGraph_printTupleStr_rettype;
DLLExport
ConnectionGraph_printTupleStr_rettype omc_ConnectionGraph_printTupleStr(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_ConnectionGraph_printTupleStr omc_ConnectionGraph_printTupleStr

typedef struct ConnectionGraph_makeTuple_rettype_s {
  modelica_metatype c1; /* outLst */
} ConnectionGraph_makeTuple_rettype;
DLLExport
ConnectionGraph_makeTuple_rettype omc_ConnectionGraph_makeTuple(threadData_t *threadData, modelica_metatype _inLstLst);
#define boxptr_ConnectionGraph_makeTuple omc_ConnectionGraph_makeTuple

typedef struct ConnectionGraph_printPotentialRootTuple_rettype_s {
  modelica_metatype c1; /* outStr */
} ConnectionGraph_printPotentialRootTuple_rettype;
DLLExport
ConnectionGraph_printPotentialRootTuple_rettype omc_ConnectionGraph_printPotentialRootTuple(threadData_t *threadData, modelica_metatype _potentialRoot);
#define boxptr_ConnectionGraph_printPotentialRootTuple omc_ConnectionGraph_printPotentialRootTuple

typedef struct ConnectionGraph_setRootDistance_rettype_s {
  modelica_metatype c1; /* orooted */
} ConnectionGraph_setRootDistance_rettype;
DLLExport
ConnectionGraph_setRootDistance_rettype omc_ConnectionGraph_setRootDistance(threadData_t *threadData, modelica_metatype _finalRoots, modelica_metatype _table, modelica_integer _distance, modelica_metatype _nextLevel, modelica_metatype _irooted);
typedef struct ConnectionGraph_setRootDistance_rettypeboxed_s {
  modelica_metatype c1; /* orooted */
} ConnectionGraph_setRootDistance_rettypeboxed;
DLLExport
ConnectionGraph_setRootDistance_rettypeboxed boxptr_ConnectionGraph_setRootDistance(threadData_t *threadData, modelica_metatype _finalRoots, modelica_metatype _table, modelica_metatype _distance, modelica_metatype _nextLevel, modelica_metatype _irooted);
typedef struct ConnectionGraph_addBranches_rettype_s {
  modelica_metatype c1; /* otable */
} ConnectionGraph_addBranches_rettype;
DLLExport
ConnectionGraph_addBranches_rettype omc_ConnectionGraph_addBranches(threadData_t *threadData, modelica_metatype _edge, modelica_metatype _itable);
#define boxptr_ConnectionGraph_addBranches omc_ConnectionGraph_addBranches

typedef struct ConnectionGraph_addConnectionsRooted_rettype_s {
  modelica_metatype c1; /* otable */
} ConnectionGraph_addConnectionsRooted_rettype;
DLLExport
ConnectionGraph_addConnectionsRooted_rettype omc_ConnectionGraph_addConnectionsRooted(threadData_t *threadData, modelica_metatype _connection, modelica_metatype _itable);
#define boxptr_ConnectionGraph_addConnectionsRooted omc_ConnectionGraph_addConnectionsRooted

typedef struct ConnectionGraph_addConnectionRooted_rettype_s {
  modelica_metatype c1; /* otable */
} ConnectionGraph_addConnectionRooted_rettype;
DLLExport
ConnectionGraph_addConnectionRooted_rettype omc_ConnectionGraph_addConnectionRooted(threadData_t *threadData, modelica_metatype _cref1, modelica_metatype _cref2, modelica_metatype _itable);
#define boxptr_ConnectionGraph_addConnectionRooted omc_ConnectionGraph_addConnectionRooted

typedef struct ConnectionGraph_evalRooted_rettype_s {
  modelica_metatype c1; /* outDae */
} ConnectionGraph_evalRooted_rettype;
DLLExport
ConnectionGraph_evalRooted_rettype omc_ConnectionGraph_evalRooted(threadData_t *threadData, modelica_metatype _inRoots, modelica_metatype _graph, modelica_metatype _inDae);
#define boxptr_ConnectionGraph_evalRooted omc_ConnectionGraph_evalRooted

typedef struct ConnectionGraph_evalRootedHelper_rettype_s {
  modelica_metatype c1; /* outRoots */
} ConnectionGraph_evalRootedHelper_rettype;
DLLExport
ConnectionGraph_evalRootedHelper_rettype omc_ConnectionGraph_evalRootedHelper(threadData_t *threadData, modelica_metatype _inRoots);
#define boxptr_ConnectionGraph_evalRootedHelper omc_ConnectionGraph_evalRootedHelper

typedef struct ConnectionGraph_getRooted_rettype_s {
  modelica_boolean c1; /* result */
} ConnectionGraph_getRooted_rettype;
DLLExport
ConnectionGraph_getRooted_rettype omc_ConnectionGraph_getRooted(threadData_t *threadData, modelica_metatype _cref1, modelica_metatype _cref2, modelica_metatype _rooted);
typedef struct ConnectionGraph_getRooted_rettypeboxed_s {
  modelica_metatype c1; /* result */
} ConnectionGraph_getRooted_rettypeboxed;
DLLExport
ConnectionGraph_getRooted_rettypeboxed boxptr_ConnectionGraph_getRooted(threadData_t *threadData, modelica_metatype _cref1, modelica_metatype _cref2, modelica_metatype _rooted);
typedef struct ConnectionGraph_getEdge_rettype_s {
  modelica_metatype c1; /* ocr */
} ConnectionGraph_getEdge_rettype;
DLLExport
ConnectionGraph_getEdge_rettype omc_ConnectionGraph_getEdge(threadData_t *threadData, modelica_metatype _cr, modelica_metatype _edges);
#define boxptr_ConnectionGraph_getEdge omc_ConnectionGraph_getEdge

typedef struct ConnectionGraph_getEdge1_rettype_s {
  modelica_metatype c1; /* ocr */
} ConnectionGraph_getEdge1_rettype;
DLLExport
ConnectionGraph_getEdge1_rettype omc_ConnectionGraph_getEdge1(threadData_t *threadData, modelica_metatype _cr, modelica_metatype _cref1, modelica_metatype _cref2);
#define boxptr_ConnectionGraph_getEdge1 omc_ConnectionGraph_getEdge1

typedef struct ConnectionGraph_evalIsRoot_rettype_s {
  modelica_metatype c1; /* outDae */
} ConnectionGraph_evalIsRoot_rettype;
DLLExport
ConnectionGraph_evalIsRoot_rettype omc_ConnectionGraph_evalIsRoot(threadData_t *threadData, modelica_metatype _inRoots, modelica_metatype _inDae);
#define boxptr_ConnectionGraph_evalIsRoot omc_ConnectionGraph_evalIsRoot

typedef struct ConnectionGraph_evalIsRootHelper_rettype_s {
  modelica_metatype c1; /* outRoots */
} ConnectionGraph_evalIsRootHelper_rettype;
DLLExport
ConnectionGraph_evalIsRootHelper_rettype omc_ConnectionGraph_evalIsRootHelper(threadData_t *threadData, modelica_metatype _inRoots);
#define boxptr_ConnectionGraph_evalIsRootHelper omc_ConnectionGraph_evalIsRootHelper

typedef struct ConnectionGraph_printConnectionStr_rettype_s {
  modelica_metatype c1; /* outStr */
} ConnectionGraph_printConnectionStr_rettype;
DLLExport
ConnectionGraph_printConnectionStr_rettype omc_ConnectionGraph_printConnectionStr(threadData_t *threadData, modelica_metatype _connectTuple, modelica_metatype _ty);
#define boxptr_ConnectionGraph_printConnectionStr omc_ConnectionGraph_printConnectionStr


DLLExport
void omc_ConnectionGraph_printEdges(threadData_t *threadData, modelica_metatype _inEdges);
#define boxptr_ConnectionGraph_printEdges omc_ConnectionGraph_printEdges


DLLExport
void omc_ConnectionGraph_printDaeEdges(threadData_t *threadData, modelica_metatype _inEdges);
#define boxptr_ConnectionGraph_printDaeEdges omc_ConnectionGraph_printDaeEdges


DLLExport
void omc_ConnectionGraph_printConnectionGraph(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_ConnectionGraph_printConnectionGraph omc_ConnectionGraph_printConnectionGraph

typedef struct ConnectionGraph_getDefiniteRoots_rettype_s {
  modelica_metatype c1; /* outResult */
} ConnectionGraph_getDefiniteRoots_rettype;
DLLExport
ConnectionGraph_getDefiniteRoots_rettype omc_ConnectionGraph_getDefiniteRoots(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_ConnectionGraph_getDefiniteRoots omc_ConnectionGraph_getDefiniteRoots

typedef struct ConnectionGraph_getPotentialRoots_rettype_s {
  modelica_metatype c1; /* outResult */
} ConnectionGraph_getPotentialRoots_rettype;
DLLExport
ConnectionGraph_getPotentialRoots_rettype omc_ConnectionGraph_getPotentialRoots(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_ConnectionGraph_getPotentialRoots omc_ConnectionGraph_getPotentialRoots

typedef struct ConnectionGraph_getBranches_rettype_s {
  modelica_metatype c1; /* outResult */
} ConnectionGraph_getBranches_rettype;
DLLExport
ConnectionGraph_getBranches_rettype omc_ConnectionGraph_getBranches(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_ConnectionGraph_getBranches omc_ConnectionGraph_getBranches

typedef struct ConnectionGraph_getConnections_rettype_s {
  modelica_metatype c1; /* outResult */
} ConnectionGraph_getConnections_rettype;
DLLExport
ConnectionGraph_getConnections_rettype omc_ConnectionGraph_getConnections(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_ConnectionGraph_getConnections omc_ConnectionGraph_getConnections

typedef struct ConnectionGraph_merge_rettype_s {
  modelica_metatype c1; /* outGraph */
} ConnectionGraph_merge_rettype;
DLLExport
ConnectionGraph_merge_rettype omc_ConnectionGraph_merge(threadData_t *threadData, modelica_metatype _inGraph1, modelica_metatype _inGraph2);
#define boxptr_ConnectionGraph_merge omc_ConnectionGraph_merge

typedef struct ConnectionGraph_graphVizEdge_rettype_s {
  modelica_metatype c1; /* out */
} ConnectionGraph_graphVizEdge_rettype;
DLLExport
ConnectionGraph_graphVizEdge_rettype omc_ConnectionGraph_graphVizEdge(threadData_t *threadData, modelica_metatype _inEdge);
#define boxptr_ConnectionGraph_graphVizEdge omc_ConnectionGraph_graphVizEdge

typedef struct ConnectionGraph_graphVizDaeEdge_rettype_s {
  modelica_metatype c1; /* out */
} ConnectionGraph_graphVizDaeEdge_rettype;
DLLExport
ConnectionGraph_graphVizDaeEdge_rettype omc_ConnectionGraph_graphVizDaeEdge(threadData_t *threadData, modelica_metatype _inDaeEdge, modelica_metatype _inBrokenDaeEdges);
#define boxptr_ConnectionGraph_graphVizDaeEdge omc_ConnectionGraph_graphVizDaeEdge

typedef struct ConnectionGraph_graphVizDefiniteRoot_rettype_s {
  modelica_metatype c1; /* out */
} ConnectionGraph_graphVizDefiniteRoot_rettype;
DLLExport
ConnectionGraph_graphVizDefiniteRoot_rettype omc_ConnectionGraph_graphVizDefiniteRoot(threadData_t *threadData, modelica_metatype _inDefiniteRoot, modelica_metatype _inFinalRoots);
#define boxptr_ConnectionGraph_graphVizDefiniteRoot omc_ConnectionGraph_graphVizDefiniteRoot

typedef struct ConnectionGraph_graphVizPotentialRoot_rettype_s {
  modelica_metatype c1; /* out */
} ConnectionGraph_graphVizPotentialRoot_rettype;
DLLExport
ConnectionGraph_graphVizPotentialRoot_rettype omc_ConnectionGraph_graphVizPotentialRoot(threadData_t *threadData, modelica_metatype _inPotentialRoot, modelica_metatype _inFinalRoots);
#define boxptr_ConnectionGraph_graphVizPotentialRoot omc_ConnectionGraph_graphVizPotentialRoot

typedef struct ConnectionGraph_generateGraphViz_rettype_s {
  modelica_metatype c1; /* brokenConnectsViaGraphViz */
} ConnectionGraph_generateGraphViz_rettype;
DLLExport
ConnectionGraph_generateGraphViz_rettype omc_ConnectionGraph_generateGraphViz(threadData_t *threadData, modelica_metatype _modelNameQualified, modelica_metatype _definiteRoots, modelica_metatype _potentialRoots, modelica_metatype _branches, modelica_metatype _connections, modelica_metatype _finalRoots, modelica_metatype _broken);
#define boxptr_ConnectionGraph_generateGraphViz omc_ConnectionGraph_generateGraphViz

typedef struct ConnectionGraph_showGraphViz_rettype_s {
  modelica_metatype c1; /* brokenConnectsViaGraphViz */
} ConnectionGraph_showGraphViz_rettype;
DLLExport
ConnectionGraph_showGraphViz_rettype omc_ConnectionGraph_showGraphViz(threadData_t *threadData, modelica_metatype _fileNameGraphViz, modelica_metatype _modelNameQualified);
#define boxptr_ConnectionGraph_showGraphViz omc_ConnectionGraph_showGraphViz

typedef struct ConnectionGraph_removeBrokenConnects_rettype_s {
  modelica_metatype c1; /* outConnects */
} ConnectionGraph_removeBrokenConnects_rettype;
DLLExport
ConnectionGraph_removeBrokenConnects_rettype omc_ConnectionGraph_removeBrokenConnects(threadData_t *threadData, modelica_metatype _inConnects, modelica_metatype _inConnected, modelica_metatype _inBroken);
#define boxptr_ConnectionGraph_removeBrokenConnects omc_ConnectionGraph_removeBrokenConnects

typedef struct ConnectionGraph_filterFromSet_rettype_s {
  modelica_metatype c1; /* filteredCrefs */
} ConnectionGraph_filterFromSet_rettype;
DLLExport
ConnectionGraph_filterFromSet_rettype omc_ConnectionGraph_filterFromSet(threadData_t *threadData, modelica_metatype _inConnects, modelica_metatype _inFilter, modelica_metatype _inAcc);
#define boxptr_ConnectionGraph_filterFromSet omc_ConnectionGraph_filterFromSet

typedef struct ConnectionGraph_removeFromConnects_rettype_s {
  modelica_metatype c1; /* outConnects */
} ConnectionGraph_removeFromConnects_rettype;
DLLExport
ConnectionGraph_removeFromConnects_rettype omc_ConnectionGraph_removeFromConnects(threadData_t *threadData, modelica_metatype _inConnects, modelica_metatype _inToRemove);
#define boxptr_ConnectionGraph_removeFromConnects omc_ConnectionGraph_removeFromConnects

typedef struct ConnectionGraph_addBrokenEqualityConstraintEquations_rettype_s {
  modelica_metatype c1; /* outDAE */
} ConnectionGraph_addBrokenEqualityConstraintEquations_rettype;
DLLExport
ConnectionGraph_addBrokenEqualityConstraintEquations_rettype omc_ConnectionGraph_addBrokenEqualityConstraintEquations(threadData_t *threadData, modelica_metatype _inDAE, modelica_metatype _inBroken);
#define boxptr_ConnectionGraph_addBrokenEqualityConstraintEquations omc_ConnectionGraph_addBrokenEqualityConstraintEquations
#ifdef __cplusplus
extern "C" {
#endif
#include "BaseHashTable.h"
#include "ComponentReference.h"
#include "ConnectUtil.h"
#include "ConnectionGraph.h"
#include "DAEUtil.h"
#include "Debug.h"
#include "ExpressionDump.h"
#include "Flags.h"
#include "HashTable.h"
#include "HashTable3.h"
#include "HashTableCG.h"
#include "IOStream.h"
#include "List.h"
#include "Settings.h"
#include "System.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

