#ifndef DumpGraphviz__H
#define DumpGraphviz__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Graphviz_Attribute_ATTR__desc;
extern struct record_description Graphviz_Node_LNODE__desc;
extern struct record_description Graphviz_Node_NODE__desc;

DLLExport
void omc_DumpGraphviz_dump(threadData_t *threadData, modelica_metatype _p);
#define boxptr_DumpGraphviz_dump omc_DumpGraphviz_dump

typedef struct DumpGraphviz_buildGraphviz_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_buildGraphviz_rettype;
DLLExport
DumpGraphviz_buildGraphviz_rettype omc_DumpGraphviz_buildGraphviz(threadData_t *threadData, modelica_metatype _inProgram);
#define boxptr_DumpGraphviz_buildGraphviz omc_DumpGraphviz_buildGraphviz

typedef struct DumpGraphviz_printClasses_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printClasses_rettype;
DLLExport
DumpGraphviz_printClasses_rettype omc_DumpGraphviz_printClasses(threadData_t *threadData, modelica_metatype _inAbsynClassLst);
#define boxptr_DumpGraphviz_printClasses omc_DumpGraphviz_printClasses

typedef struct DumpGraphviz_printClass_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printClass_rettype;
DLLExport
DumpGraphviz_printClass_rettype omc_DumpGraphviz_printClass(threadData_t *threadData, modelica_metatype _inClass);
#define boxptr_DumpGraphviz_printClass omc_DumpGraphviz_printClass

typedef struct DumpGraphviz_printParts_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printParts_rettype;
DLLExport
DumpGraphviz_printParts_rettype omc_DumpGraphviz_printParts(threadData_t *threadData, modelica_metatype _inAbsynClassPartLst);
#define boxptr_DumpGraphviz_printParts omc_DumpGraphviz_printParts

typedef struct DumpGraphviz_printClassPart_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printClassPart_rettype;
DLLExport
DumpGraphviz_printClassPart_rettype omc_DumpGraphviz_printClassPart(threadData_t *threadData, modelica_metatype _inClassPart);
#define boxptr_DumpGraphviz_printClassPart omc_DumpGraphviz_printClassPart

typedef struct DumpGraphviz_printElementitems_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printElementitems_rettype;
DLLExport
DumpGraphviz_printElementitems_rettype omc_DumpGraphviz_printElementitems(threadData_t *threadData, modelica_metatype _inAbsynElementItemLst);
#define boxptr_DumpGraphviz_printElementitems omc_DumpGraphviz_printElementitems

typedef struct DumpGraphviz_makeBoolAttr_rettype_s {
  modelica_metatype c1; /* outAttribute */
} DumpGraphviz_makeBoolAttr_rettype;
DLLExport
DumpGraphviz_makeBoolAttr_rettype omc_DumpGraphviz_makeBoolAttr(threadData_t *threadData, modelica_metatype _str, modelica_boolean _flag);
typedef struct DumpGraphviz_makeBoolAttr_rettypeboxed_s {
  modelica_metatype c1; /* outAttribute */
} DumpGraphviz_makeBoolAttr_rettypeboxed;
DLLExport
DumpGraphviz_makeBoolAttr_rettypeboxed boxptr_DumpGraphviz_makeBoolAttr(threadData_t *threadData, modelica_metatype _str, modelica_metatype _flag);
typedef struct DumpGraphviz_makeLeaf_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_makeLeaf_rettype;
DLLExport
DumpGraphviz_makeLeaf_rettype omc_DumpGraphviz_makeLeaf(threadData_t *threadData, modelica_metatype _str, modelica_metatype _al);
#define boxptr_DumpGraphviz_makeLeaf omc_DumpGraphviz_makeLeaf

typedef struct DumpGraphviz_printElement_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printElement_rettype;
DLLExport
DumpGraphviz_printElement_rettype omc_DumpGraphviz_printElement(threadData_t *threadData, modelica_metatype _inElement);
#define boxptr_DumpGraphviz_printElement omc_DumpGraphviz_printElement

typedef struct DumpGraphviz_printPath_rettype_s {
  modelica_metatype c1; /* pn */
} DumpGraphviz_printPath_rettype;
DLLExport
DumpGraphviz_printPath_rettype omc_DumpGraphviz_printPath(threadData_t *threadData, modelica_metatype _p);
#define boxptr_DumpGraphviz_printPath omc_DumpGraphviz_printPath

typedef struct DumpGraphviz_printElementspec_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printElementspec_rettype;
DLLExport
DumpGraphviz_printElementspec_rettype omc_DumpGraphviz_printElementspec(threadData_t *threadData, modelica_metatype _inElementSpec);
#define boxptr_DumpGraphviz_printElementspec omc_DumpGraphviz_printElementspec

typedef struct DumpGraphviz_printComponents_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printComponents_rettype;
DLLExport
DumpGraphviz_printComponents_rettype omc_DumpGraphviz_printComponents(threadData_t *threadData, modelica_metatype _inAbsynComponentItemLst);
#define boxptr_DumpGraphviz_printComponents omc_DumpGraphviz_printComponents

typedef struct DumpGraphviz_printComponentitem_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printComponentitem_rettype;
DLLExport
DumpGraphviz_printComponentitem_rettype omc_DumpGraphviz_printComponentitem(threadData_t *threadData, modelica_metatype _inComponentItem);
#define boxptr_DumpGraphviz_printComponentitem omc_DumpGraphviz_printComponentitem

typedef struct DumpGraphviz_printEquations_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printEquations_rettype;
DLLExport
DumpGraphviz_printEquations_rettype omc_DumpGraphviz_printEquations(threadData_t *threadData, modelica_metatype _inAbsynEquationItemLst);
#define boxptr_DumpGraphviz_printEquations omc_DumpGraphviz_printEquations

typedef struct DumpGraphviz_printEquation_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printEquation_rettype;
DLLExport
DumpGraphviz_printEquation_rettype omc_DumpGraphviz_printEquation(threadData_t *threadData, modelica_metatype _inEquation);
#define boxptr_DumpGraphviz_printEquation omc_DumpGraphviz_printEquation

typedef struct DumpGraphviz_printAlgorithms_rettype_s {
  modelica_metatype c1; /* outNodeLst */
} DumpGraphviz_printAlgorithms_rettype;
DLLExport
DumpGraphviz_printAlgorithms_rettype omc_DumpGraphviz_printAlgorithms(threadData_t *threadData, modelica_metatype _inAbsynAlgorithmItemLst);
#define boxptr_DumpGraphviz_printAlgorithms omc_DumpGraphviz_printAlgorithms

typedef struct DumpGraphviz_printAlgorithmitem_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printAlgorithmitem_rettype;
DLLExport
DumpGraphviz_printAlgorithmitem_rettype omc_DumpGraphviz_printAlgorithmitem(threadData_t *threadData, modelica_metatype _inAlgorithmItem);
#define boxptr_DumpGraphviz_printAlgorithmitem omc_DumpGraphviz_printAlgorithmitem

typedef struct DumpGraphviz_printAlgorithm_rettype_s {
  modelica_metatype c1; /* outNode */
} DumpGraphviz_printAlgorithm_rettype;
DLLExport
DumpGraphviz_printAlgorithm_rettype omc_DumpGraphviz_printAlgorithm(threadData_t *threadData, modelica_metatype _inAlgorithm);
#define boxptr_DumpGraphviz_printAlgorithm omc_DumpGraphviz_printAlgorithm

typedef struct DumpGraphviz_variabilitySymbol_rettype_s {
  modelica_metatype c1; /* outString */
} DumpGraphviz_variabilitySymbol_rettype;
DLLExport
DumpGraphviz_variabilitySymbol_rettype omc_DumpGraphviz_variabilitySymbol(threadData_t *threadData, modelica_metatype _inVariability);
#define boxptr_DumpGraphviz_variabilitySymbol omc_DumpGraphviz_variabilitySymbol

typedef struct DumpGraphviz_directionSymbol_rettype_s {
  modelica_metatype c1; /* outString */
} DumpGraphviz_directionSymbol_rettype;
DLLExport
DumpGraphviz_directionSymbol_rettype omc_DumpGraphviz_directionSymbol(threadData_t *threadData, modelica_metatype _inDirection);
#define boxptr_DumpGraphviz_directionSymbol omc_DumpGraphviz_directionSymbol
#ifdef __cplusplus
extern "C" {
#endif
#include "Absyn.h"
#include "Dump.h"
#include "DumpGraphviz.h"
#include "Graphviz.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

