#ifndef Error__H
#define Error__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Error_Severity_NOTIFICATION__desc;
extern struct record_description Error_Severity_WARNING__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
extern struct record_description Util_TranslatableContent_notrans__desc;

DLLExport
void omc_Error_updateCurrentComponent(threadData_t *threadData, modelica_metatype _component, modelica_metatype _info);
#define boxptr_Error_updateCurrentComponent omc_Error_updateCurrentComponent


DLLExport
void omc_Error_addMessage(threadData_t *threadData, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens);
#define boxptr_Error_addMessage omc_Error_addMessage


DLLExport
void omc_Error_addSourceMessage(threadData_t *threadData, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens, modelica_metatype _inInfo);
#define boxptr_Error_addSourceMessage omc_Error_addSourceMessage


DLLExport
void omc_Error_addMultiSourceMessage(threadData_t *threadData, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens, modelica_metatype _inInfo);
#define boxptr_Error_addMultiSourceMessage omc_Error_addMultiSourceMessage


DLLExport
void omc_Error_addMessageOrSourceMessage(threadData_t *threadData, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens, modelica_metatype _inInfoOpt);
#define boxptr_Error_addMessageOrSourceMessage omc_Error_addMessageOrSourceMessage

typedef struct Error_printMessagesStr_rettype_s {
  modelica_metatype c1; /* res */
} Error_printMessagesStr_rettype;
DLLExport
Error_printMessagesStr_rettype omc_Error_printMessagesStr(threadData_t *threadData);
#define boxptr_Error_printMessagesStr omc_Error_printMessagesStr

typedef struct Error_printErrorsNoWarning_rettype_s {
  modelica_metatype c1; /* res */
} Error_printErrorsNoWarning_rettype;
DLLExport
Error_printErrorsNoWarning_rettype omc_Error_printErrorsNoWarning(threadData_t *threadData);
#define boxptr_Error_printErrorsNoWarning omc_Error_printErrorsNoWarning

typedef struct Error_printMessagesStrLst_rettype_s {
  modelica_metatype c1; /* outStringLst */
} Error_printMessagesStrLst_rettype;
DLLExport
Error_printMessagesStrLst_rettype omc_Error_printMessagesStrLst(threadData_t *threadData);
#define boxptr_Error_printMessagesStrLst omc_Error_printMessagesStrLst

typedef struct Error_printMessagesStrLstType_rettype_s {
  modelica_metatype c1; /* outStringLst */
} Error_printMessagesStrLstType_rettype;
DLLExport
Error_printMessagesStrLstType_rettype omc_Error_printMessagesStrLstType(threadData_t *threadData, modelica_metatype _inMessageType);
#define boxptr_Error_printMessagesStrLstType omc_Error_printMessagesStrLstType

typedef struct Error_printMessagesStrLstSeverity_rettype_s {
  modelica_metatype c1; /* outStringLst */
} Error_printMessagesStrLstSeverity_rettype;
DLLExport
Error_printMessagesStrLstSeverity_rettype omc_Error_printMessagesStrLstSeverity(threadData_t *threadData, modelica_metatype _inSeverity);
#define boxptr_Error_printMessagesStrLstSeverity omc_Error_printMessagesStrLstSeverity


DLLExport
void omc_Error_clearMessages(threadData_t *threadData);
#define boxptr_Error_clearMessages omc_Error_clearMessages

typedef struct Error_getNumMessages_rettype_s {
  modelica_integer c1; /* num */
} Error_getNumMessages_rettype;
DLLExport
Error_getNumMessages_rettype omc_Error_getNumMessages(threadData_t *threadData);
typedef struct Error_getNumMessages_rettypeboxed_s {
  modelica_metatype c1; /* num */
} Error_getNumMessages_rettypeboxed;
DLLExport
Error_getNumMessages_rettypeboxed boxptr_Error_getNumMessages(threadData_t *threadData);
typedef struct Error_getNumErrorMessages_rettype_s {
  modelica_integer c1; /* num */
} Error_getNumErrorMessages_rettype;
DLLExport
Error_getNumErrorMessages_rettype omc_Error_getNumErrorMessages(threadData_t *threadData);
typedef struct Error_getNumErrorMessages_rettypeboxed_s {
  modelica_metatype c1; /* num */
} Error_getNumErrorMessages_rettypeboxed;
DLLExport
Error_getNumErrorMessages_rettypeboxed boxptr_Error_getNumErrorMessages(threadData_t *threadData);
typedef struct Error_getMessages_rettype_s {
  modelica_metatype c1; /* res */
} Error_getMessages_rettype;
DLLExport
Error_getMessages_rettype omc_Error_getMessages(threadData_t *threadData);
#define boxptr_Error_getMessages omc_Error_getMessages

typedef struct Error_getMessagesStrType_rettype_s {
  modelica_metatype c1; /* outString */
} Error_getMessagesStrType_rettype;
DLLExport
Error_getMessagesStrType_rettype omc_Error_getMessagesStrType(threadData_t *threadData, modelica_metatype _inMessageType);
#define boxptr_Error_getMessagesStrType omc_Error_getMessagesStrType

typedef struct Error_getMessagesStrSeverity_rettype_s {
  modelica_metatype c1; /* outString */
} Error_getMessagesStrSeverity_rettype;
DLLExport
Error_getMessagesStrSeverity_rettype omc_Error_getMessagesStrSeverity(threadData_t *threadData, modelica_metatype _inSeverity);
#define boxptr_Error_getMessagesStrSeverity omc_Error_getMessagesStrSeverity

typedef struct Error_messageTypeStr_rettype_s {
  modelica_metatype c1; /* outString */
} Error_messageTypeStr_rettype;
DLLExport
Error_messageTypeStr_rettype omc_Error_messageTypeStr(threadData_t *threadData, modelica_metatype _inMessageType);
#define boxptr_Error_messageTypeStr omc_Error_messageTypeStr

typedef struct Error_severityStr_rettype_s {
  modelica_metatype c1; /* outString */
} Error_severityStr_rettype;
DLLExport
Error_severityStr_rettype omc_Error_severityStr(threadData_t *threadData, modelica_metatype _inSeverity);
#define boxptr_Error_severityStr omc_Error_severityStr

typedef struct Error_selectString_rettype_s {
  modelica_metatype c1; /* outString */
} Error_selectString_rettype;
DLLExport
Error_selectString_rettype omc_Error_selectString(threadData_t *threadData, modelica_boolean _inBoolean1, modelica_metatype _inString2, modelica_metatype _inString3);
typedef struct Error_selectString_rettypeboxed_s {
  modelica_metatype c1; /* outString */
} Error_selectString_rettypeboxed;
DLLExport
Error_selectString_rettypeboxed boxptr_Error_selectString(threadData_t *threadData, modelica_metatype _inBoolean1, modelica_metatype _inString2, modelica_metatype _inString3);
typedef struct Error_infoStr_rettype_s {
  modelica_metatype c1; /* str */
} Error_infoStr_rettype;
DLLExport
Error_infoStr_rettype omc_Error_infoStr(threadData_t *threadData, modelica_metatype _info);
#define boxptr_Error_infoStr omc_Error_infoStr


DLLExport
void omc_Error_assertion(threadData_t *threadData, modelica_boolean _b, modelica_metatype _message, modelica_metatype _info);

DLLExport
void boxptr_Error_assertion(threadData_t *threadData, modelica_metatype _b, modelica_metatype _message, modelica_metatype _info);

DLLExport
void omc_Error_assertionOrAddSourceMessage(threadData_t *threadData, modelica_boolean _inCond, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens, modelica_metatype _inInfo);

DLLExport
void boxptr_Error_assertionOrAddSourceMessage(threadData_t *threadData, modelica_metatype _inCond, modelica_metatype _inErrorMsg, modelica_metatype _inMessageTokens, modelica_metatype _inInfo);

DLLExport
void omc_Error_failOnErrorMsg(threadData_t *threadData, modelica_metatype _inMessage);
#define boxptr_Error_failOnErrorMsg omc_Error_failOnErrorMsg


DLLExport
void omc_Error_addCompilerWarning(threadData_t *threadData, modelica_metatype _message);
#define boxptr_Error_addCompilerWarning omc_Error_addCompilerWarning
#ifdef __cplusplus
extern "C" {
#endif
#include "Error.h"
#include "ErrorExt.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

