#ifndef ErrorExt__H
#define ErrorExt__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif


DLLExport
void omc_ErrorExt_updateCurrentComponent(threadData_t *threadData, modelica_metatype _str, modelica_boolean _writeable, modelica_metatype _fileName, modelica_integer _rowstart, modelica_integer _rowend, modelica_integer _colstart, modelica_integer _colend);

DLLExport
void boxptr_ErrorExt_updateCurrentComponent(threadData_t *threadData, modelica_metatype _str, modelica_metatype _writeable, modelica_metatype _fileName, modelica_metatype _rowstart, modelica_metatype _rowend, modelica_metatype _colstart, modelica_metatype _colend);

extern void ErrorImpl__updateCurrentComponent(const char* /*_str*/, int /*_writeable*/, const char* /*_fileName*/, int /*_rowstart*/, int /*_rowend*/, int /*_colstart*/, int /*_colend*/);

DLLExport
void omc_ErrorExt_addMessage(threadData_t *threadData, modelica_integer _id, modelica_metatype _msg_type, modelica_metatype _msg_severity, modelica_metatype _msg, modelica_metatype _msg_tokens);

DLLExport
void boxptr_ErrorExt_addMessage(threadData_t *threadData, modelica_metatype _id, modelica_metatype _msg_type, modelica_metatype _msg_severity, modelica_metatype _msg, modelica_metatype _msg_tokens);

extern void Error_addMessage(int /*_id*/, modelica_metatype /*_msg_type*/, modelica_metatype /*_msg_severity*/, const char* /*_msg*/, modelica_metatype /*_msg_tokens*/);

DLLExport
void omc_ErrorExt_addSourceMessage(threadData_t *threadData, modelica_integer _id, modelica_metatype _msg_type, modelica_metatype _msg_severity, modelica_integer _sline, modelica_integer _scol, modelica_integer _eline, modelica_integer _ecol, modelica_boolean _read_only, modelica_metatype _filename, modelica_metatype _msg, modelica_metatype _tokens);

DLLExport
void boxptr_ErrorExt_addSourceMessage(threadData_t *threadData, modelica_metatype _id, modelica_metatype _msg_type, modelica_metatype _msg_severity, modelica_metatype _sline, modelica_metatype _scol, modelica_metatype _eline, modelica_metatype _ecol, modelica_metatype _read_only, modelica_metatype _filename, modelica_metatype _msg, modelica_metatype _tokens);

extern void Error_addSourceMessage(int /*_id*/, modelica_metatype /*_msg_type*/, modelica_metatype /*_msg_severity*/, int /*_sline*/, int /*_scol*/, int /*_eline*/, int /*_ecol*/, int /*_read_only*/, const char* /*_filename*/, const char* /*_msg*/, modelica_metatype /*_tokens*/);
typedef struct ErrorExt_printMessagesStr_rettype_s {
  modelica_metatype c1; /* outString */
} ErrorExt_printMessagesStr_rettype;
DLLExport
ErrorExt_printMessagesStr_rettype omc_ErrorExt_printMessagesStr(threadData_t *threadData);
#define boxptr_ErrorExt_printMessagesStr omc_ErrorExt_printMessagesStr

extern const char* Error_printMessagesStr();
typedef struct ErrorExt_getNumMessages_rettype_s {
  modelica_integer c1; /* num */
} ErrorExt_getNumMessages_rettype;
DLLExport
ErrorExt_getNumMessages_rettype omc_ErrorExt_getNumMessages(threadData_t *threadData);
typedef struct ErrorExt_getNumMessages_rettypeboxed_s {
  modelica_metatype c1; /* num */
} ErrorExt_getNumMessages_rettypeboxed;
DLLExport
ErrorExt_getNumMessages_rettypeboxed boxptr_ErrorExt_getNumMessages(threadData_t *threadData);

extern int Error_getNumMessages();
typedef struct ErrorExt_getNumErrorMessages_rettype_s {
  modelica_integer c1; /* num */
} ErrorExt_getNumErrorMessages_rettype;
DLLExport
ErrorExt_getNumErrorMessages_rettype omc_ErrorExt_getNumErrorMessages(threadData_t *threadData);
typedef struct ErrorExt_getNumErrorMessages_rettypeboxed_s {
  modelica_metatype c1; /* num */
} ErrorExt_getNumErrorMessages_rettypeboxed;
DLLExport
ErrorExt_getNumErrorMessages_rettypeboxed boxptr_ErrorExt_getNumErrorMessages(threadData_t *threadData);

extern int ErrorImpl__getNumErrorMessages();
typedef struct ErrorExt_getMessages_rettype_s {
  modelica_metatype c1; /* res */
} ErrorExt_getMessages_rettype;
DLLExport
ErrorExt_getMessages_rettype omc_ErrorExt_getMessages(threadData_t *threadData);
#define boxptr_ErrorExt_getMessages omc_ErrorExt_getMessages

extern modelica_metatype Error_getMessages();

DLLExport
void omc_ErrorExt_clearMessages(threadData_t *threadData);
#define boxptr_ErrorExt_clearMessages omc_ErrorExt_clearMessages

extern void ErrorImpl__clearMessages();

DLLExport
void omc_ErrorExt_setCheckpoint(threadData_t *threadData, modelica_metatype _id);
#define boxptr_ErrorExt_setCheckpoint omc_ErrorExt_setCheckpoint

extern void ErrorImpl__setCheckpoint(const char* /*_id*/);

DLLExport
void omc_ErrorExt_delCheckpoint(threadData_t *threadData, modelica_metatype _id);
#define boxptr_ErrorExt_delCheckpoint omc_ErrorExt_delCheckpoint

extern void ErrorImpl__delCheckpoint(const char* /*_id*/);
typedef struct ErrorExt_printErrorsNoWarning_rettype_s {
  modelica_metatype c1; /* outString */
} ErrorExt_printErrorsNoWarning_rettype;
DLLExport
ErrorExt_printErrorsNoWarning_rettype omc_ErrorExt_printErrorsNoWarning(threadData_t *threadData);
#define boxptr_ErrorExt_printErrorsNoWarning omc_ErrorExt_printErrorsNoWarning

extern const char* Error_printErrorsNoWarning();

DLLExport
void omc_ErrorExt_rollBack(threadData_t *threadData, modelica_metatype _id);
#define boxptr_ErrorExt_rollBack omc_ErrorExt_rollBack

extern void ErrorImpl__rollBack(const char* /*_id*/);
typedef struct ErrorExt_isTopCheckpoint_rettype_s {
  modelica_boolean c1; /* isThere */
} ErrorExt_isTopCheckpoint_rettype;
DLLExport
ErrorExt_isTopCheckpoint_rettype omc_ErrorExt_isTopCheckpoint(threadData_t *threadData, modelica_metatype _id);
typedef struct ErrorExt_isTopCheckpoint_rettypeboxed_s {
  modelica_metatype c1; /* isThere */
} ErrorExt_isTopCheckpoint_rettypeboxed;
DLLExport
ErrorExt_isTopCheckpoint_rettypeboxed boxptr_ErrorExt_isTopCheckpoint(threadData_t *threadData, modelica_metatype _id);

extern int ErrorImpl__isTopCheckpoint(const char* /*_id*/);

DLLExport
void omc_ErrorExt_setShowErrorMessages(threadData_t *threadData, modelica_boolean _inShow);

DLLExport
void boxptr_ErrorExt_setShowErrorMessages(threadData_t *threadData, modelica_metatype _inShow);

extern void Error_setShowErrorMessages(int /*_inShow*/);

#ifdef __cplusplus
}
#endif
#endif

