#ifndef Graph__H
#define Graph__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
typedef struct Graph_buildGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_buildGraph_rettype;
DLLExport
Graph_buildGraph_rettype omc_Graph_buildGraph(threadData_t *threadData, modelica_metatype _inNodes, modelica_fnptr inEdgeFunc, modelica_metatype _inEdgeArg);
#define boxptr_Graph_buildGraph omc_Graph_buildGraph

typedef struct Graph_emptyGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_emptyGraph_rettype;
DLLExport
Graph_emptyGraph_rettype omc_Graph_emptyGraph(threadData_t *threadData, modelica_metatype _inNodes);
#define boxptr_Graph_emptyGraph omc_Graph_emptyGraph

typedef struct Graph_emptyGraphHelper_rettype_s {
  modelica_metatype c1; /* out */
} Graph_emptyGraphHelper_rettype;
DLLExport
Graph_emptyGraphHelper_rettype omc_Graph_emptyGraphHelper(threadData_t *threadData, modelica_metatype _nt);
#define boxptr_Graph_emptyGraphHelper omc_Graph_emptyGraphHelper

typedef struct Graph_topologicalSort_rettype_s {
  modelica_metatype c1; /* outNodes */
  modelica_metatype c2; /* outRemainingGraph */
} Graph_topologicalSort_rettype;
DLLExport
Graph_topologicalSort_rettype omc_Graph_topologicalSort(threadData_t *threadData, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_topologicalSort omc_Graph_topologicalSort

typedef struct Graph_topologicalSort2_rettype_s {
  modelica_metatype c1; /* outNodes */
  modelica_metatype c2; /* outRemainingGraph */
} Graph_topologicalSort2_rettype;
DLLExport
Graph_topologicalSort2_rettype omc_Graph_topologicalSort2(threadData_t *threadData, modelica_metatype _inStartNodes, modelica_metatype _inRestNodes, modelica_metatype _inAccumNodes, modelica_fnptr inEqualFunc);
#define boxptr_Graph_topologicalSort2 omc_Graph_topologicalSort2

typedef struct Graph_hasOutgoingEdges_rettype_s {
  modelica_boolean c1; /* outHasOutEdges */
} Graph_hasOutgoingEdges_rettype;
DLLExport
Graph_hasOutgoingEdges_rettype omc_Graph_hasOutgoingEdges(threadData_t *threadData, modelica_metatype _inNode);
typedef struct Graph_hasOutgoingEdges_rettypeboxed_s {
  modelica_metatype c1; /* outHasOutEdges */
} Graph_hasOutgoingEdges_rettypeboxed;
DLLExport
Graph_hasOutgoingEdges_rettypeboxed boxptr_Graph_hasOutgoingEdges(threadData_t *threadData, modelica_metatype _inNode);
typedef struct Graph_removeEdge_rettype_s {
  modelica_metatype c1; /* outNode */
} Graph_removeEdge_rettype;
DLLExport
Graph_removeEdge_rettype omc_Graph_removeEdge(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inRemovedNode, modelica_fnptr inEqualFunc);
#define boxptr_Graph_removeEdge omc_Graph_removeEdge

typedef struct Graph_findCycles_rettype_s {
  modelica_metatype c1; /* outCycles */
} Graph_findCycles_rettype;
DLLExport
Graph_findCycles_rettype omc_Graph_findCycles(threadData_t *threadData, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_findCycles omc_Graph_findCycles

typedef struct Graph_findCycles2_rettype_s {
  modelica_metatype c1; /* outCycles */
} Graph_findCycles2_rettype;
DLLExport
Graph_findCycles2_rettype omc_Graph_findCycles2(threadData_t *threadData, modelica_metatype _inNodes, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_findCycles2 omc_Graph_findCycles2

typedef struct Graph_findCycleForNode_rettype_s {
  modelica_metatype c1; /* outCycle */
} Graph_findCycleForNode_rettype;
DLLExport
Graph_findCycleForNode_rettype omc_Graph_findCycleForNode(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inGraph, modelica_metatype _inVisitedNodes, modelica_fnptr inEqualFunc);
#define boxptr_Graph_findCycleForNode omc_Graph_findCycleForNode

typedef struct Graph_findCycleForNode2_rettype_s {
  modelica_metatype c1; /* outCycle */
} Graph_findCycleForNode2_rettype;
DLLExport
Graph_findCycleForNode2_rettype omc_Graph_findCycleForNode2(threadData_t *threadData, modelica_metatype _inNodes, modelica_metatype _inGraph, modelica_metatype _inVisitedNodes, modelica_fnptr inEqualFunc);
#define boxptr_Graph_findCycleForNode2 omc_Graph_findCycleForNode2

typedef struct Graph_findNodeInGraph_rettype_s {
  modelica_metatype c1; /* outNode */
} Graph_findNodeInGraph_rettype;
DLLExport
Graph_findNodeInGraph_rettype omc_Graph_findNodeInGraph(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_findNodeInGraph omc_Graph_findNodeInGraph

typedef struct Graph_findIndexofNodeInGraph_rettype_s {
  modelica_integer c1; /* outIndex */
} Graph_findIndexofNodeInGraph_rettype;
DLLExport
Graph_findIndexofNodeInGraph_rettype omc_Graph_findIndexofNodeInGraph(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inGraph, modelica_fnptr inEqualFunc, modelica_integer _inIndex);
typedef struct Graph_findIndexofNodeInGraph_rettypeboxed_s {
  modelica_metatype c1; /* outIndex */
} Graph_findIndexofNodeInGraph_rettypeboxed;
DLLExport
Graph_findIndexofNodeInGraph_rettypeboxed boxptr_Graph_findIndexofNodeInGraph(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inGraph, modelica_fnptr inEqualFunc, modelica_metatype _inIndex);
typedef struct Graph_removeNodesFromGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_removeNodesFromGraph_rettype;
DLLExport
Graph_removeNodesFromGraph_rettype omc_Graph_removeNodesFromGraph(threadData_t *threadData, modelica_metatype _inNodes, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_removeNodesFromGraph omc_Graph_removeNodesFromGraph

typedef struct Graph_transposeGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_transposeGraph_rettype;
DLLExport
Graph_transposeGraph_rettype omc_Graph_transposeGraph(threadData_t *threadData, modelica_metatype _intmpGraph, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_transposeGraph omc_Graph_transposeGraph

typedef struct Graph_insertNodetoGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_insertNodetoGraph_rettype;
DLLExport
Graph_insertNodetoGraph_rettype omc_Graph_insertNodetoGraph(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inVertex, modelica_fnptr inEqualFunc, modelica_metatype _inGraph);
#define boxptr_Graph_insertNodetoGraph omc_Graph_insertNodetoGraph

typedef struct Graph_allReachableNodes_rettype_s {
  modelica_metatype c1; /* reachableNodes */
} Graph_allReachableNodes_rettype;
DLLExport
Graph_allReachableNodes_rettype omc_Graph_allReachableNodes(threadData_t *threadData, modelica_metatype _intmpstorage, modelica_metatype _inGraph, modelica_fnptr inEqualFunc);
#define boxptr_Graph_allReachableNodes omc_Graph_allReachableNodes

typedef struct Graph_partialDistance2color_rettype_s {
  modelica_metatype c1; /* outColored */
} Graph_partialDistance2color_rettype;
DLLExport
Graph_partialDistance2color_rettype omc_Graph_partialDistance2color(threadData_t *threadData, modelica_metatype _toColorNodes, modelica_metatype _inforbiddenColor, modelica_metatype _inColors, modelica_metatype _inGraph, modelica_metatype _inGraphT, modelica_metatype _inColored, modelica_fnptr inEqualFunc, modelica_fnptr inPrintFunc);
#define boxptr_Graph_partialDistance2color omc_Graph_partialDistance2color

typedef struct Graph_addForbiddenColors_rettype_s {
  modelica_metatype c1; /* outForbiddenColor */
} Graph_addForbiddenColors_rettype;
DLLExport
Graph_addForbiddenColors_rettype omc_Graph_addForbiddenColors(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inNodes, modelica_metatype _inColored, modelica_metatype _inForbiddenColor, modelica_metatype _inGraph, modelica_fnptr inEqualFunc, modelica_fnptr inPrintFunc);
#define boxptr_Graph_addForbiddenColors omc_Graph_addForbiddenColors

typedef struct Graph_getArrayElem_rettype_s {
  modelica_metatype c1; /* outElem */
} Graph_getArrayElem_rettype;
DLLExport
Graph_getArrayElem_rettype omc_Graph_getArrayElem(threadData_t *threadData, modelica_integer _inIndex, modelica_metatype _inArray);
typedef struct Graph_getArrayElem_rettypeboxed_s {
  modelica_metatype c1; /* outElem */
} Graph_getArrayElem_rettypeboxed;
DLLExport
Graph_getArrayElem_rettypeboxed boxptr_Graph_getArrayElem(threadData_t *threadData, modelica_metatype _inIndex, modelica_metatype _inArray);
typedef struct Graph_cleanOptList_rettype_s {
  modelica_metatype c1; /* outList */
} Graph_cleanOptList_rettype;
DLLExport
Graph_cleanOptList_rettype omc_Graph_cleanOptList(threadData_t *threadData, modelica_metatype _inListOption);
#define boxptr_Graph_cleanOptList omc_Graph_cleanOptList


DLLExport
void omc_Graph_arrayUpdateListAppend(threadData_t *threadData, modelica_integer _inIndex, modelica_metatype _inArray, modelica_metatype _inNode);

DLLExport
void boxptr_Graph_arrayUpdateListAppend(threadData_t *threadData, modelica_metatype _inIndex, modelica_metatype _inArray, modelica_metatype _inNode);
typedef struct Graph_arrayElemetGtZero_rettype_s {
  modelica_boolean c1; /* outBoolean */
} Graph_arrayElemetGtZero_rettype;
DLLExport
Graph_arrayElemetGtZero_rettype omc_Graph_arrayElemetGtZero(threadData_t *threadData, modelica_integer _inIndex, modelica_metatype _inArray);
typedef struct Graph_arrayElemetGtZero_rettypeboxed_s {
  modelica_metatype c1; /* outBoolean */
} Graph_arrayElemetGtZero_rettypeboxed;
DLLExport
Graph_arrayElemetGtZero_rettypeboxed boxptr_Graph_arrayElemetGtZero(threadData_t *threadData, modelica_metatype _inIndex, modelica_metatype _inArray);
typedef struct Graph_arrayFindMinColorIndex_rettype_s {
  modelica_integer c1; /* outColor */
} Graph_arrayFindMinColorIndex_rettype;
DLLExport
Graph_arrayFindMinColorIndex_rettype omc_Graph_arrayFindMinColorIndex(threadData_t *threadData, modelica_metatype _inForbiddenColor, modelica_metatype _inNode, modelica_integer _inIndex, modelica_integer _inmaxIndex, modelica_fnptr inEqualFunc, modelica_fnptr inPrintFunc);
typedef struct Graph_arrayFindMinColorIndex_rettypeboxed_s {
  modelica_metatype c1; /* outColor */
} Graph_arrayFindMinColorIndex_rettypeboxed;
DLLExport
Graph_arrayFindMinColorIndex_rettypeboxed boxptr_Graph_arrayFindMinColorIndex(threadData_t *threadData, modelica_metatype _inForbiddenColor, modelica_metatype _inNode, modelica_metatype _inIndex, modelica_metatype _inmaxIndex, modelica_fnptr inEqualFunc, modelica_fnptr inPrintFunc);
typedef struct Graph_printGraph_rettype_s {
  modelica_metatype c1; /* outString */
} Graph_printGraph_rettype;
DLLExport
Graph_printGraph_rettype omc_Graph_printGraph(threadData_t *threadData, modelica_metatype _inGraph, modelica_fnptr inPrintFunc);
#define boxptr_Graph_printGraph omc_Graph_printGraph

typedef struct Graph_printNode_rettype_s {
  modelica_metatype c1; /* outString */
} Graph_printNode_rettype;
DLLExport
Graph_printNode_rettype omc_Graph_printNode(threadData_t *threadData, modelica_metatype _inNode, modelica_fnptr inPrintFunc);
#define boxptr_Graph_printNode omc_Graph_printNode


DLLExport
void omc_Graph_printGraphInt(threadData_t *threadData, modelica_metatype _inGraph);
#define boxptr_Graph_printGraphInt omc_Graph_printGraphInt


DLLExport
void omc_Graph_printNodesInt(threadData_t *threadData, modelica_metatype _inListNodes, modelica_metatype _inName);
#define boxptr_Graph_printNodesInt omc_Graph_printNodesInt

typedef struct Graph_allReachableNodesInt_rettype_s {
  modelica_metatype c1; /* reachableNodes */
} Graph_allReachableNodesInt_rettype;
DLLExport
Graph_allReachableNodesInt_rettype omc_Graph_allReachableNodesInt(threadData_t *threadData, modelica_metatype _intmpstorage, modelica_metatype _inGraph, modelica_integer _inMaxGraphNode, modelica_integer _inMaxNodexIndex);
typedef struct Graph_allReachableNodesInt_rettypeboxed_s {
  modelica_metatype c1; /* reachableNodes */
} Graph_allReachableNodesInt_rettypeboxed;
DLLExport
Graph_allReachableNodesInt_rettypeboxed boxptr_Graph_allReachableNodesInt(threadData_t *threadData, modelica_metatype _intmpstorage, modelica_metatype _inGraph, modelica_metatype _inMaxGraphNode, modelica_metatype _inMaxNodexIndex);
typedef struct Graph_partialDistance2colorInt_rettype_s {
  modelica_metatype c1; /* outColored */
} Graph_partialDistance2colorInt_rettype;
DLLExport
Graph_partialDistance2colorInt_rettype omc_Graph_partialDistance2colorInt(threadData_t *threadData, modelica_metatype _inGraphT, modelica_metatype _inforbiddenColor, modelica_metatype _inColors, modelica_metatype _inGraph, modelica_metatype _inColored);
#define boxptr_Graph_partialDistance2colorInt omc_Graph_partialDistance2colorInt

typedef struct Graph_addForbiddenColorsInt_rettype_s {
  modelica_metatype c1; /* outForbiddenColor */
} Graph_addForbiddenColorsInt_rettype;
DLLExport
Graph_addForbiddenColorsInt_rettype omc_Graph_addForbiddenColorsInt(threadData_t *threadData, modelica_integer _inNode, modelica_metatype _inNodes, modelica_metatype _inColored, modelica_metatype _inForbiddenColor, modelica_metatype _inGraph);
typedef struct Graph_addForbiddenColorsInt_rettypeboxed_s {
  modelica_metatype c1; /* outForbiddenColor */
} Graph_addForbiddenColorsInt_rettypeboxed;
DLLExport
Graph_addForbiddenColorsInt_rettypeboxed boxptr_Graph_addForbiddenColorsInt(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inNodes, modelica_metatype _inColored, modelica_metatype _inForbiddenColor, modelica_metatype _inGraph);

DLLExport
void omc_Graph_updateForbiddenColorArrayInt(threadData_t *threadData, modelica_metatype _inIndexes, modelica_metatype _inColored, modelica_metatype _inForbiddenColor, modelica_integer _inNode);

DLLExport
void boxptr_Graph_updateForbiddenColorArrayInt(threadData_t *threadData, modelica_metatype _inIndexes, modelica_metatype _inColored, modelica_metatype _inForbiddenColor, modelica_metatype _inNode);
typedef struct Graph_arrayFindMinColorIndexInt_rettype_s {
  modelica_integer c1; /* outColor */
} Graph_arrayFindMinColorIndexInt_rettype;
DLLExport
Graph_arrayFindMinColorIndexInt_rettype omc_Graph_arrayFindMinColorIndexInt(threadData_t *threadData, modelica_metatype _inForbiddenColor, modelica_integer _inNode, modelica_integer _inIndex);
typedef struct Graph_arrayFindMinColorIndexInt_rettypeboxed_s {
  modelica_metatype c1; /* outColor */
} Graph_arrayFindMinColorIndexInt_rettypeboxed;
DLLExport
Graph_arrayFindMinColorIndexInt_rettypeboxed boxptr_Graph_arrayFindMinColorIndexInt(threadData_t *threadData, modelica_metatype _inForbiddenColor, modelica_metatype _inNode, modelica_metatype _inIndex);
typedef struct Graph_filterGraph_rettype_s {
  modelica_metatype c1; /* outGraph */
} Graph_filterGraph_rettype;
DLLExport
Graph_filterGraph_rettype omc_Graph_filterGraph(threadData_t *threadData, modelica_metatype _inGraph, modelica_fnptr inCondFunc);
#define boxptr_Graph_filterGraph omc_Graph_filterGraph

typedef struct Graph_filterGraph2_rettype_s {
  modelica_metatype c1; /* outNode */
} Graph_filterGraph2_rettype;
DLLExport
Graph_filterGraph2_rettype omc_Graph_filterGraph2(threadData_t *threadData, modelica_metatype _inNode, modelica_fnptr inCondFunc, modelica_metatype _inAccumGraph);
#define boxptr_Graph_filterGraph2 omc_Graph_filterGraph2

typedef struct Graph_merge_rettype_s {
  modelica_metatype c1; /* graph */
} Graph_merge_rettype;
DLLExport
Graph_merge_rettype omc_Graph_merge(threadData_t *threadData, modelica_metatype _graph1, modelica_metatype _graph2, modelica_fnptr eqFunc, modelica_fnptr compareFunc);
#define boxptr_Graph_merge omc_Graph_merge

typedef struct Graph_merge2_rettype_s {
  modelica_metatype c1; /* graph */
} Graph_merge2_rettype;
DLLExport
Graph_merge2_rettype omc_Graph_merge2(threadData_t *threadData, modelica_metatype _inGraph, modelica_fnptr eqFunc, modelica_metatype _inAcc);
#define boxptr_Graph_merge2 omc_Graph_merge2

typedef struct Graph_merge3_rettype_s {
  modelica_metatype c1; /* elt */
  modelica_metatype c2; /* outRest */
} Graph_merge3_rettype;
DLLExport
Graph_merge3_rettype omc_Graph_merge3(threadData_t *threadData, modelica_boolean _b, modelica_metatype _n1, modelica_metatype _e1, modelica_metatype _n2, modelica_metatype _e2, modelica_metatype _rest, modelica_fnptr eqFunc);
typedef struct Graph_merge3_rettypeboxed_s {
  modelica_metatype c1; /* elt */
  modelica_metatype c2; /* outRest */
} Graph_merge3_rettypeboxed;
DLLExport
Graph_merge3_rettypeboxed boxptr_Graph_merge3(threadData_t *threadData, modelica_metatype _b, modelica_metatype _n1, modelica_metatype _e1, modelica_metatype _n2, modelica_metatype _e2, modelica_metatype _rest, modelica_fnptr eqFunc);
#ifdef __cplusplus
extern "C" {
#endif
#include "Error.h"
#include "Graph.h"
#include "List.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

