#ifndef GraphML__H
#define GraphML__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description GraphML_Attribute_ATTRIBUTE__desc;
extern struct record_description GraphML_Edge_EDGE__desc;
extern struct record_description GraphML_Graph_GRAPH__desc;
extern struct record_description GraphML_Node_NODE__desc;
extern struct record_description IOStream_IOStreamType_LIST__desc;
typedef struct GraphML_getGraph_rettype_s {
  modelica_metatype c1; /* g */
} GraphML_getGraph_rettype;
DLLExport
GraphML_getGraph_rettype omc_GraphML_getGraph(threadData_t *threadData, modelica_metatype _id, modelica_boolean _directed);
typedef struct GraphML_getGraph_rettypeboxed_s {
  modelica_metatype c1; /* g */
} GraphML_getGraph_rettypeboxed;
DLLExport
GraphML_getGraph_rettypeboxed boxptr_GraphML_getGraph(threadData_t *threadData, modelica_metatype _id, modelica_metatype _directed);
typedef struct GraphML_addGraphAttributeValue_rettype_s {
  modelica_metatype c1; /* outG */
} GraphML_addGraphAttributeValue_rettype;
DLLExport
GraphML_addGraphAttributeValue_rettype omc_GraphML_addGraphAttributeValue(threadData_t *threadData, modelica_metatype _iValue, modelica_metatype _inG);
#define boxptr_GraphML_addGraphAttributeValue omc_GraphML_addGraphAttributeValue

typedef struct GraphML_addNode_rettype_s {
  modelica_metatype c1; /* outG */
} GraphML_addNode_rettype;
DLLExport
GraphML_addNode_rettype omc_GraphML_addNode(threadData_t *threadData, modelica_metatype _id, modelica_metatype _text, modelica_metatype _color, modelica_metatype _shapeType, modelica_metatype _optDesc, modelica_metatype _attValues, modelica_metatype _addLabels, modelica_metatype _inG);
#define boxptr_GraphML_addNode omc_GraphML_addNode

typedef struct GraphML_addEdge_rettype_s {
  modelica_metatype c1; /* outG */
} GraphML_addEdge_rettype;
DLLExport
GraphML_addEdge_rettype omc_GraphML_addEdge(threadData_t *threadData, modelica_metatype _id, modelica_metatype _target, modelica_metatype _source, modelica_metatype _color, modelica_metatype _lineType, modelica_real _lineWidth, modelica_metatype _label, modelica_metatype _arrows, modelica_metatype _attValues, modelica_metatype _inG);
typedef struct GraphML_addEdge_rettypeboxed_s {
  modelica_metatype c1; /* outG */
} GraphML_addEdge_rettypeboxed;
DLLExport
GraphML_addEdge_rettypeboxed boxptr_GraphML_addEdge(threadData_t *threadData, modelica_metatype _id, modelica_metatype _target, modelica_metatype _source, modelica_metatype _color, modelica_metatype _lineType, modelica_metatype _lineWidth, modelica_metatype _label, modelica_metatype _arrows, modelica_metatype _attValues, modelica_metatype _inG);
typedef struct GraphML_addAttribute_rettype_s {
  modelica_integer c1; /* oAttIdx */
  modelica_metatype c2; /* outG */
} GraphML_addAttribute_rettype;
DLLExport
GraphML_addAttribute_rettype omc_GraphML_addAttribute(threadData_t *threadData, modelica_metatype _defaultValue, modelica_metatype _name, modelica_metatype _attType, modelica_metatype _attTarget, modelica_metatype _inG);
typedef struct GraphML_addAttribute_rettypeboxed_s {
  modelica_metatype c1; /* oAttIdx */
  modelica_metatype c2; /* outG */
} GraphML_addAttribute_rettypeboxed;
DLLExport
GraphML_addAttribute_rettypeboxed boxptr_GraphML_addAttribute(threadData_t *threadData, modelica_metatype _defaultValue, modelica_metatype _name, modelica_metatype _attType, modelica_metatype _attTarget, modelica_metatype _inG);

DLLExport
void omc_GraphML_dumpGraph(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _name);
#define boxptr_GraphML_dumpGraph omc_GraphML_dumpGraph


DLLExport
void omc_GraphML_printGraph(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _name);
#define boxptr_GraphML_printGraph omc_GraphML_printGraph

typedef struct GraphML_dumpStart_rettype_s {
  modelica_metatype c1; /* os */
} GraphML_dumpStart_rettype;
DLLExport
GraphML_dumpStart_rettype omc_GraphML_dumpStart(threadData_t *threadData, modelica_metatype _is);
#define boxptr_GraphML_dumpStart omc_GraphML_dumpStart

typedef struct GraphML_dumpEnd_rettype_s {
  modelica_metatype c1; /* os */
} GraphML_dumpEnd_rettype;
DLLExport
GraphML_dumpEnd_rettype omc_GraphML_dumpEnd(threadData_t *threadData, modelica_metatype _is);
#define boxptr_GraphML_dumpEnd omc_GraphML_dumpEnd

typedef struct GraphML_appendString_rettype_s {
  modelica_metatype c1; /* outString */
} GraphML_appendString_rettype;
DLLExport
GraphML_appendString_rettype omc_GraphML_appendString(threadData_t *threadData, modelica_metatype _inString);
#define boxptr_GraphML_appendString omc_GraphML_appendString

typedef struct GraphML_dumpGraph__Internal_rettype_s {
  modelica_metatype c1; /* outIOs */
} GraphML_dumpGraph__Internal_rettype;
DLLExport
GraphML_dumpGraph__Internal_rettype omc_GraphML_dumpGraph__Internal(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inStringDelemiter, modelica_metatype _inIOs);
#define boxptr_GraphML_dumpGraph__Internal omc_GraphML_dumpGraph__Internal

typedef struct GraphML_dumpAttributeDefinition_rettype_s {
  modelica_metatype c1; /* oIos */
} GraphML_dumpAttributeDefinition_rettype;
DLLExport
GraphML_dumpAttributeDefinition_rettype omc_GraphML_dumpAttributeDefinition(threadData_t *threadData, modelica_metatype _inAttribute, modelica_metatype _iIos);
#define boxptr_GraphML_dumpAttributeDefinition omc_GraphML_dumpAttributeDefinition

typedef struct GraphML_dumpAttributeType_rettype_s {
  modelica_metatype c1; /* oString */
} GraphML_dumpAttributeType_rettype;
DLLExport
GraphML_dumpAttributeType_rettype omc_GraphML_dumpAttributeType(threadData_t *threadData, modelica_metatype _attType);
#define boxptr_GraphML_dumpAttributeType omc_GraphML_dumpAttributeType

typedef struct GraphML_dumpAttributeTarget_rettype_s {
  modelica_metatype c1; /* oString */
} GraphML_dumpAttributeTarget_rettype;
DLLExport
GraphML_dumpAttributeTarget_rettype omc_GraphML_dumpAttributeTarget(threadData_t *threadData, modelica_metatype _attTarget);
#define boxptr_GraphML_dumpAttributeTarget omc_GraphML_dumpAttributeTarget

typedef struct GraphML_dumpNode_rettype_s {
  modelica_metatype c1; /* oAcc */
} GraphML_dumpNode_rettype;
DLLExport
GraphML_dumpNode_rettype omc_GraphML_dumpNode(threadData_t *threadData, modelica_metatype _inNode, modelica_metatype _inString, modelica_metatype _iAcc);
#define boxptr_GraphML_dumpNode omc_GraphML_dumpNode

typedef struct GraphML_createAttributeString_rettype_s {
  modelica_metatype c1; /* oString */
} GraphML_createAttributeString_rettype;
DLLExport
GraphML_createAttributeString_rettype omc_GraphML_createAttributeString(threadData_t *threadData, modelica_metatype _iAttValue, modelica_integer _idOffset);
typedef struct GraphML_createAttributeString_rettypeboxed_s {
  modelica_metatype c1; /* oString */
} GraphML_createAttributeString_rettypeboxed;
DLLExport
GraphML_createAttributeString_rettypeboxed boxptr_GraphML_createAttributeString(threadData_t *threadData, modelica_metatype _iAttValue, modelica_metatype _idOffset);
typedef struct GraphML_getNodeDesc_rettype_s {
  modelica_metatype c1; /* desc_out */
} GraphML_getNodeDesc_rettype;
DLLExport
GraphML_getNodeDesc_rettype omc_GraphML_getNodeDesc(threadData_t *threadData, modelica_metatype _node);
#define boxptr_GraphML_getNodeDesc omc_GraphML_getNodeDesc

typedef struct GraphML_getNodeLabelString_rettype_s {
  modelica_metatype c1; /* oString */
} GraphML_getNodeLabelString_rettype;
DLLExport
GraphML_getNodeLabelString_rettype omc_GraphML_getNodeLabelString(threadData_t *threadData, modelica_metatype _iLabel);
#define boxptr_GraphML_getNodeLabelString omc_GraphML_getNodeLabelString

typedef struct GraphML_getFontStyleString_rettype_s {
  modelica_metatype c1; /* oString */
} GraphML_getFontStyleString_rettype;
DLLExport
GraphML_getFontStyleString_rettype omc_GraphML_getFontStyleString(threadData_t *threadData, modelica_metatype _iFontStyle);
#define boxptr_GraphML_getFontStyleString omc_GraphML_getFontStyleString

typedef struct GraphML_getShapeTypeString_rettype_s {
  modelica_metatype c1; /* str */
} GraphML_getShapeTypeString_rettype;
DLLExport
GraphML_getShapeTypeString_rettype omc_GraphML_getShapeTypeString(threadData_t *threadData, modelica_metatype _st);
#define boxptr_GraphML_getShapeTypeString omc_GraphML_getShapeTypeString

typedef struct GraphML_dumpEdge_rettype_s {
  modelica_metatype c1; /* oAcc */
} GraphML_dumpEdge_rettype;
DLLExport
GraphML_dumpEdge_rettype omc_GraphML_dumpEdge(threadData_t *threadData, modelica_metatype _inEdge, modelica_metatype _inString, modelica_metatype _iAcc);
#define boxptr_GraphML_dumpEdge omc_GraphML_dumpEdge

typedef struct GraphML_getEdgeLabelString_rettype_s {
  modelica_metatype c1; /* outStr */
} GraphML_getEdgeLabelString_rettype;
DLLExport
GraphML_getEdgeLabelString_rettype omc_GraphML_getEdgeLabelString(threadData_t *threadData, modelica_metatype _label);
#define boxptr_GraphML_getEdgeLabelString omc_GraphML_getEdgeLabelString

typedef struct GraphML_getArrowTypeString_rettype_s {
  modelica_metatype c1; /* outString */
} GraphML_getArrowTypeString_rettype;
DLLExport
GraphML_getArrowTypeString_rettype omc_GraphML_getArrowTypeString(threadData_t *threadData, modelica_metatype _inArrow);
#define boxptr_GraphML_getArrowTypeString omc_GraphML_getArrowTypeString

typedef struct GraphML_getLineTypeString_rettype_s {
  modelica_metatype c1; /* str */
} GraphML_getLineTypeString_rettype;
DLLExport
GraphML_getLineTypeString_rettype omc_GraphML_getLineTypeString(threadData_t *threadData, modelica_metatype _lt);
#define boxptr_GraphML_getLineTypeString omc_GraphML_getLineTypeString
#ifdef __cplusplus
extern "C" {
#endif
#include "GraphML.h"
#include "IOStream.h"
#include "List.h"
#include "System.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

