#ifndef IOStreamExt__H
#define IOStreamExt__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct IOStreamExt_createFile_rettype_s {
  modelica_integer c1; /* fileID */
} IOStreamExt_createFile_rettype;
DLLExport
IOStreamExt_createFile_rettype omc_IOStreamExt_createFile(threadData_t *threadData, modelica_metatype _fileName);
typedef struct IOStreamExt_createFile_rettypeboxed_s {
  modelica_metatype c1; /* fileID */
} IOStreamExt_createFile_rettypeboxed;
DLLExport
IOStreamExt_createFile_rettypeboxed boxptr_IOStreamExt_createFile(threadData_t *threadData, modelica_metatype _fileName);

extern int IOStreamExt_createFile(const char* /*_fileName*/);

DLLExport
void omc_IOStreamExt_closeFile(threadData_t *threadData, modelica_integer _fileID);

DLLExport
void boxptr_IOStreamExt_closeFile(threadData_t *threadData, modelica_metatype _fileID);

extern void IOStreamExt_closeFile(int /*_fileID*/);

DLLExport
void omc_IOStreamExt_deleteFile(threadData_t *threadData, modelica_integer _fileID);

DLLExport
void boxptr_IOStreamExt_deleteFile(threadData_t *threadData, modelica_metatype _fileID);

extern void IOStreamExt_deleteFile(int /*_fileID*/);

DLLExport
void omc_IOStreamExt_clearFile(threadData_t *threadData, modelica_integer _fileID);

DLLExport
void boxptr_IOStreamExt_clearFile(threadData_t *threadData, modelica_metatype _fileID);

extern void IOStreamExt_clearFile(int /*_fileID*/);

DLLExport
void omc_IOStreamExt_appendFile(threadData_t *threadData, modelica_integer _fileID, modelica_metatype _inString);

DLLExport
void boxptr_IOStreamExt_appendFile(threadData_t *threadData, modelica_metatype _fileID, modelica_metatype _inString);

extern void IOStreamExt_appendFile(int /*_fileID*/, const char* /*_inString*/);
typedef struct IOStreamExt_readFile_rettype_s {
  modelica_metatype c1; /* outString */
} IOStreamExt_readFile_rettype;
DLLExport
IOStreamExt_readFile_rettype omc_IOStreamExt_readFile(threadData_t *threadData, modelica_integer _fileID);
typedef struct IOStreamExt_readFile_rettypeboxed_s {
  modelica_metatype c1; /* outString */
} IOStreamExt_readFile_rettypeboxed;
DLLExport
IOStreamExt_readFile_rettypeboxed boxptr_IOStreamExt_readFile(threadData_t *threadData, modelica_metatype _fileID);

extern const char* IOStreamExt_readFile(int /*_fileID*/);

DLLExport
void omc_IOStreamExt_printFile(threadData_t *threadData, modelica_integer _fileID, modelica_integer _whereToPrint);

DLLExport
void boxptr_IOStreamExt_printFile(threadData_t *threadData, modelica_metatype _fileID, modelica_metatype _whereToPrint);

extern void IOStreamExt_printFile(int /*_fileID*/, int /*_whereToPrint*/);
typedef struct IOStreamExt_createBuffer_rettype_s {
  modelica_integer c1; /* bufferID */
} IOStreamExt_createBuffer_rettype;
DLLExport
IOStreamExt_createBuffer_rettype omc_IOStreamExt_createBuffer(threadData_t *threadData);
typedef struct IOStreamExt_createBuffer_rettypeboxed_s {
  modelica_metatype c1; /* bufferID */
} IOStreamExt_createBuffer_rettypeboxed;
DLLExport
IOStreamExt_createBuffer_rettypeboxed boxptr_IOStreamExt_createBuffer(threadData_t *threadData);

extern int IOStreamExt_createBuffer();

DLLExport
void omc_IOStreamExt_appendBuffer(threadData_t *threadData, modelica_integer _bufferID, modelica_metatype _inString);

DLLExport
void boxptr_IOStreamExt_appendBuffer(threadData_t *threadData, modelica_metatype _bufferID, modelica_metatype _inString);

extern void IOStreamExt_appendBuffer(int /*_bufferID*/, const char* /*_inString*/);

DLLExport
void omc_IOStreamExt_deleteBuffer(threadData_t *threadData, modelica_integer _bufferID);

DLLExport
void boxptr_IOStreamExt_deleteBuffer(threadData_t *threadData, modelica_metatype _bufferID);

extern void IOStreamExt_deleteBuffer(int /*_bufferID*/);

DLLExport
void omc_IOStreamExt_clearBuffer(threadData_t *threadData, modelica_integer _bufferID);

DLLExport
void boxptr_IOStreamExt_clearBuffer(threadData_t *threadData, modelica_metatype _bufferID);

extern void IOStreamExt_clearBuffer(int /*_bufferID*/);
typedef struct IOStreamExt_readBuffer_rettype_s {
  modelica_metatype c1; /* outString */
} IOStreamExt_readBuffer_rettype;
DLLExport
IOStreamExt_readBuffer_rettype omc_IOStreamExt_readBuffer(threadData_t *threadData, modelica_integer _bufferID);
typedef struct IOStreamExt_readBuffer_rettypeboxed_s {
  modelica_metatype c1; /* outString */
} IOStreamExt_readBuffer_rettypeboxed;
DLLExport
IOStreamExt_readBuffer_rettypeboxed boxptr_IOStreamExt_readBuffer(threadData_t *threadData, modelica_metatype _bufferID);

extern const char* IOStreamExt_readBuffer(int /*_bufferID*/);

DLLExport
void omc_IOStreamExt_printBuffer(threadData_t *threadData, modelica_integer _bufferID, modelica_integer _whereToPrint);

DLLExport
void boxptr_IOStreamExt_printBuffer(threadData_t *threadData, modelica_metatype _bufferID, modelica_metatype _whereToPrint);

extern void IOStreamExt_printBuffer(int /*_bufferID*/, int /*_whereToPrint*/);
typedef struct IOStreamExt_appendReversedList_rettype_s {
  modelica_metatype c1; /* outString */
} IOStreamExt_appendReversedList_rettype;
DLLExport
IOStreamExt_appendReversedList_rettype omc_IOStreamExt_appendReversedList(threadData_t *threadData, modelica_metatype _inStringLst);
#define boxptr_IOStreamExt_appendReversedList omc_IOStreamExt_appendReversedList

extern const char* IOStreamExt_appendReversedList(modelica_metatype /*_inStringLst*/);

DLLExport
void omc_IOStreamExt_printReversedList(threadData_t *threadData, modelica_metatype _inStringLst, modelica_integer _whereToPrint);

DLLExport
void boxptr_IOStreamExt_printReversedList(threadData_t *threadData, modelica_metatype _inStringLst, modelica_metatype _whereToPrint);

extern void IOStreamExt_printReversedList(modelica_metatype /*_inStringLst*/, int /*_whereToPrint*/);

#ifdef __cplusplus
}
#endif
#endif

