#ifndef InlineSolver__H
#define InlineSolver__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Absyn_Info_INFO__desc;
extern struct record_description Absyn_TimeStamp_TIMESTAMP__desc;
extern struct record_description BackendDAE_BackendDAE_DAE__desc;
extern struct record_description BackendDAE_EqSystem_EQSYSTEM__desc;
extern struct record_description BackendDAE_Equation_EQUATION__desc;
extern struct record_description BackendDAE_Equation_SOLVED__EQUATION__desc;
extern struct record_description BackendDAE_EquationConstraints_EXACT__desc;
extern struct record_description BackendDAE_IndexReduction_NO__INDEX__REDUCTION__desc;
extern struct record_description BackendDAE_IndexType_NORMAL__desc;
extern struct record_description BackendDAE_Matching_NO__MATCHING__desc;
extern struct record_description BackendDAE_Shared_SHARED__desc;
extern struct record_description BackendDAE_Var_VAR__desc;
extern struct record_description BackendDAE_VarKind_VARIABLE__desc;
extern struct record_description DAE_ComponentRef_CREF__IDENT__desc;
extern struct record_description DAE_ConnectorType_NON__CONNECTOR__desc;
extern struct record_description DAE_ElementSource_SOURCE__desc;
extern struct record_description DAE_Exp_CREF__desc;
extern struct record_description DAE_Exp_RCONST__desc;
extern struct record_description DAE_Type_T__REAL__desc;
extern struct record_description DAE_VarDirection_BIDIR__desc;
extern struct record_description DAE_VarParallelism_NON__PARALLEL__desc;
extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;
typedef struct InlineSolver_generateDAE_rettype_s {
  modelica_metatype c1; /* outDAE */
  modelica_metatype c2; /* outInlineVars */
} InlineSolver_generateDAE_rettype;
DLLExport
InlineSolver_generateDAE_rettype omc_InlineSolver_generateDAE(threadData_t *threadData, modelica_metatype _inDAE);
#define boxptr_InlineSolver_generateDAE omc_InlineSolver_generateDAE

typedef struct InlineSolver_dae__to__algSystem_rettype_s {
  modelica_metatype c1; /* outDAE */
  modelica_metatype c2; /* outInlineVars */
} InlineSolver_dae__to__algSystem_rettype;
DLLExport
InlineSolver_dae__to__algSystem_rettype omc_InlineSolver_dae__to__algSystem(threadData_t *threadData, modelica_metatype _inDAE);
#define boxptr_InlineSolver_dae__to__algSystem omc_InlineSolver_dae__to__algSystem

typedef struct InlineSolver_addKnowInitialValueForState_rettype_s {
  modelica_metatype c1; /* outShared */
} InlineSolver_addKnowInitialValueForState_rettype;
DLLExport
InlineSolver_addKnowInitialValueForState_rettype omc_InlineSolver_addKnowInitialValueForState(threadData_t *threadData, modelica_metatype _inShared, modelica_metatype _invars);
#define boxptr_InlineSolver_addKnowInitialValueForState omc_InlineSolver_addKnowInitialValueForState

typedef struct InlineSolver_timeEquation_rettype_s {
  modelica_metatype c1; /* outEqSystem */
} InlineSolver_timeEquation_rettype;
DLLExport
InlineSolver_timeEquation_rettype omc_InlineSolver_timeEquation(threadData_t *threadData);
#define boxptr_InlineSolver_timeEquation omc_InlineSolver_timeEquation

typedef struct InlineSolver_eliminatedStatesDerivations_rettype_s {
  modelica_metatype c1; /* outTupel */
} InlineSolver_eliminatedStatesDerivations_rettype;
DLLExport
InlineSolver_eliminatedStatesDerivations_rettype omc_InlineSolver_eliminatedStatesDerivations(threadData_t *threadData, modelica_metatype _inEqSystem, modelica_metatype _inTupel);
#define boxptr_InlineSolver_eliminatedStatesDerivations omc_InlineSolver_eliminatedStatesDerivations

typedef struct InlineSolver_replaceStates__eqs_rettype_s {
  modelica_metatype c1; /* outTpl */
} InlineSolver_replaceStates__eqs_rettype;
DLLExport
InlineSolver_replaceStates__eqs_rettype omc_InlineSolver_replaceStates__eqs(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_InlineSolver_replaceStates__eqs omc_InlineSolver_replaceStates__eqs

typedef struct InlineSolver_EqSolvedEq_rettype_s {
  modelica_metatype c1; /* outEqn */
} InlineSolver_EqSolvedEq_rettype;
DLLExport
InlineSolver_EqSolvedEq_rettype omc_InlineSolver_EqSolvedEq(threadData_t *threadData, modelica_metatype _inEqn, modelica_boolean _b);
typedef struct InlineSolver_EqSolvedEq_rettypeboxed_s {
  modelica_metatype c1; /* outEqn */
} InlineSolver_EqSolvedEq_rettypeboxed;
DLLExport
InlineSolver_EqSolvedEq_rettypeboxed boxptr_InlineSolver_EqSolvedEq(threadData_t *threadData, modelica_metatype _inEqn, modelica_metatype _b);
typedef struct InlineSolver_isDerEq_rettype_s {
  modelica_boolean c1; /* b */
} InlineSolver_isDerEq_rettype;
DLLExport
InlineSolver_isDerEq_rettype omc_InlineSolver_isDerEq(threadData_t *threadData, modelica_metatype _e1);
typedef struct InlineSolver_isDerEq_rettypeboxed_s {
  modelica_metatype c1; /* b */
} InlineSolver_isDerEq_rettypeboxed;
DLLExport
InlineSolver_isDerEq_rettypeboxed boxptr_InlineSolver_isDerEq(threadData_t *threadData, modelica_metatype _e1);
typedef struct InlineSolver_replaceDerStateCref_rettype_s {
  modelica_metatype c1; /* outExp */
} InlineSolver_replaceDerStateCref_rettype;
DLLExport
InlineSolver_replaceDerStateCref_rettype omc_InlineSolver_replaceDerStateCref(threadData_t *threadData, modelica_metatype _inExp);
#define boxptr_InlineSolver_replaceDerStateCref omc_InlineSolver_replaceDerStateCref

typedef struct InlineSolver_replaceDerStateExp_rettype_s {
  modelica_metatype c1; /* outExp */
} InlineSolver_replaceDerStateExp_rettype;
DLLExport
InlineSolver_replaceDerStateExp_rettype omc_InlineSolver_replaceDerStateExp(threadData_t *threadData, modelica_metatype _inExp);
#define boxptr_InlineSolver_replaceDerStateExp omc_InlineSolver_replaceDerStateExp

typedef struct InlineSolver_crefPrefixStringWithpopCref_rettype_s {
  modelica_metatype c1; /* out_cr */
} InlineSolver_crefPrefixStringWithpopCref_rettype;
DLLExport
InlineSolver_crefPrefixStringWithpopCref_rettype omc_InlineSolver_crefPrefixStringWithpopCref(threadData_t *threadData, modelica_metatype _name, modelica_metatype _in_cr);
#define boxptr_InlineSolver_crefPrefixStringWithpopCref omc_InlineSolver_crefPrefixStringWithpopCref

typedef struct InlineSolver_replaceStates__vars_rettype_s {
  modelica_metatype c1; /* outTpl */
} InlineSolver_replaceStates__vars_rettype;
DLLExport
InlineSolver_replaceStates__vars_rettype omc_InlineSolver_replaceStates__vars(threadData_t *threadData, modelica_metatype _inTpl);
#define boxptr_InlineSolver_replaceStates__vars omc_InlineSolver_replaceStates__vars

typedef struct InlineSolver_stepLobatt_rettype_s {
  modelica_metatype c1; /* eqns */
} InlineSolver_stepLobatt_rettype;
DLLExport
InlineSolver_stepLobatt_rettype omc_InlineSolver_stepLobatt(threadData_t *threadData, modelica_metatype _x0_, modelica_metatype _x1_, modelica_metatype _x2_, modelica_metatype _x3_, modelica_metatype _x4_, modelica_metatype _derx0_, modelica_metatype _derx1_, modelica_metatype _derx2_, modelica_metatype _derx3_, modelica_metatype _derx4_, modelica_metatype _dt, modelica_metatype _ty);
#define boxptr_InlineSolver_stepLobatt omc_InlineSolver_stepLobatt

typedef struct InlineSolver_LobattoTerms_rettype_s {
  modelica_metatype c1; /* k0 */
  modelica_metatype c2; /* k1 */
  modelica_metatype c3; /* k2 */
  modelica_metatype c4; /* k3 */
  modelica_metatype c5; /* k4 */
  modelica_metatype c6; /* z0 */
  modelica_metatype c7; /* z1 */
} InlineSolver_LobattoTerms_rettype;
DLLExport
InlineSolver_LobattoTerms_rettype omc_InlineSolver_LobattoTerms(threadData_t *threadData, modelica_metatype _a0, modelica_metatype _a1, modelica_metatype _a2, modelica_metatype _a3, modelica_metatype _a4, modelica_metatype _aa, modelica_metatype _f0, modelica_metatype _f1, modelica_metatype _f2, modelica_metatype _f3, modelica_metatype _f4, modelica_metatype _x0, modelica_metatype _x1);
#define boxptr_InlineSolver_LobattoTerms omc_InlineSolver_LobattoTerms

typedef struct InlineSolver_stringCrVar_rettype_s {
  modelica_metatype c1; /* outCR */
  modelica_metatype c2; /* var */
} InlineSolver_stringCrVar_rettype;
DLLExport
InlineSolver_stringCrVar_rettype omc_InlineSolver_stringCrVar(threadData_t *threadData, modelica_metatype _varTyp, modelica_metatype _inCR, modelica_metatype _ty, modelica_metatype _arryDim);
#define boxptr_InlineSolver_stringCrVar omc_InlineSolver_stringCrVar
#ifdef __cplusplus
extern "C" {
#endif
#include "BackendDAEUtil.h"
#include "BackendDump.h"
#include "BackendEquation.h"
#include "BackendVariable.h"
#include "ComponentReference.h"
#include "Debug.h"
#include "Error.h"
#include "Expression.h"
#include "Flags.h"
#include "InlineSolver.h"
#include "List.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

