#ifndef Lapack__H
#define Lapack__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct Lapack_dgeev_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWR */
  modelica_metatype c3; /* outWI */
  modelica_metatype c4; /* outVL */
  modelica_metatype c5; /* outVR */
  modelica_metatype c6; /* outWORK */
  modelica_integer c7; /* outINFO */
} Lapack_dgeev_rettype;
DLLExport
Lapack_dgeev_rettype omc_Lapack_dgeev(threadData_t *threadData, modelica_metatype _inJOBVL, modelica_metatype _inJOBVR, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA, modelica_integer _inLDVL, modelica_integer _inLDVR, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgeev_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWR */
  modelica_metatype c3; /* outWI */
  modelica_metatype c4; /* outVL */
  modelica_metatype c5; /* outVR */
  modelica_metatype c6; /* outWORK */
  modelica_metatype c7; /* outINFO */
} Lapack_dgeev_rettypeboxed;
DLLExport
Lapack_dgeev_rettypeboxed boxptr_Lapack_dgeev(threadData_t *threadData, modelica_metatype _inJOBVL, modelica_metatype _inJOBVR, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inLDVL, modelica_metatype _inLDVR, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgeev(const char* /*_inJOBVL*/, const char* /*_inJOBVR*/, int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, int /*_inLDVL*/, int /*_inLDVR*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outWR*/, modelica_metatype* /*_outWI*/, modelica_metatype* /*_outVL*/, modelica_metatype* /*_outVR*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgegv_rettype_s {
  modelica_metatype c1; /* outALPHAR */
  modelica_metatype c2; /* outALPHAI */
  modelica_metatype c3; /* outBETA */
  modelica_metatype c4; /* outVL */
  modelica_metatype c5; /* outVR */
  modelica_metatype c6; /* outWORK */
  modelica_integer c7; /* outINFO */
} Lapack_dgegv_rettype;
DLLExport
Lapack_dgegv_rettype omc_Lapack_dgegv(threadData_t *threadData, modelica_metatype _inJOBVL, modelica_metatype _inJOBVR, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inB, modelica_integer _inLDB, modelica_integer _inLDVL, modelica_integer _inLDVR, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgegv_rettypeboxed_s {
  modelica_metatype c1; /* outALPHAR */
  modelica_metatype c2; /* outALPHAI */
  modelica_metatype c3; /* outBETA */
  modelica_metatype c4; /* outVL */
  modelica_metatype c5; /* outVR */
  modelica_metatype c6; /* outWORK */
  modelica_metatype c7; /* outINFO */
} Lapack_dgegv_rettypeboxed;
DLLExport
Lapack_dgegv_rettypeboxed boxptr_Lapack_dgegv(threadData_t *threadData, modelica_metatype _inJOBVL, modelica_metatype _inJOBVR, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inB, modelica_metatype _inLDB, modelica_metatype _inLDVL, modelica_metatype _inLDVR, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgegv(const char* /*_inJOBVL*/, const char* /*_inJOBVR*/, int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inB*/, int /*_inLDB*/, int /*_inLDVL*/, int /*_inLDVR*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outALPHAR*/, modelica_metatype* /*_outALPHAI*/, modelica_metatype* /*_outBETA*/, modelica_metatype* /*_outVL*/, modelica_metatype* /*_outVR*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgels_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outWORK */
  modelica_integer c4; /* outINFO */
} Lapack_dgels_rettype;
DLLExport
Lapack_dgels_rettype omc_Lapack_dgels(threadData_t *threadData, modelica_metatype _inTRANS, modelica_integer _inM, modelica_integer _inN, modelica_integer _inNRHS, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inB, modelica_integer _inLDB, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgels_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outWORK */
  modelica_metatype c4; /* outINFO */
} Lapack_dgels_rettypeboxed;
DLLExport
Lapack_dgels_rettypeboxed boxptr_Lapack_dgels(threadData_t *threadData, modelica_metatype _inTRANS, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inNRHS, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inB, modelica_metatype _inLDB, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgels(const char* /*_inTRANS*/, int /*_inM*/, int /*_inN*/, int /*_inNRHS*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outB*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgelsx_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outJPVT */
  modelica_integer c4; /* outRANK */
  modelica_integer c5; /* outINFO */
} Lapack_dgelsx_rettype;
DLLExport
Lapack_dgelsx_rettype omc_Lapack_dgelsx(threadData_t *threadData, modelica_integer _inM, modelica_integer _inN, modelica_integer _inNRHS, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inB, modelica_integer _inLDB, modelica_metatype _inJPVT, modelica_real _inRCOND, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgelsx_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outJPVT */
  modelica_metatype c4; /* outRANK */
  modelica_metatype c5; /* outINFO */
} Lapack_dgelsx_rettypeboxed;
DLLExport
Lapack_dgelsx_rettypeboxed boxptr_Lapack_dgelsx(threadData_t *threadData, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inNRHS, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inB, modelica_metatype _inLDB, modelica_metatype _inJPVT, modelica_metatype _inRCOND, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgelsx(int /*_inM*/, int /*_inN*/, int /*_inNRHS*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype /*_inJPVT*/, double /*_inRCOND*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outB*/, modelica_metatype* /*_outJPVT*/, int* /*_outRANK*/, int* /*_outINFO*/);
typedef struct Lapack_dgesv_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outIPIV */
  modelica_metatype c3; /* outB */
  modelica_integer c4; /* outINFO */
} Lapack_dgesv_rettype;
DLLExport
Lapack_dgesv_rettype omc_Lapack_dgesv(threadData_t *threadData, modelica_integer _inN, modelica_integer _inNRHS, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inB, modelica_integer _inLDB);
typedef struct Lapack_dgesv_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outIPIV */
  modelica_metatype c3; /* outB */
  modelica_metatype c4; /* outINFO */
} Lapack_dgesv_rettypeboxed;
DLLExport
Lapack_dgesv_rettypeboxed boxptr_Lapack_dgesv(threadData_t *threadData, modelica_metatype _inN, modelica_metatype _inNRHS, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inB, modelica_metatype _inLDB);

extern void LapackImpl__dgesv(int /*_inN*/, int /*_inNRHS*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outIPIV*/, modelica_metatype* /*_outB*/, int* /*_outINFO*/);
typedef struct Lapack_dgglse_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outC */
  modelica_metatype c4; /* outD */
  modelica_metatype c5; /* outX */
  modelica_metatype c6; /* outWORK */
  modelica_integer c7; /* outINFO */
} Lapack_dgglse_rettype;
DLLExport
Lapack_dgglse_rettype omc_Lapack_dgglse(threadData_t *threadData, modelica_integer _inM, modelica_integer _inN, modelica_integer _inP, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inB, modelica_integer _inLDB, modelica_metatype _inC, modelica_metatype _inD, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgglse_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outB */
  modelica_metatype c3; /* outC */
  modelica_metatype c4; /* outD */
  modelica_metatype c5; /* outX */
  modelica_metatype c6; /* outWORK */
  modelica_metatype c7; /* outINFO */
} Lapack_dgglse_rettypeboxed;
DLLExport
Lapack_dgglse_rettypeboxed boxptr_Lapack_dgglse(threadData_t *threadData, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inP, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inB, modelica_metatype _inLDB, modelica_metatype _inC, modelica_metatype _inD, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgglse(int /*_inM*/, int /*_inN*/, int /*_inP*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype /*_inC*/, modelica_metatype /*_inD*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outB*/, modelica_metatype* /*_outC*/, modelica_metatype* /*_outD*/, modelica_metatype* /*_outX*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgtsv_rettype_s {
  modelica_metatype c1; /* outDL */
  modelica_metatype c2; /* outD */
  modelica_metatype c3; /* outDU */
  modelica_metatype c4; /* outB */
  modelica_integer c5; /* outINFO */
} Lapack_dgtsv_rettype;
DLLExport
Lapack_dgtsv_rettype omc_Lapack_dgtsv(threadData_t *threadData, modelica_integer _inN, modelica_integer _inNRHS, modelica_metatype _inDL, modelica_metatype _inD, modelica_metatype _inDU, modelica_metatype _inB, modelica_integer _inLDB);
typedef struct Lapack_dgtsv_rettypeboxed_s {
  modelica_metatype c1; /* outDL */
  modelica_metatype c2; /* outD */
  modelica_metatype c3; /* outDU */
  modelica_metatype c4; /* outB */
  modelica_metatype c5; /* outINFO */
} Lapack_dgtsv_rettypeboxed;
DLLExport
Lapack_dgtsv_rettypeboxed boxptr_Lapack_dgtsv(threadData_t *threadData, modelica_metatype _inN, modelica_metatype _inNRHS, modelica_metatype _inDL, modelica_metatype _inD, modelica_metatype _inDU, modelica_metatype _inB, modelica_metatype _inLDB);

extern void LapackImpl__dgtsv(int /*_inN*/, int /*_inNRHS*/, modelica_metatype /*_inDL*/, modelica_metatype /*_inD*/, modelica_metatype /*_inDU*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype* /*_outDL*/, modelica_metatype* /*_outD*/, modelica_metatype* /*_outDU*/, modelica_metatype* /*_outB*/, int* /*_outINFO*/);
typedef struct Lapack_dgbsv_rettype_s {
  modelica_metatype c1; /* outAB */
  modelica_metatype c2; /* outIPIV */
  modelica_metatype c3; /* outB */
  modelica_integer c4; /* outINFO */
} Lapack_dgbsv_rettype;
DLLExport
Lapack_dgbsv_rettype omc_Lapack_dgbsv(threadData_t *threadData, modelica_integer _inN, modelica_integer _inKL, modelica_integer _inKU, modelica_integer _inNRHS, modelica_metatype _inAB, modelica_integer _inLDAB, modelica_metatype _inB, modelica_integer _inLDB);
typedef struct Lapack_dgbsv_rettypeboxed_s {
  modelica_metatype c1; /* outAB */
  modelica_metatype c2; /* outIPIV */
  modelica_metatype c3; /* outB */
  modelica_metatype c4; /* outINFO */
} Lapack_dgbsv_rettypeboxed;
DLLExport
Lapack_dgbsv_rettypeboxed boxptr_Lapack_dgbsv(threadData_t *threadData, modelica_metatype _inN, modelica_metatype _inKL, modelica_metatype _inKU, modelica_metatype _inNRHS, modelica_metatype _inAB, modelica_metatype _inLDAB, modelica_metatype _inB, modelica_metatype _inLDB);

extern void LapackImpl__dgbsv(int /*_inN*/, int /*_inKL*/, int /*_inKU*/, int /*_inNRHS*/, modelica_metatype /*_inAB*/, int /*_inLDAB*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype* /*_outAB*/, modelica_metatype* /*_outIPIV*/, modelica_metatype* /*_outB*/, int* /*_outINFO*/);
typedef struct Lapack_dgesvd_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outS */
  modelica_metatype c3; /* outU */
  modelica_metatype c4; /* outVT */
  modelica_metatype c5; /* outWORK */
  modelica_integer c6; /* outINFO */
} Lapack_dgesvd_rettype;
DLLExport
Lapack_dgesvd_rettype omc_Lapack_dgesvd(threadData_t *threadData, modelica_metatype _inJOBU, modelica_metatype _inJOBVT, modelica_integer _inM, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA, modelica_integer _inLDU, modelica_integer _inLDVT, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgesvd_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outS */
  modelica_metatype c3; /* outU */
  modelica_metatype c4; /* outVT */
  modelica_metatype c5; /* outWORK */
  modelica_metatype c6; /* outINFO */
} Lapack_dgesvd_rettypeboxed;
DLLExport
Lapack_dgesvd_rettypeboxed boxptr_Lapack_dgesvd(threadData_t *threadData, modelica_metatype _inJOBU, modelica_metatype _inJOBVT, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inLDU, modelica_metatype _inLDVT, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgesvd(const char* /*_inJOBU*/, const char* /*_inJOBVT*/, int /*_inM*/, int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, int /*_inLDU*/, int /*_inLDVT*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outS*/, modelica_metatype* /*_outU*/, modelica_metatype* /*_outVT*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgetrf_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outIPIV */
  modelica_integer c3; /* outINFO */
} Lapack_dgetrf_rettype;
DLLExport
Lapack_dgetrf_rettype omc_Lapack_dgetrf(threadData_t *threadData, modelica_integer _inM, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA);
typedef struct Lapack_dgetrf_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outIPIV */
  modelica_metatype c3; /* outINFO */
} Lapack_dgetrf_rettypeboxed;
DLLExport
Lapack_dgetrf_rettypeboxed boxptr_Lapack_dgetrf(threadData_t *threadData, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA);

extern void LapackImpl__dgetrf(int /*_inM*/, int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outIPIV*/, int* /*_outINFO*/);
typedef struct Lapack_dgetrs_rettype_s {
  modelica_metatype c1; /* outB */
  modelica_integer c2; /* outINFO */
} Lapack_dgetrs_rettype;
DLLExport
Lapack_dgetrs_rettype omc_Lapack_dgetrs(threadData_t *threadData, modelica_metatype _inTRANS, modelica_integer _inN, modelica_integer _inNRHS, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inIPIV, modelica_metatype _inB, modelica_integer _inLDB);
typedef struct Lapack_dgetrs_rettypeboxed_s {
  modelica_metatype c1; /* outB */
  modelica_metatype c2; /* outINFO */
} Lapack_dgetrs_rettypeboxed;
DLLExport
Lapack_dgetrs_rettypeboxed boxptr_Lapack_dgetrs(threadData_t *threadData, modelica_metatype _inTRANS, modelica_metatype _inN, modelica_metatype _inNRHS, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inIPIV, modelica_metatype _inB, modelica_metatype _inLDB);

extern void LapackImpl__dgetrs(const char* /*_inTRANS*/, int /*_inN*/, int /*_inNRHS*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inIPIV*/, modelica_metatype /*_inB*/, int /*_inLDB*/, modelica_metatype* /*_outB*/, int* /*_outINFO*/);
typedef struct Lapack_dgetri_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWORK */
  modelica_integer c3; /* outINFO */
} Lapack_dgetri_rettype;
DLLExport
Lapack_dgetri_rettype omc_Lapack_dgetri(threadData_t *threadData, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inIPIV, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dgetri_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWORK */
  modelica_metatype c3; /* outINFO */
} Lapack_dgetri_rettypeboxed;
DLLExport
Lapack_dgetri_rettypeboxed boxptr_Lapack_dgetri(threadData_t *threadData, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inIPIV, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dgetri(int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inIPIV*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);
typedef struct Lapack_dgeqpf_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outJPVT */
  modelica_metatype c3; /* outTAU */
  modelica_integer c4; /* outINFO */
} Lapack_dgeqpf_rettype;
DLLExport
Lapack_dgeqpf_rettype omc_Lapack_dgeqpf(threadData_t *threadData, modelica_integer _inM, modelica_integer _inN, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inJPVT, modelica_metatype _inWORK);
typedef struct Lapack_dgeqpf_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outJPVT */
  modelica_metatype c3; /* outTAU */
  modelica_metatype c4; /* outINFO */
} Lapack_dgeqpf_rettypeboxed;
DLLExport
Lapack_dgeqpf_rettypeboxed boxptr_Lapack_dgeqpf(threadData_t *threadData, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inJPVT, modelica_metatype _inWORK);

extern void LapackImpl__dgeqpf(int /*_inM*/, int /*_inN*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inJPVT*/, modelica_metatype /*_inWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outJPVT*/, modelica_metatype* /*_outTAU*/, int* /*_outINFO*/);
typedef struct Lapack_dorgqr_rettype_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWORK */
  modelica_integer c3; /* outINFO */
} Lapack_dorgqr_rettype;
DLLExport
Lapack_dorgqr_rettype omc_Lapack_dorgqr(threadData_t *threadData, modelica_integer _inM, modelica_integer _inN, modelica_integer _inK, modelica_metatype _inA, modelica_integer _inLDA, modelica_metatype _inTAU, modelica_metatype _inWORK, modelica_integer _inLWORK);
typedef struct Lapack_dorgqr_rettypeboxed_s {
  modelica_metatype c1; /* outA */
  modelica_metatype c2; /* outWORK */
  modelica_metatype c3; /* outINFO */
} Lapack_dorgqr_rettypeboxed;
DLLExport
Lapack_dorgqr_rettypeboxed boxptr_Lapack_dorgqr(threadData_t *threadData, modelica_metatype _inM, modelica_metatype _inN, modelica_metatype _inK, modelica_metatype _inA, modelica_metatype _inLDA, modelica_metatype _inTAU, modelica_metatype _inWORK, modelica_metatype _inLWORK);

extern void LapackImpl__dorgqr(int /*_inM*/, int /*_inN*/, int /*_inK*/, modelica_metatype /*_inA*/, int /*_inLDA*/, modelica_metatype /*_inTAU*/, modelica_metatype /*_inWORK*/, int /*_inLWORK*/, modelica_metatype* /*_outA*/, modelica_metatype* /*_outWORK*/, int* /*_outINFO*/);

#ifdef __cplusplus
}
#endif
#endif

