#ifndef NFSCodeCheck__H
#define NFSCodeCheck__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Absyn_Path_IDENT__desc;
extern struct record_description Error_Message_MESSAGE__desc;
extern struct record_description Error_MessageType_TRANSLATION__desc;
extern struct record_description Error_Severity_ERROR__desc;
extern struct record_description Error_Severity_NOTIFICATION__desc;
extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;
extern struct record_description Util_TranslatableContent_gettext__desc;

DLLExport
void omc_NFSCodeCheck_checkRecursiveShortDefinition(threadData_t *threadData, modelica_metatype _inTypeSpec, modelica_metatype _inTypeName, modelica_metatype _inTypeEnv, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkRecursiveShortDefinition omc_NFSCodeCheck_checkRecursiveShortDefinition

typedef struct NFSCodeCheck_isSelfReference_rettype_s {
  modelica_boolean c1; /* selfRef */
} NFSCodeCheck_isSelfReference_rettype;
DLLExport
NFSCodeCheck_isSelfReference_rettype omc_NFSCodeCheck_isSelfReference(threadData_t *threadData, modelica_metatype _inTypeName, modelica_metatype _inTypePath, modelica_metatype _inReferencedName);
typedef struct NFSCodeCheck_isSelfReference_rettypeboxed_s {
  modelica_metatype c1; /* selfRef */
} NFSCodeCheck_isSelfReference_rettypeboxed;
DLLExport
NFSCodeCheck_isSelfReference_rettypeboxed boxptr_NFSCodeCheck_isSelfReference(threadData_t *threadData, modelica_metatype _inTypeName, modelica_metatype _inTypePath, modelica_metatype _inReferencedName);

DLLExport
void omc_NFSCodeCheck_checkClassExtendsReplaceability(threadData_t *threadData, modelica_metatype _inBaseClass, modelica_metatype _inOriginInfo);
#define boxptr_NFSCodeCheck_checkClassExtendsReplaceability omc_NFSCodeCheck_checkClassExtendsReplaceability


DLLExport
void omc_NFSCodeCheck_checkRedeclareModifier(threadData_t *threadData, modelica_metatype _inModifier, modelica_metatype _inBaseClass, modelica_metatype _inEnv);
#define boxptr_NFSCodeCheck_checkRedeclareModifier omc_NFSCodeCheck_checkRedeclareModifier


DLLExport
void omc_NFSCodeCheck_checkRedeclareModifier2(threadData_t *threadData, modelica_metatype _inModifier, modelica_metatype _inBaseClass, modelica_metatype _inEnv);
#define boxptr_NFSCodeCheck_checkRedeclareModifier2 omc_NFSCodeCheck_checkRedeclareModifier2


DLLExport
void omc_NFSCodeCheck_checkModifierIfRedeclare(threadData_t *threadData, modelica_metatype _inItem, modelica_metatype _inModifier, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkModifierIfRedeclare omc_NFSCodeCheck_checkModifierIfRedeclare


DLLExport
void omc_NFSCodeCheck_checkRedeclaredElementPrefix(threadData_t *threadData, modelica_metatype _inItem, modelica_metatype _inReplacement, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkRedeclaredElementPrefix omc_NFSCodeCheck_checkRedeclaredElementPrefix


DLLExport
void omc_NFSCodeCheck_checkRedeclarationReplaceable(threadData_t *threadData, modelica_metatype _inName, modelica_metatype _inType, modelica_metatype _inReplaceable, modelica_metatype _inOriginInfo, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkRedeclarationReplaceable omc_NFSCodeCheck_checkRedeclarationReplaceable


DLLExport
void omc_NFSCodeCheck_checkRedeclarationFinal(threadData_t *threadData, modelica_metatype _inName, modelica_metatype _inType, modelica_metatype _inFinal, modelica_metatype _inOriginInfo, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkRedeclarationFinal omc_NFSCodeCheck_checkRedeclarationFinal


DLLExport
void omc_NFSCodeCheck_checkRedeclarationVariability(threadData_t *threadData, modelica_metatype _inName, modelica_metatype _inType, modelica_metatype _inVariability, modelica_metatype _inOriginInfo, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkRedeclarationVariability omc_NFSCodeCheck_checkRedeclarationVariability


DLLExport
void omc_NFSCodeCheck_checkRedeclarationVisibility(threadData_t *threadData, modelica_metatype _inName, modelica_metatype _inType, modelica_metatype _inOriginalVisibility, modelica_metatype _inNewVisibility, modelica_metatype _inOriginInfo, modelica_metatype _inNewInfo);
#define boxptr_NFSCodeCheck_checkRedeclarationVisibility omc_NFSCodeCheck_checkRedeclarationVisibility


DLLExport
void omc_NFSCodeCheck_checkValidEnumLiteral(threadData_t *threadData, modelica_metatype _inLiteral, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkValidEnumLiteral omc_NFSCodeCheck_checkValidEnumLiteral


DLLExport
void omc_NFSCodeCheck_checkDuplicateRedeclarations(threadData_t *threadData, modelica_metatype _inRedeclare, modelica_metatype _inRedeclarations);
#define boxptr_NFSCodeCheck_checkDuplicateRedeclarations omc_NFSCodeCheck_checkDuplicateRedeclarations

typedef struct NFSCodeCheck_checkDuplicateRedeclarations2_rettype_s {
  modelica_boolean c1; /* outIsDuplicate */
} NFSCodeCheck_checkDuplicateRedeclarations2_rettype;
DLLExport
NFSCodeCheck_checkDuplicateRedeclarations2_rettype omc_NFSCodeCheck_checkDuplicateRedeclarations2(threadData_t *threadData, modelica_metatype _inRedeclareName, modelica_metatype _inRedeclareInfo, modelica_metatype _inRedeclarations);
typedef struct NFSCodeCheck_checkDuplicateRedeclarations2_rettypeboxed_s {
  modelica_metatype c1; /* outIsDuplicate */
} NFSCodeCheck_checkDuplicateRedeclarations2_rettypeboxed;
DLLExport
NFSCodeCheck_checkDuplicateRedeclarations2_rettypeboxed boxptr_NFSCodeCheck_checkDuplicateRedeclarations2(threadData_t *threadData, modelica_metatype _inRedeclareName, modelica_metatype _inRedeclareInfo, modelica_metatype _inRedeclarations);

DLLExport
void omc_NFSCodeCheck_checkRecursiveComponentDeclaration(threadData_t *threadData, modelica_metatype _inComponentName, modelica_metatype _inComponentInfo, modelica_metatype _inTypeEnv, modelica_metatype _inTypeItem, modelica_metatype _inComponentEnv);
#define boxptr_NFSCodeCheck_checkRecursiveComponentDeclaration omc_NFSCodeCheck_checkRecursiveComponentDeclaration

typedef struct NFSCodeCheck_checkIdentNotEqTypeName_rettype_s {
  modelica_boolean c1; /* outIsNotEq */
} NFSCodeCheck_checkIdentNotEqTypeName_rettype;
DLLExport
NFSCodeCheck_checkIdentNotEqTypeName_rettype omc_NFSCodeCheck_checkIdentNotEqTypeName(threadData_t *threadData, modelica_metatype _inIdent, modelica_metatype _inTypeName, modelica_metatype _inInfo);
typedef struct NFSCodeCheck_checkIdentNotEqTypeName_rettypeboxed_s {
  modelica_metatype c1; /* outIsNotEq */
} NFSCodeCheck_checkIdentNotEqTypeName_rettypeboxed;
DLLExport
NFSCodeCheck_checkIdentNotEqTypeName_rettypeboxed boxptr_NFSCodeCheck_checkIdentNotEqTypeName(threadData_t *threadData, modelica_metatype _inIdent, modelica_metatype _inTypeName, modelica_metatype _inInfo);

DLLExport
void omc_NFSCodeCheck_checkComponentsEqual(threadData_t *threadData, modelica_metatype _inComponent1, modelica_metatype _inComponent2);
#define boxptr_NFSCodeCheck_checkComponentsEqual omc_NFSCodeCheck_checkComponentsEqual


DLLExport
void omc_NFSCodeCheck_checkInstanceRestriction(threadData_t *threadData, modelica_metatype _inItem, modelica_metatype _inPrefix, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkInstanceRestriction omc_NFSCodeCheck_checkInstanceRestriction

typedef struct NFSCodeCheck_isInstantiableClassRestriction_rettype_s {
  modelica_boolean c1; /* outIsInstantiable */
} NFSCodeCheck_isInstantiableClassRestriction_rettype;
DLLExport
NFSCodeCheck_isInstantiableClassRestriction_rettype omc_NFSCodeCheck_isInstantiableClassRestriction(threadData_t *threadData, modelica_metatype _inRestriction);
typedef struct NFSCodeCheck_isInstantiableClassRestriction_rettypeboxed_s {
  modelica_metatype c1; /* outIsInstantiable */
} NFSCodeCheck_isInstantiableClassRestriction_rettypeboxed;
DLLExport
NFSCodeCheck_isInstantiableClassRestriction_rettypeboxed boxptr_NFSCodeCheck_isInstantiableClassRestriction(threadData_t *threadData, modelica_metatype _inRestriction);

DLLExport
void omc_NFSCodeCheck_checkPartialInstance(threadData_t *threadData, modelica_metatype _inItem, modelica_metatype _inInfo);
#define boxptr_NFSCodeCheck_checkPartialInstance omc_NFSCodeCheck_checkPartialInstance
#ifdef __cplusplus
extern "C" {
#endif
#include "Absyn.h"
#include "Debug.h"
#include "Dump.h"
#include "Error.h"
#include "Flags.h"
#include "NFInstDump.h"
#include "NFSCodeCheck.h"
#include "NFSCodeEnv.h"
#include "SCode.h"
#include "SCodeDump.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

