#ifndef OpenTURNS__H
#define OpenTURNS__H
#define __OPENMODELICA__METAMODELICA
#include "meta_modelica.h"

#include "modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description Absyn_FunctionArgs_FUNCTIONARGS__desc;
extern struct record_description Absyn_Program_PROGRAM__desc;
extern struct record_description Absyn_TimeStamp_TIMESTAMP__desc;
extern struct record_description Absyn_Within_TOP__desc;
extern struct record_description AbsynDep_AvlTree_AVLTREENODE__desc;
extern struct record_description AbsynDep_Depends_DEPENDS__desc;
extern struct record_description BackendDAE_BackendDAE_DAE__desc;
extern struct record_description BackendDAE_EqSystem_EQSYSTEM__desc;
extern struct record_description BackendDAE_Matching_NO__MATCHING__desc;
extern struct record_description DAE_Algorithm_ALGORITHM__STMTS__desc;
extern struct record_description DAE_Distribution_DISTRIBUTION__desc;
extern struct record_description GlobalScript_SymbolTable_SYMBOLTABLE__desc;
typedef struct OpenTURNS_generateOpenTURNSInterface_rettype_s {
  modelica_metatype c1; /* scriptFile */
} OpenTURNS_generateOpenTURNSInterface_rettype;
DLLExport
OpenTURNS_generateOpenTURNSInterface_rettype omc_OpenTURNS_generateOpenTURNSInterface(threadData_t *threadData, modelica_metatype _cache, modelica_metatype _env, modelica_metatype _inDaelow, modelica_metatype _inFunctionTree, modelica_metatype _inPath, modelica_metatype _inProgram, modelica_metatype _inDAElist, modelica_metatype _templateFile);
#define boxptr_OpenTURNS_generateOpenTURNSInterface omc_OpenTURNS_generateOpenTURNSInterface


DLLExport
void omc_OpenTURNS_generateWrapperLibrary(threadData_t *threadData, modelica_metatype _fullClassName, modelica_metatype _lastClassName);
#define boxptr_OpenTURNS_generateWrapperLibrary omc_OpenTURNS_generateWrapperLibrary


DLLExport
void omc_OpenTURNS_generateXMLFile(threadData_t *threadData, modelica_metatype _className, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateXMLFile omc_OpenTURNS_generateXMLFile

typedef struct OpenTURNS_generateXMLFileContent_rettype_s {
  modelica_metatype c1; /* content */
} OpenTURNS_generateXMLFileContent_rettype;
DLLExport
OpenTURNS_generateXMLFileContent_rettype omc_OpenTURNS_generateXMLFileContent(threadData_t *threadData, modelica_metatype _className, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateXMLFileContent omc_OpenTURNS_generateXMLFileContent

typedef struct OpenTURNS_generateXMLHeader_rettype_s {
  modelica_metatype c1; /* header */
} OpenTURNS_generateXMLHeader_rettype;
DLLExport
OpenTURNS_generateXMLHeader_rettype omc_OpenTURNS_generateXMLHeader(threadData_t *threadData, modelica_metatype _className);
#define boxptr_OpenTURNS_generateXMLHeader omc_OpenTURNS_generateXMLHeader

typedef struct OpenTURNS_generateXMLExternalCode_rettype_s {
  modelica_metatype c1; /* content */
} OpenTURNS_generateXMLExternalCode_rettype;
DLLExport
OpenTURNS_generateXMLExternalCode_rettype omc_OpenTURNS_generateXMLExternalCode(threadData_t *threadData, modelica_metatype _className, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateXMLExternalCode omc_OpenTURNS_generateXMLExternalCode

typedef struct OpenTURNS_generateXMLLibrary_rettype_s {
  modelica_metatype c1; /* content */
} OpenTURNS_generateXMLLibrary_rettype;
DLLExport
OpenTURNS_generateXMLLibrary_rettype omc_OpenTURNS_generateXMLLibrary(threadData_t *threadData, modelica_metatype _className, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateXMLLibrary omc_OpenTURNS_generateXMLLibrary

typedef struct OpenTURNS_generateXMLLibraryInputs_rettype_s {
  modelica_metatype c1; /* strLst */
} OpenTURNS_generateXMLLibraryInputs_rettype;
DLLExport
OpenTURNS_generateXMLLibraryInputs_rettype omc_OpenTURNS_generateXMLLibraryInputs(threadData_t *threadData, modelica_metatype _varLst);
#define boxptr_OpenTURNS_generateXMLLibraryInputs omc_OpenTURNS_generateXMLLibraryInputs

typedef struct OpenTURNS_generateXMLLibraryOutputs_rettype_s {
  modelica_metatype c1; /* strLst */
} OpenTURNS_generateXMLLibraryOutputs_rettype;
DLLExport
OpenTURNS_generateXMLLibraryOutputs_rettype omc_OpenTURNS_generateXMLLibraryOutputs(threadData_t *threadData, modelica_metatype _varLst);
#define boxptr_OpenTURNS_generateXMLLibraryOutputs omc_OpenTURNS_generateXMLLibraryOutputs

typedef struct OpenTURNS_generatePythonScript_rettype_s {
  modelica_metatype c1; /* pythonFileName */
} OpenTURNS_generatePythonScript_rettype;
DLLExport
OpenTURNS_generatePythonScript_rettype omc_OpenTURNS_generatePythonScript(threadData_t *threadData, modelica_metatype _inModelPath, modelica_metatype _templateFile, modelica_metatype _dae, modelica_metatype _inDaelow);
#define boxptr_OpenTURNS_generatePythonScript omc_OpenTURNS_generatePythonScript

typedef struct OpenTURNS_generateDistributions_rettype_s {
  modelica_metatype c1; /* distributions */
  modelica_metatype c2; /* distributionVarLst */
} OpenTURNS_generateDistributions_rettype;
DLLExport
OpenTURNS_generateDistributions_rettype omc_OpenTURNS_generateDistributions(threadData_t *threadData, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateDistributions omc_OpenTURNS_generateDistributions

typedef struct OpenTURNS_generateDistributionVariable_rettype_s {
  modelica_metatype c1; /* str */
  modelica_metatype c2; /* distributionVar */
} OpenTURNS_generateDistributionVariable_rettype;
DLLExport
OpenTURNS_generateDistributionVariable_rettype omc_OpenTURNS_generateDistributionVariable(threadData_t *threadData, modelica_metatype _tpl, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateDistributionVariable omc_OpenTURNS_generateDistributionVariable

typedef struct OpenTURNS_generateCorrelationMatrix_rettype_s {
  modelica_metatype c1; /* correlationMatrix */
} OpenTURNS_generateCorrelationMatrix_rettype;
DLLExport
OpenTURNS_generateCorrelationMatrix_rettype omc_OpenTURNS_generateCorrelationMatrix(threadData_t *threadData, modelica_metatype _dae, modelica_integer _numDists, modelica_metatype _uncertainVars);
typedef struct OpenTURNS_generateCorrelationMatrix_rettypeboxed_s {
  modelica_metatype c1; /* correlationMatrix */
} OpenTURNS_generateCorrelationMatrix_rettypeboxed;
DLLExport
OpenTURNS_generateCorrelationMatrix_rettypeboxed boxptr_OpenTURNS_generateCorrelationMatrix(threadData_t *threadData, modelica_metatype _dae, modelica_metatype _numDists, modelica_metatype _uncertainVars);
typedef struct OpenTURNS_stripCorrelationFromDae_rettype_s {
  modelica_metatype c1; /* strippedDae */
} OpenTURNS_stripCorrelationFromDae_rettype;
DLLExport
OpenTURNS_stripCorrelationFromDae_rettype omc_OpenTURNS_stripCorrelationFromDae(threadData_t *threadData, modelica_metatype _dae);
#define boxptr_OpenTURNS_stripCorrelationFromDae omc_OpenTURNS_stripCorrelationFromDae

typedef struct OpenTURNS_eqnSystemNotZero_rettype_s {
  modelica_boolean c1; /* notZero */
} OpenTURNS_eqnSystemNotZero_rettype;
DLLExport
OpenTURNS_eqnSystemNotZero_rettype omc_OpenTURNS_eqnSystemNotZero(threadData_t *threadData, modelica_metatype _eqs);
typedef struct OpenTURNS_eqnSystemNotZero_rettypeboxed_s {
  modelica_metatype c1; /* notZero */
} OpenTURNS_eqnSystemNotZero_rettypeboxed;
DLLExport
OpenTURNS_eqnSystemNotZero_rettypeboxed boxptr_OpenTURNS_eqnSystemNotZero(threadData_t *threadData, modelica_metatype _eqs);
typedef struct OpenTURNS_stripCorrelationVarsAndEqns_rettype_s {
  modelica_metatype c1; /* outEqsys */
} OpenTURNS_stripCorrelationVarsAndEqns_rettype;
DLLExport
OpenTURNS_stripCorrelationVarsAndEqns_rettype omc_OpenTURNS_stripCorrelationVarsAndEqns(threadData_t *threadData, modelica_metatype _eqsys);
#define boxptr_OpenTURNS_stripCorrelationVarsAndEqns omc_OpenTURNS_stripCorrelationVarsAndEqns

typedef struct OpenTURNS_stripCorrelationEqns_rettype_s {
  modelica_metatype c1; /* outEqns */
} OpenTURNS_stripCorrelationEqns_rettype;
DLLExport
OpenTURNS_stripCorrelationEqns_rettype omc_OpenTURNS_stripCorrelationEqns(threadData_t *threadData, modelica_metatype _eqns);
#define boxptr_OpenTURNS_stripCorrelationEqns omc_OpenTURNS_stripCorrelationEqns

typedef struct OpenTURNS_equationIsCorrelationBinding_rettype_s {
  modelica_boolean c1; /* res */
} OpenTURNS_equationIsCorrelationBinding_rettype;
DLLExport
OpenTURNS_equationIsCorrelationBinding_rettype omc_OpenTURNS_equationIsCorrelationBinding(threadData_t *threadData, modelica_metatype _eqn);
typedef struct OpenTURNS_equationIsCorrelationBinding_rettypeboxed_s {
  modelica_metatype c1; /* res */
} OpenTURNS_equationIsCorrelationBinding_rettypeboxed;
DLLExport
OpenTURNS_equationIsCorrelationBinding_rettypeboxed boxptr_OpenTURNS_equationIsCorrelationBinding(threadData_t *threadData, modelica_metatype _eqn);
typedef struct OpenTURNS_stripCorrelationVars_rettype_s {
  modelica_metatype c1; /* outVars */
} OpenTURNS_stripCorrelationVars_rettype;
DLLExport
OpenTURNS_stripCorrelationVars_rettype omc_OpenTURNS_stripCorrelationVars(threadData_t *threadData, modelica_metatype _vars);
#define boxptr_OpenTURNS_stripCorrelationVars omc_OpenTURNS_stripCorrelationVars

typedef struct OpenTURNS_isCorrelationVar_rettype_s {
  modelica_boolean c1; /* res */
} OpenTURNS_isCorrelationVar_rettype;
DLLExport
OpenTURNS_isCorrelationVar_rettype omc_OpenTURNS_isCorrelationVar(threadData_t *threadData, modelica_metatype _var);
typedef struct OpenTURNS_isCorrelationVar_rettypeboxed_s {
  modelica_metatype c1; /* res */
} OpenTURNS_isCorrelationVar_rettypeboxed;
DLLExport
OpenTURNS_isCorrelationVar_rettypeboxed boxptr_OpenTURNS_isCorrelationVar(threadData_t *threadData, modelica_metatype _var);
typedef struct OpenTURNS_isCorrelationVarCref_rettype_s {
  modelica_boolean c1; /* res */
} OpenTURNS_isCorrelationVarCref_rettype;
DLLExport
OpenTURNS_isCorrelationVarCref_rettype omc_OpenTURNS_isCorrelationVarCref(threadData_t *threadData, modelica_metatype _cr);
typedef struct OpenTURNS_isCorrelationVarCref_rettypeboxed_s {
  modelica_metatype c1; /* res */
} OpenTURNS_isCorrelationVarCref_rettypeboxed;
DLLExport
OpenTURNS_isCorrelationVarCref_rettypeboxed boxptr_OpenTURNS_isCorrelationVarCref(threadData_t *threadData, modelica_metatype _cr);
typedef struct OpenTURNS_hasCorrelationStatement_rettype_s {
  modelica_boolean c1; /* res */
} OpenTURNS_hasCorrelationStatement_rettype;
DLLExport
OpenTURNS_hasCorrelationStatement_rettype omc_OpenTURNS_hasCorrelationStatement(threadData_t *threadData, modelica_metatype _alg);
typedef struct OpenTURNS_hasCorrelationStatement_rettypeboxed_s {
  modelica_metatype c1; /* res */
} OpenTURNS_hasCorrelationStatement_rettypeboxed;
DLLExport
OpenTURNS_hasCorrelationStatement_rettypeboxed boxptr_OpenTURNS_hasCorrelationStatement(threadData_t *threadData, modelica_metatype _alg);
typedef struct OpenTURNS_getCorrelationExp_rettype_s {
  modelica_metatype c1; /* res */
} OpenTURNS_getCorrelationExp_rettype;
DLLExport
OpenTURNS_getCorrelationExp_rettype omc_OpenTURNS_getCorrelationExp(threadData_t *threadData, modelica_metatype _alg);
#define boxptr_OpenTURNS_getCorrelationExp omc_OpenTURNS_getCorrelationExp

typedef struct OpenTURNS_generateCorrelationMatrix2_rettype_s {
  modelica_metatype c1; /* str */
} OpenTURNS_generateCorrelationMatrix2_rettype;
DLLExport
OpenTURNS_generateCorrelationMatrix2_rettype omc_OpenTURNS_generateCorrelationMatrix2(threadData_t *threadData, modelica_metatype _correlationAlg, modelica_metatype _uncertainVars);
#define boxptr_OpenTURNS_generateCorrelationMatrix2 omc_OpenTURNS_generateCorrelationMatrix2

typedef struct OpenTURNS_generateCorrelationMatrix3_rettype_s {
  modelica_metatype c1; /* str */
} OpenTURNS_generateCorrelationMatrix3_rettype;
DLLExport
OpenTURNS_generateCorrelationMatrix3_rettype omc_OpenTURNS_generateCorrelationMatrix3(threadData_t *threadData, modelica_metatype _exp, modelica_metatype _uncertainVars);
#define boxptr_OpenTURNS_generateCorrelationMatrix3 omc_OpenTURNS_generateCorrelationMatrix3

typedef struct OpenTURNS_generateCollectionDistributions_rettype_s {
  modelica_metatype c1; /* collectionDistributions */
} OpenTURNS_generateCollectionDistributions_rettype;
DLLExport
OpenTURNS_generateCollectionDistributions_rettype omc_OpenTURNS_generateCollectionDistributions(threadData_t *threadData, modelica_metatype _dae, modelica_metatype _distributionVarLst);
#define boxptr_OpenTURNS_generateCollectionDistributions omc_OpenTURNS_generateCollectionDistributions

typedef struct OpenTURNS_getName_rettype_s {
  modelica_metatype c1; /* outStr */
} OpenTURNS_getName_rettype;
DLLExport
OpenTURNS_getName_rettype omc_OpenTURNS_getName(threadData_t *threadData, modelica_metatype _distVarTpl);
#define boxptr_OpenTURNS_getName omc_OpenTURNS_getName

typedef struct OpenTURNS_generateCollectionDistributions2_rettype_s {
  modelica_metatype c1; /* str */
} OpenTURNS_generateCollectionDistributions2_rettype;
DLLExport
OpenTURNS_generateCollectionDistributions2_rettype omc_OpenTURNS_generateCollectionDistributions2(threadData_t *threadData, modelica_metatype _distVarTpl, modelica_metatype _tpl);
#define boxptr_OpenTURNS_generateCollectionDistributions2 omc_OpenTURNS_generateCollectionDistributions2

typedef struct OpenTURNS_generateInputDescriptions_rettype_s {
  modelica_metatype c1; /* inputDescriptions */
} OpenTURNS_generateInputDescriptions_rettype;
DLLExport
OpenTURNS_generateInputDescriptions_rettype omc_OpenTURNS_generateInputDescriptions(threadData_t *threadData, modelica_metatype _dae);
#define boxptr_OpenTURNS_generateInputDescriptions omc_OpenTURNS_generateInputDescriptions

typedef struct OpenTURNS_getFullSharePath_rettype_s {
  modelica_metatype c1; /* strFullSharePath */
} OpenTURNS_getFullSharePath_rettype;
DLLExport
OpenTURNS_getFullSharePath_rettype omc_OpenTURNS_getFullSharePath(threadData_t *threadData);
#define boxptr_OpenTURNS_getFullSharePath omc_OpenTURNS_getFullSharePath

typedef struct OpenTURNS_getFullShareFileName_rettype_s {
  modelica_metatype c1; /* strFullShareFileName */
} OpenTURNS_getFullShareFileName_rettype;
DLLExport
OpenTURNS_getFullShareFileName_rettype omc_OpenTURNS_getFullShareFileName(threadData_t *threadData, modelica_metatype _strFileName);
#define boxptr_OpenTURNS_getFullShareFileName omc_OpenTURNS_getFullShareFileName

typedef struct OpenTURNS_runPythonScript_rettype_s {
  modelica_metatype c1; /* outStrLogFile */
} OpenTURNS_runPythonScript_rettype;
DLLExport
OpenTURNS_runPythonScript_rettype omc_OpenTURNS_runPythonScript(threadData_t *threadData, modelica_metatype _inStrPythonScriptFile);
#define boxptr_OpenTURNS_runPythonScript omc_OpenTURNS_runPythonScript


DLLExport
void omc_OpenTURNS_runCommand(threadData_t *threadData, modelica_metatype _cmd);
#define boxptr_OpenTURNS_runCommand omc_OpenTURNS_runCommand
#ifdef __cplusplus
extern "C" {
#endif
#include "Absyn.h"
#include "BackendDAEOptimize.h"
#include "BackendDAEUtil.h"
#include "BackendEquation.h"
#include "BackendVariable.h"
#include "CevalScript.h"
#include "ComponentReference.h"
#include "Expression.h"
#include "ExpressionDump.h"
#include "Interactive.h"
#include "List.h"
#include "OpenTURNS.h"
#include "Settings.h"
#include "SimCodeMain.h"
#include "System.h"
#include "Util.h"
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
}
#endif
#endif

