// $Id: NewProjectBaseForm.cpp 15963 2013-05-02 19:17:13Z sjoelund.se $
/**
 * This file is part of OpenModelica.
 *
 * Copyright (c) 1998-CurrentYear, Open Source Modelica Consortium (OSMC),
 * c/o Linköpings universitet, Department of Computer and Information Science,
 * SE-58183 Linköping, Sweden.
 *
 * All rights reserved.
 *
 * THIS PROGRAM IS PROVIDED UNDER THE TERMS OF GPL VERSION 3 LICENSE OR 
 * THIS OSMC PUBLIC LICENSE (OSMC-PL). 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE
 * OF THE OSMC PUBLIC LICENSE OR THE GPL VERSION 3, ACCORDING TO RECIPIENTS CHOICE. 
 *
 * The OpenModelica software and the Open Source Modelica
 * Consortium (OSMC) Public License (OSMC-PL) are obtained
 * from OSMC, either from the above address,
 * from the URLs: http://www.ida.liu.se/projects/OpenModelica or  
 * http://www.openmodelica.org, and in the OpenModelica distribution. 
 * GNU version 3 is obtained from: http://www.gnu.org/copyleft/gpl.html.
 *
 * This program is distributed WITHOUT ANY WARRANTY; without
 * even the implied warranty of  MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE, EXCEPT AS EXPRESSLY SET FORTH
 * IN THE BY RECIPIENT SELECTED SUBSIDIARY LICENSE CONDITIONS OF OSMC-PL.
 *
 * See the full OSMC Public License conditions for more details.
 *
 * Main contributor 2010, Hubert Thierot, CEP - ARMINES (France)
 * Main contributor 2010, Hubert Thierot, CEP - ARMINES (France)

     @file NewProjectBaseForm.cpp
     @brief Comments for file documentation.
     @author Hubert Thieriot, hubert.thieriot@mines-paristech.fr
     Company : CEP - ARMINES (France)
     http://www-cep.ensmp.fr/english/
     @version 
*/

#include "NewProjectBaseForm.h"
#include "ui_NewProjectBaseForm.h"
#include <QtGui/QErrorMessage>


NewProjectBaseForm::NewProjectBaseForm(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::NewProjectBaseFormClass)
{
    m_ui->setupUi(this);
    
    connect(m_ui->pushCancel, SIGNAL(clicked()), this, SLOT(reject()));
    connect(m_ui->pushOk, SIGNAL(clicked()), this, SLOT(validate()));
}

NewProjectBaseForm::~NewProjectBaseForm()
{
    delete m_ui;
}


void NewProjectBaseForm::validate()
{
    if(!m_ui->lineProjectName->text().isEmpty())
    {
        projectName=m_ui->lineProjectName->text();

        accept();
    }
    else
    {
         QErrorMessage *errorMessageDialog = new QErrorMessage(this);
         errorMessageDialog->showMessage("Incorrect name");
    }

}


void NewProjectBaseForm::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

